﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;
using UnityEngine.Events;

namespace CarMod
{
    public class CarMod
    {
        public static string tag = " -CM";
        public static void Main()
        {
            ModAPI.Register(
                new Modification
                {
                    OriginalItem = ModAPI.FindSpawnable("Car"),
                    NameOverride = "Audi A4" + tag,
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "Car produced since 1994 by the German car manufacturer Audi, a subsidiary of the Volkswagen Group.",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/Cars/Audi A4/Thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Transform body = Instance.transform.GetChild(0);
                        BoxCollider2D[] boxColliders = body.GetComponents<BoxCollider2D>();
                        boxColliders[0].offset = new Vector2(0.0003607571f, -0.6723801f);
                        boxColliders[0].size = new Vector2(0.7148612f, 0.342592f);
                        boxColliders[1].offset = new Vector2(-0.3000616f, 0.09522128f);
                        boxColliders[1].size = new Vector2(0.1689302f, 1.26843f);
                        boxColliders[2].offset = new Vector2(-1.191312f, -0.6707045f);
                        boxColliders[2].size = new Vector2(0.6972498f, 0.3421229f);
                        boxColliders[3].offset = new Vector2(-1.631744f, 0.01107115f);
                        boxColliders[3].size = new Vector2(0.2636082f, 1.152815f);
                        body.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(3.060745f, -0.9329169f),
                            new Vector2(3.528571f, -0.8354951f),
                            new Vector2(3.337887f, -0.0630527f),
                            new Vector2(1.614175f, 0.1910262f),
                            new Vector2(0.8274078f, 0.7162807f),
                            new Vector2(0.1718019f, 0.9288237f),
                            new Vector2(-1.311635f, 0.9285715f),
                            new Vector2(-2.571465f, 0.3875467f),
                            new Vector2(-2.570911f, -0.1323804f),
                            new Vector2(-3.413413f, -0.1402977f),
                            new Vector2(-3.415922f, -0.7100658f),
                            new Vector2(-2.750413f, -0.9304728f)
                        });
                        body.GetComponent<PolygonCollider2D>().SetPath(1, new Vector2[]
                        {
                            new Vector2(-1.816524f, 0.1034421f),
                            new Vector2(-1.819524f, 0.2552218f),
                            new Vector2(-1.559001f, 0.7247119f),
                            new Vector2(-1.153004f, 0.8431288f),
                            new Vector2(0.111502f, 0.8465484f),
                            new Vector2(0.5939376f, 0.7035104f),
                            new Vector2(1.441056f, 0.1544568f),
                            new Vector2(1.441444f, -0.813762f),
                            new Vector2(-1.157408f, -0.8089445f)
                        });
                        body.GetChild(0).localPosition = new Vector3(0.1000073f, -0.0142924f);

                        WheelJoint2D[] wheels = body.GetComponents<WheelJoint2D>();
                        wheels[0].anchor = new Vector2(2.36f, -0.806f);
                        wheels[1].anchor = new Vector2(-2.068f, -0.806f);

                        GameObject headlight = new GameObject("Headlight");
                        headlight.transform.parent = body;
                        headlight.transform.rotation = body.rotation;
                        headlight.transform.localPosition = new Vector3(3.214f, -0.2f);
                        headlight.transform.localScale = new Vector3(1f, 1f);
                        SpriteRenderer headlightRenderer = headlight.GetOrAddComponent<SpriteRenderer>();
                        headlightRenderer.sprite = ModAPI.LoadSprite("Textures/Cars/Audi A4/Headlight.png");
                        headlightRenderer.sortingOrder = body.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        headlight.AddComponent<Optout>();
                        ModAPI.CreateLight(headlight.transform, Color.white, 3.5f, 1.5f);
                        headlight.SetActive(false);

                        GameObject taillight = new GameObject("Taillight");
                        taillight.transform.parent = body;
                        taillight.transform.rotation = body.rotation;
                        taillight.transform.localPosition = new Vector3(-3.257f, 0.057f);
                        taillight.transform.localScale = new Vector3(1f, 1f);
                        SpriteRenderer taillightRenderer = taillight.GetOrAddComponent<SpriteRenderer>();
                        taillightRenderer.sprite = ModAPI.LoadSprite("Textures/Cars/Audi A4/Taillight.png");
                        taillightRenderer.sortingOrder = body.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        taillight.AddComponent<Optout>();
                        ModAPI.CreateLight(taillight.transform, Color.red, 3.5f, 1.5f);
                        taillight.SetActive(false);

                        Transform bonnet = Instance.transform.GetChild(3);
                        bonnet.GetComponent<HingeJoint2D>().anchor = new Vector2(-0.8157148f, 0.1143804f);
                        bonnet.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(0.5923996f, -0.01134229f),
                            new Vector2(-0.4646941f, 0.1571429f),
                            new Vector2(-0.8285714f, 0.1571429f),
                            new Vector2(-0.8285714f, 0.1023642f),
                            new Vector2(0.5709956f, -0.1571429f),
                            new Vector2(0.8285714f, -0.1571429f)
                        });

                        Transform boot = Instance.transform.GetChild(4);
                        boot.GetComponent<HingeJoint2D>().anchor = new Vector2(0.41f, 0.2f);
                        BoxCollider2D collider1 = boot.GetComponent<BoxCollider2D>();
                        collider1.offset = new Vector2(-0.3952925f, -0.1574069f);
                        collider1.size = new Vector2(0.1237006f, 0.08763137f);
                        boot.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.3127339f, 0.1679793f),
                            new Vector2(-0.3698192f, -0.258925f),
                            new Vector2(-0.3199155f, -0.2592466f),
                            new Vector2(-0.2476237f, 0.1079744f),
                            new Vector2(0.4592464f, 0.1750954f),
                            new Vector2(0.4560386f, 0.2571429f)
                        });

                        Transform frontDoor = Instance.transform.GetChild(5);
                        frontDoor.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(0.4526816f, 0.543638f),
                            new Vector2(-0.3762484f, 0.857028f),
                            new Vector2(-0.9714286f, 0.8571429f),
                            new Vector2(-0.7434942f, 0.0252445f),
                            new Vector2(-0.7440699f, -0.8571429f),
                            new Vector2(0.9714286f, -0.8571429f),
                            new Vector2(0.9737331f, 0.04973945f)
                        });

                        Transform backDoor = Instance.transform.GetChild(6);
                        backDoor.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.4491169f, 0.7937872f),
                            new Vector2(-0.7993343f, 0.2554604f),
                            new Vector2(-0.8f, 0.04698031f),
                            new Vector2(-0.1085917f, -0.8563237f),
                            new Vector2(0.8f, -0.8571429f),
                            new Vector2(0.8f, -0.1784481f),
                            new Vector2(0.5348876f, 0.8641579f)
                        });

                        body.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[]
                        {
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Audi A4/BlackColor/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Audi A4/BlackColor/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Audi A4/BlackColor/Bonnet.png"),
                                Boot = ModAPI.LoadSprite("Textures/Cars/Audi A4/BlackColor/Boot.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Audi A4/BlackColor/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/Audi A4/BlackColor/BackDoor.png")
                            },
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Audi A4/BlueColor/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Audi A4/BlueColor/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Audi A4/BlueColor/Bonnet.png"),
                                Boot = ModAPI.LoadSprite("Textures/Cars/Audi A4/BlueColor/Boot.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Audi A4/BlueColor/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/Audi A4/BlueColor/BackDoor.png")
                            },
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Audi A4/GrayColor/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Audi A4/GrayColor/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Audi A4/GrayColor/Bonnet.png"),
                                Boot = ModAPI.LoadSprite("Textures/Cars/Audi A4/GrayColor/Boot.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Audi A4/GrayColor/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/Audi A4/GrayColor/BackDoor.png")
                            },
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Audi A4/GreenColor/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Audi A4/GreenColor/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Audi A4/GreenColor/Bonnet.png"),
                                Boot = ModAPI.LoadSprite("Textures/Cars/Audi A4/GreenColor/Boot.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Audi A4/GreenColor/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/Audi A4/GreenColor/BackDoor.png")
                            },
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Audi A4/RedColor/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Audi A4/RedColor/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Audi A4/RedColor/Bonnet.png"),
                                Boot = ModAPI.LoadSprite("Textures/Cars/Audi A4/RedColor/Boot.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Audi A4/RedColor/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/Audi A4/RedColor/BackDoor.png")
                            }
                        };

                        CarSerialisationHelper carSerialisationHelper = Instance.AddComponent<CarSerialisationHelper>();
                        carSerialisationHelper.AfterFirstSpawn = () =>
                        {
                            body.GetComponent<CarBehaviour>().MotorSpeed = -4600f;

                            wheels[0].connectedBody.transform.localPosition = new Vector3(2.36f, -0.806f);
                            wheels[1].connectedBody.transform.localPosition = new Vector3(-2.068f, -0.806f);
                            bonnet.localPosition = new Vector3(2.471424f, 0.0857097f);
                            boot.localPosition = new Vector3(-3.04f, 0.13f);
                            frontDoor.localPosition = new Vector3(0.500002f, 0.0142789f);
                            backDoor.localPosition = new Vector3(-1.042857f, 0.0142789f);
                            Instance.transform.GetChild(7).localPosition = new Vector3(2.2f, -0.25f);
                            Instance.transform.GetChild(8).localPosition = new Vector3(-2.3f, -0.3f);
                        };
                        carSerialisationHelper.AfterSpawn = () =>
                        {
                            carSerialisationHelper.carOptics.Headlights = new GameObject[]
                            {
                                headlight,
                                taillight
                            };
                        };

                        NoCollide noCollide = Instance.GetComponent<NoCollide>();
                        noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                        noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Car"),
                    NameOverride = "Lada 2104" + tag,
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "Soviet and Russian rear-wheel drive car of the III group of a small class with a station wagon body. Developed at the Volga Automobile Plant. Produced from 1982 to 2006.",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/Cars/Lada 2104/Thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Transform body = Instance.transform.GetChild(0);
                        BoxCollider2D[] boxColliders = body.GetComponents<BoxCollider2D>();
                        boxColliders[0].offset = new Vector2(-0.9935724f, -0.6366533f);
                        boxColliders[0].size = new Vector2(0.7319374f, 0.3867753f);
                        boxColliders[1].offset = new Vector2(-1.412266f, 0.07183601f);
                        boxColliders[1].size = new Vector2(0.2066746f, 1.086045f);
                        boxColliders[2].offset = new Vector2(0.2173646f, -0.6447749f);
                        boxColliders[2].size = new Vector2(0.7642735f, 0.4010276f);
                        boxColliders[3].offset = new Vector2(-0.09891982f, 0.1281012f);
                        boxColliders[3].size = new Vector2(0.200361f, 1.260856f);
                        body.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(3.339788f, -0.04188037f),
                            new Vector2(3.269659f, -0.04320218f),
                            new Vector2(3.203921f, -0.2113113f),
                            new Vector2(1.57134f, -0.09922314f),
                            new Vector2(1.571429f, 0.1289061f),
                            new Vector2(1.486577f, 0.128993f),
                            new Vector2(1.344451f, 0.4632163f),
                            new Vector2(0.9703096f, 0.9293668f),
                            new Vector2(-2.261764f, 0.9285715f),
                            new Vector2(-3.085149f, 0.04257962f),
                            new Vector2(-3.285778f, -0.5570759f),
                            new Vector2(-2.972294f, -0.8398728f),
                            new Vector2(-1.26619f, -0.9285724f),
                            new Vector2(3.022087f, -0.9289024f)
                        });
                        body.GetComponent<PolygonCollider2D>().SetPath(1, new Vector2[]
                        {
                            new Vector2(-0.9709282f, -0.8142473f),
                            new Vector2(-1.545203f, -0.1505785f),
                            new Vector2(-1.342683f, 0.8427334f),
                            new Vector2(0.8568147f, 0.8430069f),
                            new Vector2(1.222358f, 0.4639388f),
                            new Vector2(1.461143f, -0.08030061f),
                            new Vector2(1.456752f, -0.8142435f)
                        });
                        body.GetChild(0).localPosition = new Vector3(0.1285647f, -0.0571414f);

                        WheelJoint2D[] wheels = body.GetComponents<WheelJoint2D>();
                        wheels[0].anchor = new Vector2(2.35f, -0.9f);
                        wheels[0].connectedBody.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Cars/Lada 2104/Wheel.png");
                        wheels[0].connectedBody.GetComponent<CircleCollider2D>().radius = 0.4857143f;
                        wheels[1].anchor = new Vector2(-1.7f, -0.9f);
                        wheels[1].connectedBody.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Cars/Lada 2104/Wheel.png");
                        wheels[1].connectedBody.GetComponent<CircleCollider2D>().radius = 0.4857143f;

                        LightSprite headlight = ModAPI.CreateLight(body, Color.white, 3.5f, 1.5f);
                        headlight.transform.localPosition = new Vector3(3.23f, -0.403f, 0f);
                        headlight.gameObject.SetActive(false);

                        GameObject taillight = new GameObject("Taillight");
                        taillight.transform.parent = body;
                        taillight.transform.rotation = body.rotation;
                        taillight.transform.localPosition = new Vector3(-3.0857f, -0.0286f, 0f);
                        taillight.transform.localScale = new Vector3(1f, 1f, 1f);
                        SpriteRenderer taillightRenderer = taillight.GetOrAddComponent<SpriteRenderer>();
                        taillightRenderer.sprite = ModAPI.LoadSprite("Textures/Cars/Lada 2104/Taillight.png");
                        taillightRenderer.sortingOrder = body.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        taillight.AddComponent<Optout>();
                        ModAPI.CreateLight(taillight.transform, Color.red, 3.5f, 1.5f);
                        taillight.SetActive(false);

                        GameObject turnSignal1 = new GameObject("Turn Signal 1");
                        turnSignal1.transform.parent = body;
                        turnSignal1.transform.rotation = body.rotation;
                        turnSignal1.transform.localPosition = new Vector3(-3.1287f, -0.1572f, 0f);
                        turnSignal1.transform.localScale = new Vector3(1f, 1f, 1f);
                        SpriteRenderer turnSignal1Renderer = turnSignal1.GetOrAddComponent<SpriteRenderer>();
                        turnSignal1Renderer.sprite = ModAPI.LoadSprite("Textures/Cars/Lada 2104/TurnSignal1.png");
                        turnSignal1Renderer.sortingOrder = body.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        turnSignal1.AddComponent<Optout>();
                        ModAPI.CreateLight(turnSignal1.transform, new Color32(255, 146, 0, 255), 1f, 1f);
                        turnSignal1.SetActive(false);

                        GameObject turnSignal2 = new GameObject("Turn Signal 2");
                        turnSignal2.transform.parent = body;
                        turnSignal2.transform.rotation = body.rotation;
                        turnSignal2.transform.localPosition = new Vector3(3.042803f, -0.257206f, 0f);
                        turnSignal2.transform.localScale = new Vector3(1f, 1f, 1f);
                        SpriteRenderer turnSignal2Renderer = turnSignal2.GetOrAddComponent<SpriteRenderer>();
                        turnSignal2Renderer.sprite = ModAPI.LoadSprite("Textures/Cars/Lada 2104/TurnSignal2.png");
                        turnSignal2Renderer.sortingOrder = body.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        turnSignal2.AddComponent<Optout>();
                        ModAPI.CreateLight(turnSignal2.transform, new Color32(255, 146, 0, 255), 1f, 1f);
                        turnSignal2.SetActive(false);

                        GameObject reversingLamp = new GameObject("Reversing Lamp");
                        reversingLamp.transform.parent = body;
                        reversingLamp.transform.rotation = body.rotation;
                        reversingLamp.transform.localPosition = new Vector3(-3.185709f, -0.271485f);
                        reversingLamp.transform.localScale = new Vector3(1f, 1f, 1f);
                        SpriteRenderer reversingLampRenderer = reversingLamp.GetOrAddComponent<SpriteRenderer>();
                        reversingLampRenderer.sprite = ModAPI.LoadSprite("Textures/Cars/Lada 2104/ReversingLamp.png");
                        reversingLampRenderer.sortingOrder = body.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        reversingLamp.AddComponent<Optout>();
                        ModAPI.CreateLight(reversingLamp.transform, Color.white, 1f, 1f);
                        reversingLamp.SetActive(false);

                        Transform bonnet = Instance.transform.GetChild(3);
                        bonnet.GetComponent<HingeJoint2D>().anchor = new Vector2(0.8714285f, -0.1142855f);
                        bonnet.GetComponent<HingeJoint2D>().limits = new JointAngleLimits2D
                        {
                            min = 0,
                            max = 70
                        };
                        bonnet.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.8714285f, 0.1142857f),
                            new Vector2(-0.8721212f, 0.05846947f),
                            new Vector2(0.8714285f, -0.1142857f),
                            new Vector2(0.8703743f, -0.05867064f)
                        });

                        Instance.transform.GetChild(4).gameObject.SetActive(false);

                        Transform frontDoor = Instance.transform.GetChild(5);
                        frontDoor.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.8f, 0.8571429f),
                            new Vector2(-0.8f, -0.8571429f),
                            new Vector2(0.8f, -0.8571429f),
                            new Vector2(0.7972623f, -0.09603468f),
                            new Vector2(0.5215713f, 0.4979815f),
                            new Vector2(0.2152529f, 0.8591825f)
                        });

                        Transform backDoor = Instance.transform.GetChild(6);
                        backDoor.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.461466f, 0.8428571f),
                            new Vector2(-0.7285714f, 0.1471105f),
                            new Vector2(-0.7285714f, -0.1811957f),
                            new Vector2(-0.1169578f, -0.8428571f),
                            new Vector2(0.7285714f, -0.8428571f),
                            new Vector2(0.7285714f, 0.8428571f)
                        });

                        body.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[]
                        {
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Lada 2104/BlackColor/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Lada 2104/BlackColor/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Lada 2104/BlackColor/Bonnet.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Lada 2104/BlackColor/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/Lada 2104/BlackColor/BackDoor.png")
                            },
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Lada 2104/BlueColor/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Lada 2104/BlueColor/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Lada 2104/BlueColor/Bonnet.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Lada 2104/BlueColor/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/Lada 2104/BlueColor/BackDoor.png")
                            },
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Lada 2104/GrayColor/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Lada 2104/GrayColor/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Lada 2104/GrayColor/Bonnet.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Lada 2104/GrayColor/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/Lada 2104/GrayColor/BackDoor.png")
                            },
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Lada 2104/GreenColor/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Lada 2104/GreenColor/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Lada 2104/GreenColor/Bonnet.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Lada 2104/GreenColor/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/Lada 2104/GreenColor/BackDoor.png")
                            },
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Lada 2104/RedColor/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Lada 2104/RedColor/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Lada 2104/RedColor/Bonnet.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Lada 2104/RedColor/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/Lada 2104/RedColor/BackDoor.png")
                            }
                        };

                        AudioClip failedEngineStartup = ModAPI.LoadSound("Sounds/FailedEngineStartup.mp3");
                        CarSerialisationHelper carSerialisationHelper = Instance.AddComponent<CarSerialisationHelper>();
                        carSerialisationHelper.AfterFirstSpawn = () =>
                        {
                            body.GetComponent<CarBehaviour>().MotorSpeed = -4200f;

                            wheels[0].connectedBody.transform.localPosition = new Vector3(2.35f, -0.9f);
                            wheels[1].connectedBody.transform.localPosition = new Vector3(-1.7f, -0.9f);
                            bonnet.localPosition = new Vector3(2.44f, 0.015f);
                            frontDoor.localPosition = new Vector3(0.685f, 0.015f);
                            backDoor.localPosition = new Vector3(-0.84f, 0.027f);
                            Instance.transform.GetChild(7).localPosition = new Vector3(2.3f, -0.35f);
                            Instance.transform.GetChild(8).localPosition = new Vector3(-2.1f, -0.35f);
                        };
                        carSerialisationHelper.AfterSpawn = () =>
                        {
                            carSerialisationHelper.carOptics.FailedEngineStartup = true;
                            carSerialisationHelper.carOptics.Headlights = new GameObject[]
                            {
                                headlight.gameObject,
                                taillight
                            };
                            carSerialisationHelper.carOptics.TurnSignals = new GameObject[]
                            {
                                turnSignal1,
                                turnSignal2
                            };
                            carSerialisationHelper.carOptics.ReversingLamp = reversingLamp;
                            carSerialisationHelper.carOptics.FailedEngineStartupSound = failedEngineStartup;
                            carSerialisationHelper.carOptics.UpdateActivation();
                        };

                        NoCollide noCollide = Instance.GetComponent<NoCollide>();
                        noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                        noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Car"),
                    NameOverride = "Hummer H1" +tag,
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "Four-wheel-drive utility vehicle based on the M998 Humvee, which was created by AM General. The vehicle was produced from 1992 through 2006, and was the first of what became the Hummer line. Originally designed strictly for military use, the off-road vehicle was released to the civilian market due to market demand.",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/Cars/Hummer H1/Thumb.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Transform body = Instance.transform.GetChild(0);
                        BoxCollider2D[] boxColliders = body.GetComponents<BoxCollider2D>();
                        boxColliders[0].offset = new Vector2(-0.4425528f, -0.6865115f);
                        boxColliders[0].size = new Vector2(0.7118573f, 0.3165189f);
                        boxColliders[1].offset = new Vector2(-0.8529415f, -0.03636563f);
                        boxColliders[1].size = new Vector2(0.1621748f, 1.11035f);
                        boxColliders[2].offset = new Vector2(0.8854706f, -0.6751637f);
                        boxColliders[2].size = new Vector2(0.68918f, 0.3494469f);
                        boxColliders[3].offset = new Vector2(0.5598401f, 0.06309009f);
                        boxColliders[3].size = new Vector2(0.2034953f, 1.221151f);
                        body.GetComponent<PolygonCollider2D>().offset = new Vector2(0f, 0.028357f);
                        body.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(2.142774f, 0.0433135f),
                            new Vector2(2.14286f, 0.2427346f),
                            new Vector2(2.028517f, 0.2427998f),
                            new Vector2(1.971389f, 1.014234f),
                            new Vector2(-0.8857394f, 1.014222f),
                            new Vector2(-0.9429132f, 0.9285183f),
                            new Vector2(-1.114345f, 0.2429981f),
                            new Vector2(-1.174045f, 0.2429996f),
                            new Vector2(-1.174348f, 0.009822398f),
                            new Vector2(-2.88577f, 0.009885341f),
                            new Vector2(-2.885741f, 0.2430139f),
                            new Vector2(-2.94285f, 0.2430294f),
                            new Vector2(-2.942976f, -0.6426549f),
                            new Vector2(-0.9429818f, -0.6429099f),
                            new Vector2(-0.6877806f, -1.071776f),
                            new Vector2(2.456642f, -1.071214f),
                            new Vector2(2.656974f, -0.6716815f),
                            new Vector2(4.056909f, -0.6715363f),
                            new Vector2(4.143048f, -0.5858107f),
                            new Vector2(4.143254f, -0.2142706f),
                            new Vector2(2.628627f, -0.214393f)
                        });
                        body.GetComponent<PolygonCollider2D>().SetPath(1, new Vector2[]
                        {
                            new Vector2(1.885841f, 0.8142986f),
                            new Vector2(1.885638f, -0.8429346f),
                            new Vector2(-0.1050253f, -0.8429241f),
                            new Vector2(-0.6381247f, -0.7111959f),
                            new Vector2(-0.911347f, 0.2348347f),
                            new Vector2(-0.742581f, 0.8141136f)
                        });
                        body.GetChild(0).localPosition = new Vector3(0.8f, -0.014292f);

                        WheelJoint2D[] wheels = body.GetComponents<WheelJoint2D>();
                        wheels[0].anchor = new Vector2(3.366f, -1.0f);
                        wheels[0].connectedBody.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Cars/Hummer H1/Wheel.png");
                        wheels[0].connectedBody.GetComponent<CircleCollider2D>().radius = 0.6857143f;
                        wheels[1].anchor = new Vector2(-1.711f, -1.0f);
                        wheels[1].connectedBody.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Cars/Hummer H1/Wheel.png");
                        wheels[1].connectedBody.GetComponent<CircleCollider2D>().radius = 0.6857143f;

                        LightSprite taillight = ModAPI.CreateLight(body, Color.red, 3.5f, 1.5f);
                        taillight.transform.localPosition = new Vector3(-2.934f, -0.112f);
                        taillight.gameObject.SetActive(false);

                        LightSprite reversingLamp = ModAPI.CreateLight(body, Color.white, 1f, 1f);
                        reversingLamp.transform.localPosition = new Vector3(-2.933f, -0.139f);
                        reversingLamp.gameObject.SetActive(false);

                        Transform bonnet = Instance.transform.GetChild(3);
                        bonnet.GetComponent<SpriteRenderer>().sortingOrder = wheels[0].connectedBody.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        bonnet.GetComponent<FixedJoint2D>().breakForce = 300f;
                        bonnet.GetComponent<HingeJoint2D>().anchor = new Vector2(0.9283743f, -0.3900707f);
                        bonnet.GetComponent<HingeJoint2D>().limits = new JointAngleLimits2D
                        {
                            min = 0,
                            max = 55
                        };
                        bonnet.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.5345829f, 0.4f),
                            new Vector2(-1.014286f, 0.4f),
                            new Vector2(-1.012003f, 0.1802728f),
                            new Vector2(-0.3898644f, -0.1411351f),
                            new Vector2(-0.2047734f, -0.1415623f),
                            new Vector2(-0.07092929f, -0.08663893f),
                            new Vector2(0.545867f, -0.08511019f),
                            new Vector2(0.8657677f, -0.4001054f),
                            new Vector2(1.014286f, -0.4f),
                            new Vector2(1.014286f, -0.06328857f),
                            new Vector2(0.8967597f, 0.07804364f)
                        });

                        LightSprite headlight = ModAPI.CreateLight(bonnet, Color.white, 3.5f, 1.5f);
                        headlight.transform.localPosition = new Vector3(0.9874802f, -0.217f);
                        headlight.gameObject.SetActive(false);

                        GameObject turnSignal = new GameObject("Turn Signal");
                        turnSignal.transform.parent = bonnet;
                        turnSignal.transform.rotation = bonnet.rotation;
                        turnSignal.transform.localPosition = new Vector3(0.800002f, -0.071431f, 0f);
                        turnSignal.transform.localScale = new Vector3(1f, 1f, 1f);
                        SpriteRenderer turnSignalRenderer = turnSignal.AddComponent<SpriteRenderer>();
                        turnSignalRenderer.sprite = ModAPI.LoadSprite("Textures/Cars/Hummer H1/TurnSignal.png");
                        turnSignalRenderer.sortingOrder = bonnet.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        turnSignal.AddComponent<Optout>();
                        ModAPI.CreateLight(turnSignal.transform, new Color32(255, 146, 0, 255), 1f, 1f);
                        turnSignal.SetActive(false);

                        Instance.transform.GetChild(4).gameObject.SetActive(false);

                        Transform frontDoor = Instance.transform.GetChild(5);
                        UnityEngine.Object.Destroy(frontDoor.GetComponent<PolygonCollider2D>());
                        frontDoor.gameObject.AddComponent<BoxCollider2D>().size = new Vector2(1.342857f, 1.714286f);

                        Transform backDoor = Instance.transform.GetChild(6);
                        backDoor.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.4999099f, 0.8571624f),
                            new Vector2(-0.7284815f, 0.2569818f),
                            new Vector2(-0.7285628f, -4.300475e-05f),
                            new Vector2(-0.2143337f, -0.8571276f),
                            new Vector2(0.7285714f, -0.8571429f),
                            new Vector2(0.7285714f, 0.8571429f)
                        });

                        body.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[] 
                        {
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Hummer H1/BlackColor/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Hummer H1/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Hummer H1/BlackColor/Bonnet.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Hummer H1/BlackColor/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/Hummer H1/BlackColor/BackDoor.png")
                            },
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Hummer H1/GrayColor/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Hummer H1/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Hummer H1/GrayColor/Bonnet.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Hummer H1/GrayColor/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/Hummer H1/GrayColor/BackDoor.png")
                            },
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Hummer H1/RedColor/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Hummer H1/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Hummer H1/RedColor/Bonnet.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Hummer H1/RedColor/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/Hummer H1/RedColor/BackDoor.png")
                            },
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Hummer H1/YellowColor/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Hummer H1/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Hummer H1/YellowColor/Bonnet.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Hummer H1/YellowColor/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/Hummer H1/YellowColor/BackDoor.png")
                            }
                        };

                        CarSerialisationHelper carSerialisationHelper = Instance.AddComponent<CarSerialisationHelper>();
                        carSerialisationHelper.AfterFirstSpawn = () =>
                        {
                            body.GetComponent<CarBehaviour>().MotorSpeed = -3100f;

                            wheels[0].connectedBody.transform.localPosition = new Vector3(3.366f, -1.0f);
                            wheels[1].connectedBody.transform.localPosition = new Vector3(-1.711f, -1.0f);
                            bonnet.localPosition = new Vector3(3.12852f, -0.128623f);
                            frontDoor.localPosition = new Vector3(1.24286f, 0.0142914f);
                            backDoor.localPosition = new Vector3(-0.2142861f, 0.0142914f);
                            Instance.transform.GetChild(8).localPosition = new Vector3(-2.144f, -0.285f);

                            Transform engine = Instance.transform.GetChild(7);
                            engine.localScale = new Vector3(0.9f, 0.9f);
                            engine.localPosition = new Vector3(3.355f, -0.283f);
                        };
                        carSerialisationHelper.AfterSpawn = () =>
                        {
                            carSerialisationHelper.carOptics.Headlights = new GameObject[]
                            {
                                headlight.gameObject,
                                taillight.gameObject
                            };
                            carSerialisationHelper.carOptics.TurnSignals = new GameObject[]
                            {
                                turnSignal
                            };
                            carSerialisationHelper.carOptics.ReversingLamp = reversingLamp.gameObject;
                            carSerialisationHelper.carOptics.UpdateActivation();
                            if (bonnet.GetComponents<JointSerialisationHelper>()[1].Broken)
                            {
                                List<GameObject> headlightList = carSerialisationHelper.carOptics.Headlights.ToList();
                                headlightList.Remove(headlight.gameObject);
                                carSerialisationHelper.carOptics.Headlights = headlightList.ToArray();
                                carSerialisationHelper.carOptics.TurnSignals = new GameObject[0];
                            }
                        };

                        bonnet.GetComponent<JointBreakSoundBehaviour>().OnBreak.AddListener(() =>
                        {
                            List<GameObject> headlightList = carSerialisationHelper.carOptics.Headlights.ToList();
                            headlightList.Remove(headlight.gameObject);
                            carSerialisationHelper.carOptics.Headlights = headlightList.ToArray();
                            carSerialisationHelper.carOptics.TurnSignals = new GameObject[0];
                            ModAPI.CreateParticleEffect("BrokenElectronicsSpark", bonnet.position + new Vector3(0.9283743f, -0.3900707f));
                            headlight.gameObject.SetActive(false);
                            turnSignal.SetActive(false);
                        });

                        NoCollide noCollide = Instance.GetComponent<NoCollide>();
                        noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                        noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Car"),
                    NameOverride = "Hummer H1 Military" +tag,
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "Hummer H1 but military.",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/Cars/Hummer H1/Thumb2.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Transform body = Instance.transform.GetChild(0);
                        BoxCollider2D[] boxColliders = body.GetComponents<BoxCollider2D>();
                        boxColliders[0].offset = new Vector2(0.8932201f, -0.7014027f);
                        boxColliders[0].size = new Vector2(0.6993212f, 0.3226223f);
                        boxColliders[1].offset = new Vector2(0.5522f, -0.02798796f);
                        boxColliders[1].size = new Vector2(0.2182359f, 1.335423f);
                        boxColliders[2].offset = new Vector2(-0.4047221f, -0.7252221f);
                        boxColliders[2].size = new Vector2(0.6617968f, 0.3002539f);
                        boxColliders[3].offset = new Vector2(-0.812965f, -0.04964495f);
                        boxColliders[3].size = new Vector2(0.2242718f, 1.10992f);
                        body.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(2.142774f, 0.0433135f),
                            new Vector2(2.14286f, 0.2427346f),
                            new Vector2(2.028517f, 0.2427998f),
                            new Vector2(1.971389f, 1.014234f),
                            new Vector2(1.342682f, 1.014179f),
                            new Vector2(1.342811f, 1.071436f),
                            new Vector2(0.771365f, 1.071429f),
                            new Vector2(0.7712709f, 0.8142624f),
                            new Vector2(1.885841f, 0.8142986f),
                            new Vector2(1.885638f, -0.8429346f),
                            new Vector2(-0.1050253f, -0.8429241f),
                            new Vector2(-0.6381247f, -0.7111959f),
                            new Vector2(-0.911347f, 0.2348347f),
                            new Vector2(-0.742581f, 0.8141136f),
                            new Vector2(-0.113258f, 0.8142576f),
                            new Vector2(-0.1134357f, 1.071426f),
                            new Vector2(-0.2857676f, 1.071425f),
                            new Vector2(-0.2858009f, 1.014233f),
                            new Vector2(-0.8857394f, 1.014222f),
                            new Vector2(-0.9429132f, 0.9285183f),
                            new Vector2(-1.037319f, 0.2142334f),
                            new Vector2(-2.942794f, 0.2141121f),
                            new Vector2(-2.942976f, -0.6426549f),
                            new Vector2(-0.9429818f, -0.6429098f),
                            new Vector2(-0.6877806f, -1.071776f),
                            new Vector2(2.456642f, -1.071214f),
                            new Vector2(2.656974f, -0.6716815f),
                            new Vector2(4.056909f, -0.6715363f),
                            new Vector2(4.143048f, -0.5858107f),
                            new Vector2(4.143254f, -0.2142706f),
                            new Vector2(2.628627f, -0.214393f)
                        });
                        body.GetComponent<PolygonCollider2D>().pathCount = 1;
                        PhysicalProperties properties = UnityEngine.Object.Instantiate(body.GetComponent<PhysicalBehaviour>().Properties);
                        properties.BulletSpeedAbsorptionPower = 6f;
                        body.GetComponent<PhysicalBehaviour>().Properties = properties;
                        body.GetChild(0).localPosition = new Vector3(0.8f, -0.04286f);

                        WheelJoint2D[] wheels = body.GetComponents<WheelJoint2D>();
                        wheels[0].anchor = new Vector2(3.366f, -1.03f);
                        wheels[0].connectedBody.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Cars/Hummer H1/Wheel.png");
                        wheels[0].connectedBody.GetComponent<CircleCollider2D>().radius = 0.6857143f;
                        wheels[1].anchor = new Vector2(-1.711f, -1.03f);
                        wheels[1].connectedBody.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Cars/Hummer H1/Wheel.png");
                        wheels[1].connectedBody.GetComponent<CircleCollider2D>().radius = 0.6857143f;

                        LightSprite taillight = ModAPI.CreateLight(body, Color.red, 3.5f, 1.5f);
                        taillight.transform.localPosition = new Vector3(-2.934f, -0.112f);
                        taillight.gameObject.SetActive(false);

                        LightSprite reversingLamp = ModAPI.CreateLight(body, Color.white, 1f, 1f);
                        reversingLamp.transform.localPosition = new Vector3(-2.933f, -0.139f);
                        reversingLamp.gameObject.SetActive(false);

                        Transform bonnet = Instance.transform.GetChild(3);
                        bonnet.GetComponent<SpriteRenderer>().sortingOrder = body.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        bonnet.GetComponent<FixedJoint2D>().breakForce = 350f;
                        bonnet.GetComponent<HingeJoint2D>().anchor = new Vector2(0.9283743f, -0.3900707f);
                        bonnet.GetComponent<HingeJoint2D>().limits = new JointAngleLimits2D
                        {
                            min = 0,
                            max = 55
                        };
                        bonnet.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.5345829f, 0.4f),
                            new Vector2(-1.014286f, 0.4f),
                            new Vector2(-1.012003f, 0.1802728f),
                            new Vector2(-0.3898644f, -0.1411351f),
                            new Vector2(-0.2047734f, -0.1415623f),
                            new Vector2(-0.07092929f, -0.08663893f),
                            new Vector2(0.545867f, -0.08511019f),
                            new Vector2(0.8657677f, -0.4001054f),
                            new Vector2(1.014286f, -0.4f),
                            new Vector2(1.014286f, -0.06328857f),
                            new Vector2(0.8967597f, 0.07804364f)
                        });

                        LightSprite headlight = ModAPI.CreateLight(bonnet, Color.white, 3.5f, 1.5f);
                        headlight.transform.localPosition = new Vector3(0.9874802f, -0.217f);
                        headlight.gameObject.SetActive(false);

                        GameObject turnSignal = new GameObject("Turn Signal");
                        turnSignal.transform.parent = bonnet;
                        turnSignal.transform.rotation = bonnet.rotation;
                        turnSignal.transform.localPosition = new Vector3(0.800002f, -0.071431f, 0f);
                        turnSignal.transform.localScale = new Vector3(1f, 1f, 1f);
                        SpriteRenderer turnSignalRenderer = turnSignal.GetOrAddComponent<SpriteRenderer>();
                        turnSignalRenderer.sprite = ModAPI.LoadSprite("Textures/Cars/Hummer H1/TurnSignal.png");
                        turnSignalRenderer.sortingOrder = bonnet.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        turnSignal.AddComponent<Optout>();
                        ModAPI.CreateLight(turnSignal.transform, new Color32(255, 146, 0, 255), 1f, 1f);
                        turnSignal.SetActive(false);

                        Transform boot = Instance.transform.GetChild(4);
                        UnityEngine.Object.Destroy(boot.GetComponent<BoxCollider2D>());
                        boot.GetComponent<HingeJoint2D>().anchor = new Vector2(0.9999198f, 0.3283523f);
                        boot.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(1f, 0.3571429f),
                            new Vector2(0.8580877f, 0.3561639f),
                            new Vector2(-0.8859256f, -0.08020445f),
                            new Vector2(-1f, -0.3571429f),
                            new Vector2(-0.9437303f, -0.3571429f),
                            new Vector2(-0.8207295f, -0.1145015f),
                            new Vector2(0.9999917f, 0.2995541f)
                        });

                        Transform frontDoor = Instance.transform.GetChild(5);
                        UnityEngine.Object.Destroy(frontDoor.GetComponent<PolygonCollider2D>());
                        frontDoor.gameObject.AddComponent<BoxCollider2D>().size = new Vector2(1.342857f, 1.714286f);

                        Transform backDoor = Instance.transform.GetChild(6);
                        backDoor.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.4999099f, 0.8571624f),
                            new Vector2(-0.7284815f, 0.2569818f),
                            new Vector2(-0.7285628f, -4.300475e-05f),
                            new Vector2(-0.2143337f, -0.8571276f),
                            new Vector2(0.7285714f, -0.8571429f),
                            new Vector2(0.7285714f, 0.8571429f)
                        });

                        GameObject hatch = new GameObject("Hatch");
                        hatch.transform.parent = Instance.transform;
                        hatch.transform.rotation = body.transform.rotation;
                        hatch.transform.localScale = Vector3.one;
                        hatch.transform.localPosition = new Vector3(0.328508f, 1.057143f);
                        SpriteRenderer hatchRenderer = hatch.AddComponent<SpriteRenderer>();
                        hatchRenderer.sprite = ModAPI.LoadSprite("Textures/Cars/Hummer H1/MilitaryDesertSkin/Hatch.png");
                        hatchRenderer.sortingOrder = boot.GetComponent<SpriteRenderer>().sortingOrder;
                        hatchRenderer.sortingLayerName = boot.GetComponent<SpriteRenderer>().sortingLayerName;
                        hatch.layer = 9;
                        BoxCollider2D boxCollider1 = hatch.AddComponent<BoxCollider2D>();
                        boxCollider1.offset = new Vector2(0f, -0.02859946f);
                        boxCollider1.size = new Vector2(0.8857143f, 0.08565822f);
                        BoxCollider2D boxCollider2 = hatch.AddComponent<BoxCollider2D>();
                        boxCollider2.offset = new Vector2(-3.321469e-05f, 0.02843906f);
                        boxCollider2.size = new Vector2(0.1426883f, 0.08597901f);
                        hatch.AddComponent<Rigidbody2D>().mass = 0.3f;
                        FixedJoint2D fixedJoint = hatch.AddComponent<FixedJoint2D>();
                        fixedJoint.connectedBody = body.GetComponent<Rigidbody2D>();
                        fixedJoint.breakForce = boot.GetComponent<FixedJoint2D>().breakForce;
                        HingeJoint2D hingeJoint = hatch.AddComponent<HingeJoint2D>();
                        hingeJoint.connectedBody = body.GetComponent<Rigidbody2D>();
                        hingeJoint.anchor = new Vector2(-0.4428571f, -0.07142854f);
                        hingeJoint.breakForce = 900f;
                        hingeJoint.breakTorque = 900f;
                        hingeJoint.limits = new JointAngleLimits2D()
                        {
                            min = -95,
                            max = 0
                        };
                        hingeJoint.useLimits = true;
                        hatch.AddComponent<JointSerialisationHelper>().Joint = fixedJoint;
                        hatch.AddComponent<JointSerialisationHelper>().Joint = hingeJoint;
                        JointBreakSoundBehaviour jointBreakSound = hatch.AddComponent<JointBreakSoundBehaviour>();
                        jointBreakSound.Clips = boot.GetComponent<JointBreakSoundBehaviour>().Clips;
                        jointBreakSound.AudioSource = hatch.GetComponent<AudioSource>();
                        jointBreakSound.Joints = new Joint2D[]
                        {
                            hingeJoint
                        };
                        jointBreakSound.OnBreak = new UnityEvent();
                        jointBreakSound.OnBreak.AddListener(() =>
                        {
                            jointBreakSound.Joints = new Joint2D[0];
                        });
                        hatch.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        hatch.AddComponent<AudioSourceTimeScaleBehaviour>();
                        hatch.AddComponent<Optout>();

                        body.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[]
                        {
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Hummer H1/MilitaryDesertSkin/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Hummer H1/MilitaryDesertSkin/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Hummer H1/MilitaryDesertSkin/Bonnet.png"),
                                Boot = ModAPI.LoadSprite("Textures/Cars/Hummer H1/MilitaryDesertSkin/Boot.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Hummer H1/MilitaryDesertSkin/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/Hummer H1/MilitaryDesertSkin/BackDoor.png")
                            },
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Hummer H1/MilitarySkin/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Hummer H1/MilitarySkin/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Hummer H1/MilitarySkin/Bonnet.png"),
                                Boot = ModAPI.LoadSprite("Textures/Cars/Hummer H1/MilitarySkin/Boot.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Hummer H1/MilitarySkin/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/Hummer H1/MilitarySkin/BackDoor.png")
                            },
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Hummer H1/MilitaryBlackSkin/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Hummer H1/MilitaryBlackSkin/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Hummer H1/BlackColor/Bonnet.png"),
                                Boot = ModAPI.LoadSprite("Textures/Cars/Hummer H1/MilitaryBlackSkin/Boot.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Hummer H1/MilitaryBlackSkin/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/Hummer H1/MilitaryBlackSkin/BackDoor.png")
                            }
                        };

                        CarSerialisationHelper carSerialisationHelper = Instance.AddComponent<CarSerialisationHelper>();
                        carSerialisationHelper.AfterFirstSpawn = () =>
                        {
                            body.GetComponent<CarBehaviour>().MotorSpeed = -3050f;

                            wheels[0].connectedBody.transform.localPosition = new Vector3(3.366f, -1.03f);
                            wheels[1].connectedBody.transform.localPosition = new Vector3(-1.711f, -1.03f);
                            bonnet.localPosition = new Vector3(3.12852f, -0.157142f);
                            boot.localPosition = new Vector3(-1.942854f, 0.5714235f);
                            frontDoor.localPosition = new Vector3(1.24286f, -0.014338f);
                            backDoor.localPosition = new Vector3(-0.2142861f, -0.014338f);
                            Instance.transform.GetChild(8).localPosition = new Vector3(-2.144f, -0.231f);

                            Transform engine = Instance.transform.GetChild(7);
                            engine.localScale = new Vector3(0.9f, 0.9f);
                            engine.localPosition = new Vector3(3.355f, -0.316f);

                            Instance.AddComponent<ObjectSerialisationHelper>().Object = hatch;
                        };
                        carSerialisationHelper.AfterSpawn = () =>
                        {
                            carSerialisationHelper.carOptics.Headlights = new GameObject[]
                            {
                                headlight.gameObject,
                                taillight.gameObject
                            };
                            carSerialisationHelper.carOptics.TurnSignals = new GameObject[]
                            {
                                turnSignal
                            };
                            carSerialisationHelper.carOptics.UpdateActivation();
                            carSerialisationHelper.carOptics.ReversingLamp = reversingLamp.gameObject;
                            if (bonnet.GetComponents<JointSerialisationHelper>()[1].Broken)
                            {
                                List<GameObject> headlightList = carSerialisationHelper.carOptics.Headlights.ToList();
                                headlightList.Remove(headlight.gameObject);
                                carSerialisationHelper.carOptics.Headlights = headlightList.ToArray();
                                carSerialisationHelper.carOptics.TurnSignals = new GameObject[0];
                            }
                        };

                        hatch.AddComponent<RandomCarTextureChildBehaviour>().Sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("Textures/Cars/Hummer H1/MilitaryDesertSkin/Hatch.png"),
                            ModAPI.LoadSprite("Textures/Cars/Hummer H1/MilitarySkin/Hatch.png"),
                            ModAPI.LoadSprite("Textures/Cars/Hummer H1/MilitaryBlackSkin/Hatch.png")
                        };

                        bonnet.GetComponent<JointBreakSoundBehaviour>().OnBreak.AddListener(() =>
                        {
                            List<GameObject> headlightList = carSerialisationHelper.carOptics.Headlights.ToList();
                            headlightList.Remove(headlight.gameObject);
                            carSerialisationHelper.carOptics.Headlights = headlightList.ToArray();
                            carSerialisationHelper.carOptics.TurnSignals = new GameObject[0];
                            ModAPI.CreateParticleEffect("BrokenElectronicsSpark", bonnet.position + new Vector3(0.9283743f, -0.3900707f));
                            headlight.gameObject.SetActive(false);
                            turnSignal.SetActive(false);
                        });

                        NoCollide noCollide = Instance.GetComponent<NoCollide>();
                        noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                        noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Car"),
                    NameOverride = "BMW M5 F90" +tag,
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "The BMW M5 is a high performance variant of the BMW 5 Series marketed under the BMW M sub-brand. It is considered an iconic vehicle in the sports sedan category. The majority of M5s have been produced in the sedan (saloon) body style, but in some countries the M5 was also available as a wagon (estate) from 1992 to 1995 and from 2006 to 2010.",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/Cars/BMW M5 F90/Thumb.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Transform body = Instance.transform.GetChild(0);
                        BoxCollider2D[] boxColliders = body.GetComponents<BoxCollider2D>();
                        boxColliders[0].offset = new Vector2(0.0185051f, -0.6445808f);
                        boxColliders[0].size = new Vector2(0.7351952f, 0.3980198f);
                        boxColliders[1].offset = new Vector2(-0.2947388f, 0.125545f);
                        boxColliders[1].size = new Vector2(0.2218513f, 1.21115f);
                        boxColliders[2].offset = new Vector2(-1.269417f, -0.6495647f);
                        boxColliders[2].size = new Vector2(0.6644325f, 0.3261127f);
                        boxColliders[3].offset = new Vector2(-1.696531f, 0.01295042f);
                        boxColliders[3].size = new Vector2(0.2514458f, 1.129582f);
                        body.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(3.542883f, -0.8288047f),
                            new Vector2(3.542857f, -0.4048213f),
                            new Vector2(3.428571f, -0.03311843f),
                            new Vector2(1.514205f, 0.2292352f),
                            new Vector2(1.514286f, 0.2824824f),
                            new Vector2(1.360908f, 0.2830796f),
                            new Vector2(1.106244f, 0.4834788f),
                            new Vector2(0.3950077f, 0.8772881f),
                            new Vector2(-0.3152425f, 0.9717709f),
                            new Vector2(-1.191791f, 0.9711298f),
                            new Vector2(-1.743479f, 0.8534529f),
                            new Vector2(-2.542146f, 0.5141158f),
                            new Vector2(-2.635382f, -0.03078544f),
                            new Vector2(-3.399124f, -0.03073749f),
                            new Vector2(-3.54007f, -0.3404343f),
                            new Vector2(-3.403266f, -0.7696168f),
                            new Vector2(-2.723561f, -0.9389736f),
                            new Vector2(3.171155f, -0.9435956f)
                        });
                        body.GetComponent<PolygonCollider2D>().SetPath(1, new Vector2[]
                        {
                            new Vector2(-2.00018f, 0.485719f),
                            new Vector2(-1.9999f, 0.5697989f),
                            new Vector2(-1.417173f, 0.8569055f),
                            new Vector2(-0.1492898f, 0.8572279f),
                            new Vector2(0.3262769f, 0.7524905f),
                            new Vector2(1.426542f, 0.1684611f),
                            new Vector2(1.428516f, -0.8000567f),
                            new Vector2(-1.255342f, -0.7974393f)
                        });
                        body.GetChild(0).localPosition = new Vector3(0.199997f, -0.042856f);

                        WheelJoint2D[] wheels = body.GetComponents<WheelJoint2D>();
                        wheels[0].anchor = new Vector2(2.46f, -0.793f);
                        wheels[1].anchor = new Vector2(-2.063f, -0.793f);

                        GameObject headlight = new GameObject("Headlight");
                        headlight.transform.parent = body;
                        headlight.transform.rotation = body.rotation;
                        headlight.transform.localPosition = new Vector3(3.214276f, -0.1571992f);
                        headlight.transform.localScale = new Vector3(1f, 1f);
                        SpriteRenderer headlightRenderer = headlight.GetOrAddComponent<SpriteRenderer>();
                        headlightRenderer.sprite = ModAPI.LoadSprite("Textures/Cars/BMW M5 F90/Headlight.png");
                        headlightRenderer.sortingOrder = body.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        headlight.AddComponent<Optout>();
                        ModAPI.CreateLight(headlight.transform, Color.white, 3.5f, 1.5f);
                        headlight.SetActive(false);

                        GameObject taillight = new GameObject("Taillight");
                        taillight.transform.parent = body;
                        taillight.transform.rotation = body.rotation;
                        taillight.transform.localPosition = new Vector3(-3.185709f, 0.1142304f);
                        taillight.transform.localScale = new Vector3(1f, 1f);
                        SpriteRenderer taillightRenderer = taillight.GetOrAddComponent<SpriteRenderer>();
                        taillightRenderer.sprite = ModAPI.LoadSprite("Textures/Cars/BMW M5 F90/Taillight.png");
                        taillightRenderer.sortingOrder = body.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        taillight.AddComponent<Optout>();
                        ModAPI.CreateLight(taillight.transform, Color.red, 3.5f, 1.5f);
                        taillight.SetActive(false);

                        LightSprite turnSignal1 = ModAPI.CreateLight(body, new Color32(255, 146, 0, 255), 1f, 1f);
                        turnSignal1.transform.localPosition = new Vector3(3.271f, -0.125f);
                        turnSignal1.gameObject.SetActive(false);

                        LightSprite turnSignal2 = ModAPI.CreateLight(body, new Color32(255, 146, 0, 255), 1f, 1f);
                        turnSignal2.transform.localPosition = new Vector3(-3.26f, 0.131f);
                        turnSignal2.gameObject.SetActive(false);

                        LightSprite reversingLamp = ModAPI.CreateLight(body, Color.white, 1f, 1f);
                        reversingLamp.transform.localPosition = new Vector3(-3.386f, 0.127f);
                        reversingLamp.gameObject.SetActive(false);

                        Transform bonnet = Instance.transform.GetChild(3);
                        bonnet.GetComponent<HingeJoint2D>().anchor = new Vector2(-0.9428809f, 0.1287231f);
                        bonnet.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.9571429f, 0.1857143f),
                            new Vector2(-0.9562626f, 0.13167f),
                            new Vector2(0.6687631f, -0.1034289f),
                            new Vector2(0.8142713f, -0.1857143f),
                            new Vector2(0.9571429f, -0.1857143f),
                            new Vector2(0.6998358f, -0.01441953f),
                            new Vector2(-0.7857933f, 0.1856971f)
                        });

                        Transform boot = Instance.transform.GetChild(4);
                        boot.GetComponent<HingeJoint2D>().anchor = new Vector2(0.4681487f, 0.2259247f);
                        boot.GetComponent<BoxCollider2D>().offset = new Vector2(-0.4118117f, -0.1446873f);
                        boot.GetComponent<BoxCollider2D>().size = new Vector2(0.1192338f, 0.08299851f);
                        boot.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.3856234f, 0.1279374f),
                            new Vector2(-0.385169f, -0.2713265f),
                            new Vector2(-0.3287662f, -0.2714205f),
                            new Vector2(-0.3285711f, 0.02907726f),
                            new Vector2(0.4410973f, 0.1574926f),
                            new Vector2(0.4714286f, 0.2714286f),
                            new Vector2(0.01417835f, 0.1287098f)
                        });

                        Transform frontDoor = Instance.transform.GetChild(5);
                        frontDoor.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.9428571f, 0.8571429f),
                            new Vector2(-0.6846544f, 0.017946f),
                            new Vector2(-0.685322f, -0.8571743f),
                            new Vector2(0.9428571f, -0.8571429f),
                            new Vector2(0.9428571f, 0.04125424f),
                            new Vector2(-0.1266136f, 0.7428083f),
                            new Vector2(-0.6497065f, 0.8571429f)
                        });

                        Transform backDoor = Instance.transform.GetChild(6);
                        backDoor.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.02858108f, 0.8571619f),
                            new Vector2(-0.9141942f, 0.5710715f),
                            new Vector2(-0.9142857f, 0.4374049f),
                            new Vector2(-0.08489598f, -0.8571429f),
                            new Vector2(0.9142857f, -0.8571429f),
                            new Vector2(0.9142857f, -0.1308719f),
                            new Vector2(0.6570932f, 0.8571381f)
                        });

                        body.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[] 
                        {
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/BMW M5 F90/BlackColor/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/BMW M5 F90/BlackColor/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/BMW M5 F90/BlackColor/Bonnet.png"),
                                Boot = ModAPI.LoadSprite("Textures/Cars/BMW M5 F90/BlackColor/Boot.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/BMW M5 F90/BlackColor/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/BMW M5 F90/BlackColor/BackDoor.png")
                            },
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/BMW M5 F90/BlueColor/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/BMW M5 F90/BlueColor/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/BMW M5 F90/BlueColor/Bonnet.png"),
                                Boot = ModAPI.LoadSprite("Textures/Cars/BMW M5 F90/BlueColor/Boot.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/BMW M5 F90/BlueColor/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/BMW M5 F90/BlueColor/BackDoor.png")
                            },
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/BMW M5 F90/GrayColor/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/BMW M5 F90/GrayColor/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/BMW M5 F90/GrayColor/Bonnet.png"),
                                Boot = ModAPI.LoadSprite("Textures/Cars/BMW M5 F90/GrayColor/Boot.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/BMW M5 F90/GrayColor/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/BMW M5 F90/GrayColor/BackDoor.png")
                            },
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/BMW M5 F90/GreenColor/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/BMW M5 F90/GreenColor/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/BMW M5 F90/GreenColor/Bonnet.png"),
                                Boot = ModAPI.LoadSprite("Textures/Cars/BMW M5 F90/GreenColor/Boot.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/BMW M5 F90/GreenColor/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/BMW M5 F90/GreenColor/BackDoor.png")
                            },
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/BMW M5 F90/RedColor/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/BMW M5 F90/RedColor/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/BMW M5 F90/RedColor/Bonnet.png"),
                                Boot = ModAPI.LoadSprite("Textures/Cars/BMW M5 F90/RedColor/Boot.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/BMW M5 F90/RedColor/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/BMW M5 F90/RedColor/BackDoor.png")
                            }
                        };

                        CarSerialisationHelper carSerialisationHelper = Instance.AddComponent<CarSerialisationHelper>();
                        carSerialisationHelper.AfterFirstSpawn = () =>
                        {
                            body.GetComponent<CarBehaviour>().MotorSpeed = -4850f;

                            wheels[0].connectedBody.transform.localPosition = new Vector3(2.46f, -0.793f);
                            wheels[1].connectedBody.transform.localPosition = new Vector3(-2.063f, -0.793f);
                            bonnet.localPosition = new Vector3(2.49999f, 0.1000027f);
                            boot.localPosition = new Vector3(-3.01435f, 0.24296f);
                            frontDoor.localPosition = new Vector3(0.514286f, 0.0285201f);
                            backDoor.localPosition = new Vector3(-1.114284f, 0.0285201f);
                            Instance.transform.GetChild(7).localPosition = new Vector3(2.2f, -0.25f);
                            Instance.transform.GetChild(8).localPosition = new Vector3(-2.3f, -0.3f);
                        };
                        carSerialisationHelper.AfterSpawn = () =>
                        {
                            carSerialisationHelper.carOptics.ActivateTurnSignalsOnCollision = true;
                            carSerialisationHelper.carOptics.Headlights = new GameObject[]
                            {
                                headlight,
                                taillight
                            };
                            carSerialisationHelper.carOptics.TurnSignals = new GameObject[]
                            {
                                turnSignal1.gameObject,
                                turnSignal2.gameObject
                            };
                            carSerialisationHelper.carOptics.ReversingLamp = reversingLamp.gameObject;
                            carSerialisationHelper.carOptics.UpdateActivation();
                        };

                        NoCollide noCollide = Instance.GetComponent<NoCollide>();
                        noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                        noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Car"),
                    NameOverride = "KamAZ-5410" +tag,
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "Soviet and Russian truck tractor of the KamAZ line of the first generation. Produced by the Kama Automobile Plant from 1976 to 1997.",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/Cars/KamAZ-5410/Thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Transform body = Instance.transform.GetChild(0);

                        Transform bodyBackground = body.GetChild(0);
                        bodyBackground.localPosition = new Vector3(2.428563f, 0.05714f);
                        bodyBackground.gameObject.AddComponent<Optout>();

                        WheelJoint2D[] wheels = body.GetComponents<WheelJoint2D>();
                        wheels[0].anchor = new Vector2(-1.8f, -0.42f);
                        wheels[0].connectedBody.GetComponent<SpriteRenderer>().sprite = ModAPI.FindSpawnable("Truck").Prefab.transform.GetChild(0).GetChild(0).GetComponent<SpriteRenderer>().sprite;
                        wheels[0].connectedBody.GetComponent<SpriteRenderer>().sortingOrder = body.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        wheels[0].connectedBody.GetComponent<CircleCollider2D>().radius = 0.6857144f;
                        wheels[0].motor = new JointMotor2D
                        {
                            maxMotorTorque = 300f
                        };
                        wheels[0].suspension = new JointSuspension2D
                        {
                            angle = 90f,
                            dampingRatio = 1f,
                            frequency = 10f
                        };
                        wheels[1].anchor = new Vector2(2.4f, -0.42f);
                        wheels[1].connectedBody.GetComponent<SpriteRenderer>().sprite = wheels[0].connectedBody.GetComponent<SpriteRenderer>().sprite;
                        wheels[1].connectedBody.GetComponent<CircleCollider2D>().radius = 0.6857144f;
                        wheels[1].motor = wheels[0].motor;
                        wheels[1].suspension = wheels[0].suspension;

                        Transform body2 = Instance.transform.GetChild(3);

                        GameObject body2Background = new GameObject("Background");
                        body2Background.transform.parent = body2;
                        body2Background.transform.rotation = body2.rotation;
                        body2Background.transform.localScale = Vector3.one;
                        body2Background.transform.localPosition = new Vector3(0.485653f, -0.085773f);
                        SpriteRenderer frameBackgroundRenderer = bodyBackground.gameObject.GetComponent<SpriteRenderer>();
                        SpriteRenderer body2BackgroundRenderer = body2Background.AddComponent<SpriteRenderer>();
                        body2BackgroundRenderer.sprite = ModAPI.LoadSprite("Textures/Cars/KamAZ-5410/BodyBackground.png");
                        body2BackgroundRenderer.sortingOrder = frameBackgroundRenderer.sortingOrder;
                        body2BackgroundRenderer.sortingLayerName = frameBackgroundRenderer.sortingLayerName;
                        body2Background.AddComponent<Optout>();

                        LightSprite headlight = ModAPI.CreateLight(body2, Color.white, 3.5f, 1.5f);
                        headlight.transform.localPosition = new Vector3(1.794f, -1.097f);
                        headlight.gameObject.SetActive(false);

                        GameObject turnSignal = new GameObject("Turn Signal");
                        turnSignal.transform.parent = body2;
                        turnSignal.transform.rotation = body2.rotation;
                        turnSignal.transform.localPosition = new Vector3(1.699994f, -0.67148f, 0f);
                        turnSignal.transform.localScale = new Vector3(1f, 1f, 1f);
                        SpriteRenderer turnSignalRenderer = turnSignal.GetOrAddComponent<SpriteRenderer>();
                        turnSignalRenderer.sprite = ModAPI.LoadSprite("Textures/Cars/KamAZ-5410/TurnSignal.png");
                        turnSignalRenderer.sortingOrder = body2.gameObject.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        turnSignal.AddComponent<Optout>();
                        ModAPI.CreateLight(turnSignal.transform, new Color32(255, 146, 0, 255), 1f, 1f);
                        turnSignal.SetActive(false);

                        Instance.transform.GetChild(4).gameObject.SetActive(false);

                        Transform door = Instance.transform.GetChild(5);
                        GameObject wheel = new GameObject("Wheel3");
                        wheel.transform.parent = Instance.transform;
                        wheel.transform.rotation = Instance.transform.rotation;
                        wheel.transform.localScale = new Vector3(1.12f, 1.12f);
                        wheel.transform.localPosition = new Vector3(-3.45f, -0.42f);
                        wheel.gameObject.AddComponent<Optout>();
                        SpriteRenderer wheelRenderer = wheel.AddComponent<SpriteRenderer>();
                        wheelRenderer.sprite = wheels[0].connectedBody.GetComponent<SpriteRenderer>().sprite;
                        wheelRenderer.sortingOrder = body.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        wheel.layer = 9;
                        wheel.AddComponent<CircleCollider2D>();
                        wheel.AddComponent<Rigidbody2D>().mass = 1f;
                        WheelJoint2D wheelJoint = body.gameObject.AddComponent<WheelJoint2D>();
                        wheelJoint.connectedBody = wheel.GetComponent<Rigidbody2D>();
                        wheelJoint.anchor = new Vector3(-3.45f, -0.42f);
                        wheelJoint.motor = wheels[0].motor;
                        wheelJoint.suspension = wheels[0].suspension;
                        wheelJoint.breakForce = wheels[0].breakForce;
                        wheelJoint.useMotor = true;
                        wheel.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Rubber");
                        wheel.AddComponent<AudioSourceTimeScaleBehaviour>();
                        wheel.AddComponent<Optout>();

                        if (body.GetComponent<CarBehaviour>().WheelJoints.Length == 2)
                        {
                            List<WheelJoint2D> wheelList = body.GetComponent<CarBehaviour>().WheelJoints.ToList();
                            wheelList.Add(wheelJoint);
                            body.GetComponent<CarBehaviour>().WheelJoints = wheelList.ToArray();

                            List<bool> wheelStateList = body.GetComponent<CarBehaviour>().WheelJointState.ToList();
                            wheelStateList.Add(true);
                            body.GetComponent<CarBehaviour>().WheelJointState = wheelStateList.ToArray();
                        }
                        else if (wheelJoint)
                        {
                            List<WheelJoint2D> wheelList = wheels.ToList();
                            wheelList[2] = wheelJoint;
                            body.GetComponent<CarBehaviour>().WheelJoints = wheelList.ToArray();

                            List<bool> wheelStateList = body.GetComponent<CarBehaviour>().WheelJointState.ToList();
                            wheelStateList[2] = true;
                            body.GetComponent<CarBehaviour>().WheelJointState = wheelStateList.ToArray();
                        }
                        body.gameObject.AddComponent<CarWheelsBehaviour>().Wheels = body.GetComponent<CarBehaviour>().WheelJoints;

                        body.GetComponent<CarBehaviour>().MotorSpeed = -2600f;
                        PhysicalBehaviour phys = body.GetComponent<PhysicalBehaviour>();
                        phys.TrueInitialMass = 22f;
                        phys.InitialMass = 22f;
                        phys.rigidbody.mass = 22f;
                        body.GetComponent<Rigidbody2D>().centerOfMass = new Vector2(-2.67f, -0.18f);
                        BoxCollider2D[] boxColliders = body.GetComponents<BoxCollider2D>();
                        boxColliders[0].offset = new Vector2(-0.06393433f, -0.1572786f);
                        boxColliders[0].size = new Vector2(9.157845f, 0.6576098f);
                        UnityEngine.Object.Destroy(boxColliders[1]);
                        UnityEngine.Object.Destroy(boxColliders[2]);
                        UnityEngine.Object.Destroy(boxColliders[3]);
                        PolygonCollider2D collider1 = body.GetComponent<PolygonCollider2D>();
                        collider1.pathCount = 1;
                        collider1.SetPath(0, new Vector2[]
                        {
                            new Vector2(3.448299f, 0.1494574f),
                            new Vector2(3.063602f, 0.598303f),
                            new Vector2(2.662553f, 0.7714286f),
                            new Vector2(1.786014f, 0.7715569f),
                            new Vector2(1.412421f, 0.2550817f),
                            new Vector2(1.241325f, 0.150818f)
                        });

                        body2.localPosition = new Vector3(2.82857f, 1.757137f);
                        body2.gameObject.name = "Body2";
                        body2.gameObject.AddComponent<Optout>();
                        body2.GetComponent<SpriteRenderer>().sortingOrder = body.gameObject.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        PhysicalBehaviour bodyPhys = body2.GetComponent<PhysicalBehaviour>();
                        bodyPhys.TrueInitialMass = 10f;
                        bodyPhys.InitialMass = 10f;
                        bodyPhys.rigidbody.mass = 10f;
                        FixedJoint2D bodyFixedJoint = body2.GetComponent<FixedJoint2D>();
                        bodyFixedJoint.breakForce = 10000f;
                        bodyFixedJoint.breakTorque = 5000f;
                        HingeJoint2D hingeJoint = body2.GetComponent<HingeJoint2D>();
                        hingeJoint.anchor = new Vector2(1.669298f, -1.625472f);
                        hingeJoint.breakForce = 55000f;
                        hingeJoint.breakTorque = 50000f;
                        body2.GetComponent<HingeJoint2D>().limits = new JointAngleLimits2D
                        {
                            min = 0f,
                            max = 50f
                        };
                        PolygonCollider2D collider2 = body2.GetComponent<PolygonCollider2D>();
                        collider2.pathCount = 2;
                        collider2.SetPath(0, new Vector2[]
                        {
                            new Vector2(1.042037f, 1.642932f),
                            new Vector2(-1.814286f, 1.642857f),
                            new Vector2(-1.814963f, -0.6419314f),
                            new Vector2(-1.555116f, -1.529448f),
                            new Vector2(-1.415082f, -1.529006f),
                            new Vector2(-1.042828f, -1.014586f),
                            new Vector2(-0.1579247f, -1.014272f),
                            new Vector2(0.2430989f, -1.214104f),
                            new Vector2(0.5899226f, -1.642857f),
                            new Vector2(1.814286f, -1.642857f),
                            new Vector2(1.814232f, -0.529066f),
                            new Vector2(1.698458f, 0.1631409f)
                        });
                        collider2.SetPath(1, new Vector2[]
                        {
                            new Vector2(-0.5287204f, -0.6144501f),
                            new Vector2(-0.5278333f, 1.386016f),
                            new Vector2(1.041466f, 1.384924f),
                            new Vector2(1.499565f, 0.1845545f),
                            new Vector2(1.499649f, -0.6143883f)
                        });
                        BoxCollider2D collider3 = body2.gameObject.AddComponent<BoxCollider2D>();
                        collider3.offset = new Vector2(-0.2462864f, 0.2933933f);
                        collider3.size = new Vector2(0.2338066f, 1.442909f);
                        BoxCollider2D collider4 = body2.gameObject.AddComponent<BoxCollider2D>();
                        collider4.offset = new Vector2(0.05560207f, -0.2966778f);
                        collider4.size = new Vector2(0.7293339f, 0.2595994f);
                        BoxCollider2D collider5 = body2.gameObject.AddComponent<BoxCollider2D>();
                        collider5.offset = new Vector2(0.0428648f, -0.4884115f);
                        collider5.size = new Vector2(0.4581356f, 0.3809508f);

                        body2.gameObject.AddComponent<Optout>();

                        door.localPosition = new Vector3(3.314236f, 1.67136f);
                        door.gameObject.name = "Door";
                        door.gameObject.AddComponent<Optout>();
                        door.GetComponent<FixedJoint2D>().connectedBody = body2.GetComponent<Rigidbody2D>();
                        door.GetComponent<HingeJoint2D>().connectedBody = body2.GetComponent<Rigidbody2D>();
                        door.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-1.042865f, 1.471429f),
                            new Vector2(-1.040095f, -0.8447788f),
                            new Vector2(-0.6768951f, -0.8437735f),
                            new Vector2(-0.1882877f, -1.047096f),
                            new Vector2(0.1591494f, -1.471429f),
                            new Vector2(1.042857f, -1.471429f),
                            new Vector2(1.042857f, 0.2650303f),
                            new Vector2(0.5563124f, 1.471924f)
                        });

                        door.gameObject.AddComponent<Optout>();

                        GameObject mirror = new GameObject("Mirror");
                        mirror.transform.parent = Instance.transform;
                        mirror.transform.rotation = door.rotation;
                        mirror.transform.localScale = Vector3.one;
                        mirror.transform.localPosition = new Vector3(4.141f, 2.18f);
                        SpriteRenderer mirrorRenderer = mirror.gameObject.AddComponent<SpriteRenderer>();
                        mirrorRenderer.sprite = ModAPI.LoadSprite("Textures/Cars/KamAZ-5410/Mirror.png");
                        mirrorRenderer.sortingOrder = door.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        mirrorRenderer.sortingLayerName = door.GetComponent<SpriteRenderer>().sortingLayerName;
                        mirror.layer = 9;
                        mirror.AddComponent<BoxCollider2D>();
                        mirror.AddComponent<Rigidbody2D>().mass = 1f;
                        FixedJoint2D mirrorFixedJoint = mirror.AddComponent<FixedJoint2D>();
                        mirrorFixedJoint.connectedBody = door.GetComponent<Rigidbody2D>();
                        mirrorFixedJoint.frequency = 8f;
                        mirrorFixedJoint.dampingRatio = 1f;
                        mirrorFixedJoint.breakForce = 500f;
                        mirrorFixedJoint.anchor = new Vector2(0.01333714f, -0.3564899f);
                        mirror.AddComponent<JointSerialisationHelper>().Joint = mirrorFixedJoint;
                        mirror.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        mirror.AddComponent<AudioSourceTimeScaleBehaviour>();
                        mirror.AddComponent<Optout>();

                        Instance.transform.GetChild(6).gameObject.SetActive(false);

                        Transform gastank = Instance.transform.GetChild(8);
                        SpriteRenderer gastankRenderer = gastank.GetComponent<SpriteRenderer>();
                        gastankRenderer.sprite = ModAPI.LoadSprite("Textures/Cars/KamAZ-5410/Gastank.png");
                        gastankRenderer.sortingOrder = body.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        gastankRenderer.sortingLayerName = body.GetComponent<SpriteRenderer>().sortingLayerName;
                        PhysicalBehaviour gastankPhys = gastank.GetComponent<PhysicalBehaviour>();
                        gastankPhys.TrueInitialMass = 6f;
                        gastankPhys.InitialMass = 6f;
                        gastankPhys.rigidbody.mass = 6f;
                        gastank.GetComponent<BoxCollider2D>().size = new Vector3(1.657143f, 0.5428572f);

                        GameObject towbar = new GameObject("Towbar");
                        towbar.transform.parent = body;
                        towbar.transform.rotation = body.rotation;
                        towbar.transform.localScale = Vector3.one;
                        towbar.transform.localPosition = new Vector3(-2.5267f, 0.39999f);
                        SpriteRenderer towbarRenderer = towbar.AddComponent<SpriteRenderer>();
                        towbarRenderer.sprite = ModAPI.LoadSprite("Textures/Cars/KamAZ-5410/Towbar.png");
                        towbarRenderer.sortingLayerName = body.GetComponent<SpriteRenderer>().sortingLayerName;
                        towbar.layer = 9;
                        towbar.AddComponent<BoxCollider2D>();
                        towbar.AddComponent<Rigidbody2D>().mass = 8f;
                        towbar.AddComponent<FixedJoint2D>().connectedBody = body.GetComponent<Rigidbody2D>();
                        PhysicalBehaviour towbarPhys = towbar.AddComponent<PhysicalBehaviour>();
                        towbarPhys.SpawnSpawnParticles = false;
                        towbarPhys.Properties = body.GetComponent<PhysicalBehaviour>().Properties;
                        towbar.AddComponent<TowbarBehaviour>().Anchor = new Vector2(0f, 0.2571428f);
                        towbar.AddComponent<AudioSourceTimeScaleBehaviour>();
                        towbar.AddComponent<Optout>();

                        body.gameObject.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[]
                        {
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/KamAZ-5410/Frame.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/KamAZ-5410/FrameBackground.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/KamAZ-5410/BlueColor/Body.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/KamAZ-5410/BlueColor/Door.png")
                            },
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/KamAZ-5410/Frame.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/KamAZ-5410/FrameBackground.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/KamAZ-5410/RedColor/Body.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/KamAZ-5410/RedColor/Door.png")
                            },
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/KamAZ-5410/Frame.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/KamAZ-5410/FrameBackground.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/KamAZ-5410/YellowColor/Body.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/KamAZ-5410/YellowColor/Door.png")
                            }
                        };

                        CarSerialisationHelper carSerialisationHelper = Instance.AddComponent<CarSerialisationHelper>();
                        carSerialisationHelper.AfterFirstSpawn = () =>
                        {
                            wheels[0].connectedBody.transform.localPosition = new Vector3(-1.8f, -0.42f);
                            wheels[0].connectedBody.transform.localScale = new Vector3(1.12f, 1.12f);
                            wheels[1].connectedBody.transform.localPosition = new Vector3(2.4f, -0.42f);
                            wheels[1].connectedBody.transform.localScale = new Vector3(1.12f, 1.12f);
                            gastank.localPosition = new Vector3(0.308f, -0.159f);

                            Transform engine = Instance.transform.GetChild(7);
                            engine.localScale = new Vector3(1.3f, 1.3f);
                            engine.localPosition = new Vector3(2.45f, 0.38f);

                            Instance.AddComponent<ObjectSerialisationHelper>().Object = body2.gameObject;
                            Instance.AddComponent<ObjectSerialisationHelper>().Object = door.gameObject;
                            Instance.AddComponent<ObjectSerialisationHelper>().Object = wheel;
                            Instance.AddComponent<ObjectSerialisationHelper>().Object = mirror;
                        };
                        carSerialisationHelper.AfterSpawn = () =>
                        {
                            carSerialisationHelper.carOptics.Headlights = new GameObject[]
                            {
                                headlight.gameObject
                            };
                            carSerialisationHelper.carOptics.TurnSignals = new GameObject[]
                            {
                                turnSignal
                            };
                            carSerialisationHelper.carOptics.UpdateActivation();
                        };
                        carSerialisationHelper.Left = () =>
                        {
                            body.GetComponent<Rigidbody2D>().centerOfMass = new Vector2(2.67f, -0.18f);
                        };

                        NoCollide noCollide = Instance.GetComponent<NoCollide>();
                        noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                        noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Trailer" +tag,
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "You can attach it to KamAZ-5410.",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/Cars/Trailer/Thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        UnityEngine.Object.Destroy(Instance.GetComponent<GlowingHotMetalBehaviour>());
                        UnityEngine.Object.Destroy(Instance.GetComponent<PhysicalBehaviour>());
                        UnityEngine.Object.Destroy(Instance.GetComponent<ContextMenuOptionComponent>());
                        UnityEngine.Object.Destroy(Instance.GetComponent<SpriteRenderer>());
                        UnityEngine.Object.Destroy(Instance.GetComponent<Rigidbody2D>());
                        UnityEngine.Object.Destroy(Instance.GetComponent<BoxCollider2D>());
                        UnityEngine.Object.Destroy(Instance.GetComponent<AudioSource>());
                        UnityEngine.Object.Destroy(Instance.GetComponent<AudioSource>());

                        GameObject container = new GameObject("Container");
                        container.transform.parent = Instance.transform;
                        container.transform.rotation = Instance.transform.rotation;
                        container.transform.localScale = Vector3.one;
                        container.transform.localPosition = Vector3.zero;
                        SpriteRenderer containerRenderer = container.AddComponent<SpriteRenderer>();
                        containerRenderer.sprite = ModAPI.LoadSprite("Textures/Cars/Trailer/Container.png");
                        containerRenderer.sortingOrder = 10;
                        containerRenderer.sortingLayerName = "Foreground";
                        container.layer = 9;
                        BoxCollider2D collider1 = container.AddComponent<BoxCollider2D>();
                        collider1.offset = new Vector2(0f, 2.056987f);
                        collider1.size = new Vector2(13.37143f, 0.1145964f);
                        BoxCollider2D collider2 = container.AddComponent<BoxCollider2D>();
                        collider2.offset = new Vector2(6.628792f, 0.2329054f);
                        collider2.size = new Vector2(0.1138458f, 3.76276f);
                        BoxCollider2D collider3 = container.AddComponent<BoxCollider2D>();
                        collider3.offset = new Vector2(0f, -1.657508f);
                        collider3.size = new Vector2(13.37143f, 0.2281466f);
                        BoxCollider2D collider4 = container.AddComponent<BoxCollider2D>();
                        collider4.offset = new Vector2(-4.114307f, -1.873653f);
                        collider4.size = new Vector2(4.457176f, 0.4670568f);
                        BoxCollider2D collider5 = container.AddComponent<BoxCollider2D>();
                        collider5.offset = new Vector2(-6.628533f, -1.399221f);
                        collider5.size = new Vector2(0.1143608f, 0.510725f);
                        container.AddComponent<Rigidbody2D>().mass = 20f;
                        container.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindSpawnable("Car").Prefab.transform.GetChild(0).gameObject.GetComponent<PhysicalBehaviour>().Properties;
                        container.AddComponent<AudioSourceTimeScaleBehaviour>();
                        container.AddComponent<Optout>();

                        GameObject background = new GameObject("Background");
                        background.transform.parent = container.transform;
                        background.transform.rotation = container.transform.rotation;
                        background.transform.localScale = Vector3.one;
                        background.transform.localPosition = new Vector3(-4.114337f, -2.542856f);
                        SpriteRenderer backgroundRenderer = background.AddComponent<SpriteRenderer>();
                        backgroundRenderer.sprite = ModAPI.LoadSprite("Textures/Cars/Trailer/Background.png");
                        backgroundRenderer.sortingLayerName = "Bottom";
                        background.AddComponent<Optout>();

                        GameObject towbar = new GameObject("Towbar");
                        towbar.transform.parent = container.transform;
                        towbar.transform.rotation = container.transform.rotation;
                        towbar.transform.localScale = Vector3.one;
                        towbar.transform.localPosition = new Vector3(3.8281f, -1.827f);
                        towbar.AddComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Cars/Trailer/Towbar.png");
                        towbar.layer = 9;
                        towbar.AddComponent<BoxCollider2D>();
                        towbar.AddComponent<Rigidbody2D>().mass = 5f;
                        towbar.AddComponent<FixedJoint2D>().connectedBody = container.GetComponent<Rigidbody2D>();
                        towbar.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindSpawnable("Car").Prefab.transform.GetChild(0).gameObject.GetComponent<PhysicalBehaviour>().Properties;
                        TowbarBehaviour towbarBehaviour = towbar.GetOrAddComponent<TowbarBehaviour>();
                        towbarBehaviour.IsTrailerTowbar = true;
                        towbarBehaviour.Anchor = new Vector2(0f, -0.05714297f);
                        towbar.AddComponent<AudioSourceTimeScaleBehaviour>();
                        towbar.AddComponent<Optout>();

                        GameObject bumper = new GameObject("Bumper");
                        bumper.transform.parent = Instance.transform;
                        bumper.transform.rotation = Instance.transform.rotation;
                        bumper.transform.localScale = Vector3.one;
                        bumper.transform.localPosition = new Vector3(-6.6143f, -2.21427f);
                        SpriteRenderer bumperRenderer = bumper.AddComponent<SpriteRenderer>();
                        bumperRenderer.sprite = ModAPI.LoadSprite("Textures/Cars/Trailer/Bumper.png");
                        bumperRenderer.sortingLayerName = "Default";
                        bumper.layer = 9;
                        bumper.AddComponent<BoxCollider2D>();
                        bumper.AddComponent<Rigidbody2D>().mass = 4f;
                        FixedJoint2D fixedJoint1 = bumper.AddComponent<FixedJoint2D>();
                        fixedJoint1.connectedBody = container.GetComponent<Rigidbody2D>();
                        fixedJoint1.frequency = 8f;
                        fixedJoint1.dampingRatio = 1f;
                        fixedJoint1.breakForce = 10000f;
                        fixedJoint1.anchor = new Vector2(0f, 0.442857f);
                        bumper.AddComponent<JointSerialisationHelper>().Joint = fixedJoint1;
                        bumper.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        bumper.AddComponent<AudioSourceTimeScaleBehaviour>();
                        bumper.AddComponent<Optout>();

                        GameObject supportFootPart1 = new GameObject("Support Foot Part 1");
                        supportFootPart1.transform.parent = Instance.transform;
                        supportFootPart1.transform.rotation = Instance.transform.rotation;
                        supportFootPart1.transform.localScale = Vector3.one;
                        supportFootPart1.transform.localPosition = new Vector3(0.7458f, -2.2999f);
                        SpriteRenderer supportFootPart1Renderer = supportFootPart1.AddComponent<SpriteRenderer>();
                        supportFootPart1Renderer.sprite = ModAPI.LoadSprite("Textures/Cars/Trailer/SupportFootPart1.png");
                        supportFootPart1Renderer.sortingOrder = 2;
                        supportFootPart1Renderer.sortingLayerName = "Default";
                        supportFootPart1.layer = 9;
                        supportFootPart1.AddComponent<BoxCollider2D>();
                        supportFootPart1.AddComponent<Rigidbody2D>().mass = 3f;
                        FixedJoint2D fixedJoint2 = supportFootPart1.AddComponent<FixedJoint2D>();
                        fixedJoint2.connectedBody = container.GetComponent<Rigidbody2D>();
                        fixedJoint2.breakForce = 20000f;
                        supportFootPart1.AddComponent<JointSerialisationHelper>().Joint = fixedJoint2;
                        supportFootPart1.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        supportFootPart1.AddComponent<AudioSourceTimeScaleBehaviour>();
                        DamagableMachineryBehaviour damagable = supportFootPart1.AddComponent<DamagableMachineryBehaviour>();
                        damagable.FirearmDamageMultiplier = 1f;
                        damagable.ExplosionDamageMultiplier = 5f;
                        damagable.Health = 20f;
                        damagable.GameObjectsToToggle = new GameObject[0];
                        damagable.Waterproof = false;

                        GameObject supportFootPart2 = new GameObject("Support Foot Part 2");
                        supportFootPart2.transform.parent = supportFootPart1.transform;
                        supportFootPart2.transform.rotation = Instance.transform.rotation;
                        supportFootPart2.transform.localScale = Vector3.one;
                        supportFootPart2.transform.localPosition = new Vector3(-5.2e-05f, -0.942911f);
                        SpriteRenderer supportFootPart2Renderer = supportFootPart2.AddComponent<SpriteRenderer>();
                        supportFootPart2Renderer.sprite = ModAPI.LoadSprite("Textures/Cars/Trailer/SupportFootPart2.png");
                        supportFootPart2Renderer.sortingLayerName = "Default";
                        supportFootPart2.layer = 9;
                        supportFootPart2.AddComponent<BoxCollider2D>();
                        supportFootPart2.AddComponent<Rigidbody2D>().mass = 3f;
                        SliderJoint2D sliderJoint = supportFootPart1.AddComponent<SliderJoint2D>();
                        sliderJoint.connectedBody = supportFootPart2.GetComponent<Rigidbody2D>();
                        sliderJoint.anchor = Vector2.zero;
                        sliderJoint.angle = 180f;
                        sliderJoint.motor = new JointMotor2D
                        {
                            maxMotorTorque = Mathf.Infinity
                        };
                        sliderJoint.limits = new JointTranslationLimits2D
                        {
                            min = 0.05f,
                            max = 0.95f
                        };
                        supportFootPart2.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        SupportFootBehaviour supportFootBehaviour = supportFootPart1.AddComponent<SupportFootBehaviour>();
                        supportFootBehaviour.SliderJoint = sliderJoint;
                        supportFootPart2.AddComponent<AudioSourceTimeScaleBehaviour>();
                        supportFootPart2.AddComponent<Optout>();

                        damagable.BehavioursToToggle = new MonoBehaviour[]
                        {
                            supportFootBehaviour
                        };
                        damagable.OnDamaged = new UnityEvent();
                        damagable.OnDamaged.AddListener(() =>
                        {
                            sliderJoint.motor = new JointMotor2D()
                            {
                                motorSpeed = 0f,
                                maxMotorTorque = 0f
                            };
                        });
                        damagable.OnRepaired = new UnityEvent();
                        damagable.OnRepaired.AddListener(() =>
                        {
                            sliderJoint.motor = new JointMotor2D()
                            {
                                maxMotorTorque = Mathf.Infinity
                            };
                        });
                        damagable.gameObject.AddComponent<Optout>();

                        GameObject wheel1 = new GameObject("Wheel1");
                        wheel1.transform.parent = Instance.transform;
                        wheel1.transform.rotation = Instance.transform.rotation;
                        wheel1.transform.localScale = new Vector3(1.12f, 1.12f);
                        wheel1.transform.localPosition = new Vector3(-3.303337f, -2.918703f);
                        SpriteRenderer wheel1Renderer = wheel1.AddComponent<SpriteRenderer>();
                        wheel1Renderer.sprite = ModAPI.FindSpawnable("Truck").Prefab.transform.GetChild(0).GetChild(0).GetComponent<SpriteRenderer>().sprite;
                        wheel1Renderer.sortingOrder = containerRenderer.sortingOrder - 1;
                        wheel1Renderer.sortingLayerName = containerRenderer.sortingLayerName;
                        wheel1.layer = 9;
                        wheel1.AddComponent<CircleCollider2D>();
                        wheel1.AddComponent<Rigidbody2D>().mass = 1f;
                        WheelJoint2D wheelJoint1 = container.AddComponent<WheelJoint2D>();
                        wheelJoint1.anchor = new Vector2(-3.303337f, -2.918703f);
                        wheelJoint1.breakForce = 15000f;
                        wheelJoint1.connectedBody = wheel1.GetComponent<Rigidbody2D>();
                        wheelJoint1.motor = new JointMotor2D
                        {
                            maxMotorTorque = 300f
                        };
                        wheelJoint1.suspension = new JointSuspension2D
                        {
                            angle = 90f,
                            dampingRatio = 1f,
                            frequency = 10f
                        };
                        wheelJoint1.useMotor = true;
                        container.AddComponent<JointSerialisationHelper>().Joint = wheelJoint1;
                        wheel1.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Rubber");
                        wheel1.AddComponent<AudioSourceTimeScaleBehaviour>();
                        wheel1.AddComponent<Optout>();

                        GameObject wheel2 = new GameObject("Wheel2");
                        wheel2.transform.parent = Instance.transform;
                        wheel2.transform.rotation = Instance.transform.rotation;
                        wheel2.transform.localScale = new Vector3(1.12f, 1.12f);
                        wheel2.transform.localPosition = new Vector3(-4.925337f, -2.918703f);
                        SpriteRenderer wheel2Renderer = wheel2.AddComponent<SpriteRenderer>();
                        wheel2Renderer.sprite = ModAPI.FindSpawnable("Truck").Prefab.transform.GetChild(0).GetChild(0).GetComponent<SpriteRenderer>().sprite;
                        wheel2Renderer.sortingOrder = containerRenderer.sortingOrder - 1;
                        wheel2Renderer.sortingLayerName = containerRenderer.sortingLayerName;
                        wheel2.layer = 9;
                        wheel2.AddComponent<CircleCollider2D>();
                        wheel2.AddComponent<Rigidbody2D>().mass = 1f;
                        WheelJoint2D wheelJoint2 = container.AddComponent<WheelJoint2D>();
                        wheelJoint2.anchor = new Vector2(-4.925337f, -2.918703f);
                        wheelJoint2.breakForce = 15000f;
                        wheelJoint2.connectedBody = wheel2.GetComponent<Rigidbody2D>();
                        wheelJoint2.motor = new JointMotor2D
                        {
                            maxMotorTorque = 300f
                        };
                        wheelJoint2.suspension = new JointSuspension2D
                        {
                            angle = 90f,
                            dampingRatio = 1f,
                            frequency = 10f
                        };
                        wheelJoint2.useMotor = true;
                        container.AddComponent<JointSerialisationHelper>().Joint = wheelJoint2;
                        wheel2.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Rubber");
                        wheel2.AddComponent<AudioSourceTimeScaleBehaviour>();
                        wheel2.AddComponent<Optout>();

                        TrailerBehaviour trailer = container.AddComponent<TrailerBehaviour>();
                        trailer.TowbarBehaviour = towbarBehaviour;
                        trailer.Wheels = container.GetComponents<WheelJoint2D>();
                        trailer.SupportFoot = supportFootBehaviour;

                        CarSerialisationHelper carSerialisationHelper = Instance.AddComponent<CarSerialisationHelper>();
                        carSerialisationHelper.AfterFirstSpawn = () =>
                        {
                            Instance.AddComponent<ObjectSerialisationHelper>().Object = container;
                            Instance.AddComponent<ObjectSerialisationHelper>().Object = bumper;
                            Instance.AddComponent<ObjectSerialisationHelper>().Object = supportFootPart1;
                            Instance.AddComponent<ObjectSerialisationHelper>().Object = supportFootPart2;
                            Instance.AddComponent<ObjectSerialisationHelper>().Object = wheel1;
                            Instance.AddComponent<ObjectSerialisationHelper>().Object = wheel2;
                        };

                        NoCollide noCollide = Instance.GetOrAddComponent<NoCollide>();
                        noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                        noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Car"),
                    NameOverride = "Ford Crown Victoria" +tag,
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "American four-seat full-size rear-wheel drive sedan with a frame chassis, produced from 1991 to 2011.",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/Thumb.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Transform body = Instance.transform.GetChild(0);
                        BoxCollider2D[] boxColliders = body.GetComponents<BoxCollider2D>();
                        boxColliders[0].offset = new Vector2(-1.109245f, -0.7098498f);
                        boxColliders[0].size = new Vector2(0.6141787f, 0.3565912f);
                        boxColliders[1].offset = new Vector2(0.1289096f, -0.7024093f);
                        boxColliders[1].size = new Vector2(0.7193098f, 0.3670492f);
                        boxColliders[2].offset = new Vector2(-1.565375f, -0.04685879f);
                        boxColliders[2].size = new Vector2(0.3069048f, 1.172821f);
                        boxColliders[3].offset = new Vector2(-0.182754f, 0.05844641f);
                        boxColliders[3].size = new Vector2(0.2466841f, 1.228509f);
                        body.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(3.185663f, -0.9714276f),
                            new Vector2(3.757149f, -0.8567454f),
                            new Vector2(3.757144f, -0.3715542f),
                            new Vector2(3.527358f, -0.03142194f),
                            new Vector2(3.426147f, -0.1706514f),
                            new Vector2(1.911986f, -0.1707306f),
                            new Vector2(1.773367f, 0.1989212f),
                            new Vector2(1.554763f, 0.2378535f),
                            new Vector2(1.115627f, 0.6039464f),
                            new Vector2(0.6578842f, 0.8850195f),
                            new Vector2(0.09945774f, 0.9713602f),
                            new Vector2(-0.9570971f, 0.9719434f),
                            new Vector2(-1.611534f, 0.8831856f),
                            new Vector2(-1.868014f, 0.7379428f),
                            new Vector2(-2.297083f, 0.2813388f),
                            new Vector2(-2.57194f, -0.3414292f),
                            new Vector2(-3.729291f, -0.3409923f),
                            new Vector2(-3.871582f, -0.4034667f),
                            new Vector2(-3.872947f, -0.7684664f),
                            new Vector2(-3.78304f, -0.8540244f),
                            new Vector2(-2.871483f, -0.9714276f)
                        });
                        body.GetComponent<PolygonCollider2D>().SetPath(1, new Vector2[]
                        {
                            new Vector2(-1.270739f, -0.6419963f),
                            new Vector2(-1.751979f, -0.03752166f),
                            new Vector2(-1.777454f, 0.2506431f),
                            new Vector2(-1.417542f, 0.8557708f),
                            new Vector2(0.4993168f, 0.8566883f),
                            new Vector2(1.529173f, 0.1971864f),
                            new Vector2(1.528283f, -0.8572918f),
                            new Vector2(-1.271488f, -0.8571992f)
                        });
                        body.GetChild(0).localPosition = new Vector3(0.2428579f, -0.0285669f);

                        WheelJoint2D[] wheels = body.GetComponents<WheelJoint2D>();
                        wheels[0].anchor = new Vector2(2.498f, -0.842f);
                        wheels[0].connectedBody.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/Wheel.png");
                        wheels[1].anchor = new Vector2(-2.017f, -0.842f);
                        wheels[1].connectedBody.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/Wheel.png");

                        GameObject headlight = new GameObject("Headlight");
                        headlight.transform.parent = body;
                        headlight.transform.rotation = body.rotation;
                        headlight.transform.localPosition = new Vector3(3.428513f, -0.228559f, 0f);
                        headlight.transform.localScale = new Vector3(1f, 1f, 1f);
                        SpriteRenderer headlightRenderer = headlight.GetOrAddComponent<SpriteRenderer>();
                        headlightRenderer.sprite = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/Headlight.png");
                        headlightRenderer.sortingOrder = body.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        headlight.AddComponent<Optout>();
                        ModAPI.CreateLight(headlight.transform, Color.white, 4f, 1.5f);
                        headlight.SetActive(false);

                        GameObject taillight = new GameObject("Taillight");
                        taillight.transform.parent = body;
                        taillight.transform.rotation = body.rotation;
                        taillight.transform.localPosition = new Vector3(-3.600053f, -0.0143395f, 0f);
                        taillight.transform.localScale = new Vector3(1f, 1f, 1f);
                        SpriteRenderer taillightRenderer = taillight.GetOrAddComponent<SpriteRenderer>();
                        taillightRenderer.sprite = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/Taillight.png");
                        taillightRenderer.sortingOrder = body.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        taillight.AddComponent<Optout>();
                        ModAPI.CreateLight(taillight.transform, Color.red, 4f, 1.5f);
                        taillight.SetActive(false);

                        GameObject turnSignal = new GameObject("Turn Signal");
                        turnSignal.transform.parent = body;
                        turnSignal.transform.rotation = body.rotation;
                        turnSignal.transform.localPosition = new Vector3(3.357033f, -0.2286191f, 0f);
                        turnSignal.transform.localScale = new Vector3(1f, 1f, 1f);
                        SpriteRenderer turnSignalRenderer = turnSignal.GetOrAddComponent<SpriteRenderer>();
                        turnSignalRenderer.sprite = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/TurnSignal.png");
                        turnSignalRenderer.sortingOrder = body.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        turnSignal.AddComponent<Optout>();
                        ModAPI.CreateLight(turnSignal.transform, new Color32(255, 146, 0, 255), 2f, 1f);
                        turnSignal.SetActive(false);

                        Transform bonnet = Instance.transform.GetChild(3);
                        bonnet.GetComponent<HingeJoint2D>().anchor = new Vector2(-0.968627f, 0.1274662f);
                        bonnet.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.0295496f, 0.1156359f),
                            new Vector2(-0.9714286f, 0.1571429f),
                            new Vector2(-0.9714457f, 0.1009738f),
                            new Vector2(-0.2341142f, 0.06994343f),
                            new Vector2(0.566185f, -0.06477737f),
                            new Vector2(0.9147415f, -0.1564877f),
                            new Vector2(0.9722034f, -0.156457f),
                            new Vector2(0.9104564f, -0.07180859f)
                        });

                        Transform boot = Instance.transform.GetChild(4);
                        boot.GetComponent<HingeJoint2D>().anchor = new Vector2(0.7391396f, 0.2849712f);
                        BoxCollider2D collider1 = boot.GetComponent<BoxCollider2D>();
                        collider1.offset = new Vector3(-0.695933f, -0.1282277f);
                        collider1.size = new Vector3(0.09384847f, 0.08699512f);
                        boot.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.5408741f, 0.2304043f),
                            new Vector2(-0.6252663f, 0.1166591f),
                            new Vector2(-0.6855795f, -0.3142857f),
                            new Vector2(-0.6258167f, -0.3142857f),
                            new Vector2(-0.5501909f, 0.1585217f),
                            new Vector2(0.7394573f, 0.2598256f),
                            new Vector2(0.7428572f, 0.3142857f)
                        });

                        LightSprite reversingLamp = ModAPI.CreateLight(boot, Color.white, 1f, 1f);
                        reversingLamp.transform.localPosition = new Vector3(-0.6440883f, -0.03637658f);

                        Transform frontDoor = Instance.transform.GetChild(5);
                        frontDoor.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.1371212f, 0.8572855f),
                            new Vector2(-0.5434418f, 0.8856862f),
                            new Vector2(-0.9142857f, 0.8857143f),
                            new Vector2(-0.7665864f, -0.01718572f),
                            new Vector2(-0.7682474f, -0.8863561f),
                            new Vector2(0.9142857f, -0.8857143f),
                            new Vector2(0.9142857f, -0.002121955f),
                            new Vector2(0.7692806f, 0.2652609f)
                        });

                        Transform backDoor = Instance.transform.GetChild(6);
                        backDoor.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(0.7285714f, 0.8857143f),
                            new Vector2(-0.4270734f, 0.8857143f),
                            new Vector2(-0.8143019f, 0.2284377f),
                            new Vector2(-0.8143387f, -0.0568924f),
                            new Vector2(-0.4355482f, -0.3771335f),
                            new Vector2(-0.2788066f, -0.8857143f),
                            new Vector2(0.8142857f, -0.8857143f),
                            new Vector2(0.8142857f, 0.3714286f),
                            new Vector2(0.7857143f, 0.5714286f)
                        });

                        RandomCarTextureBehaviour randomCarTextures = body.GetComponent<RandomCarTextureBehaviour>();
                        randomCarTextures.Textures = new RandomCarTextureBehaviour.CarSprites[]
                        {
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/BlackColor/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/BlackColor/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/BlackColor/Bonnet.png"),
                                Boot = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/BlackColor/Boot.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/BlackColor/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/BlackColor/BackDoor.png")
                            },
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/BlueColor/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/BlueColor/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/BlueColor/Bonnet.png"),
                                Boot = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/BlueColor/Boot.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/BlueColor/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/BlueColor/BackDoor.png")
                            },
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/GrayColor/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/GrayColor/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/GrayColor/Bonnet.png"),
                                Boot = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/GrayColor/Boot.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/GrayColor/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/GrayColor/BackDoor.png")
                            },
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/GreenColor/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/GreenColor/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/GreenColor/Bonnet.png"),
                                Boot = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/GreenColor/Boot.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/GreenColor/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/GreenColor/BackDoor.png")
                            },
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/RedColor/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/RedColor/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/RedColor/Bonnet.png"),
                                Boot = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/RedColor/Boot.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/RedColor/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/RedColor/BackDoor.png")
                            },
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/TaxiSkin/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/TaxiSkin/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/TaxiSkin/Bonnet.png"),
                                Boot = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/TaxiSkin/Boot.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/TaxiSkin/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/TaxiSkin/BackDoor.png")
                            }
                        };

                        Sprite leftFrontDoor = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/TaxiSkin/FrontDoor2.png");
                        CarSerialisationHelper carSerialisationHelper = Instance.AddComponent<CarSerialisationHelper>();
                        carSerialisationHelper.AfterFirstSpawn = () =>
                        {
                            body.GetComponent<CarBehaviour>().MotorSpeed = -4100f;

                            wheels[0].connectedBody.transform.localPosition = new Vector3(2.498f, -0.842f);
                            wheels[1].connectedBody.transform.localPosition = new Vector3(-2.017f, -0.842f);
                            bonnet.localPosition = new Vector3(2.557092f, 0.071427f);
                            boot.localPosition = new Vector3(-3.042912f, -0.028623f);
                            frontDoor.localPosition = new Vector3(0.642853f, -5.46e-05f);
                            backDoor.localPosition = new Vector3(-0.971439f, -3e-06f);
                            Instance.transform.GetChild(7).localPosition = new Vector3(2.522f, -0.333f);
                            Instance.transform.GetChild(8).localPosition = new Vector3(-2.082f, -0.435f);
                        };
                        carSerialisationHelper.AfterSpawn = () =>
                        {
                            carSerialisationHelper.carOptics.Headlights = new GameObject[]
                            {
                                headlight,
                                taillight
                            };
                            carSerialisationHelper.carOptics.TurnSignals = new GameObject[]
                            {
                                turnSignal
                            };
                            carSerialisationHelper.carOptics.ReversingLamp = reversingLamp.gameObject;
                            carSerialisationHelper.carOptics.UpdateActivation();
                        };
                        carSerialisationHelper.Left = () =>
                        {
                            randomCarTextures.Textures[5].FrontDoor = leftFrontDoor;
                            if (randomCarTextures.chosenIndex == 5)
                            {
                                frontDoor.GetComponent<SpriteRenderer>().sprite = randomCarTextures.Textures[5].FrontDoor;
                            }
                        };

                        NoCollide noCollide = Instance.GetComponent<NoCollide>();
                        noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                        noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Car"),
                    NameOverride = "Ford Crown Victoria Police" +tag,
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "Police version of the Ford Crown Victoria.",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/Thumb2.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Transform body = Instance.transform.GetChild(0);
                        BoxCollider2D[] boxColliders = body.gameObject.GetComponents<BoxCollider2D>();
                        boxColliders[0].offset = new Vector2(-1.109245f, -0.7098498f);
                        boxColliders[0].size = new Vector2(0.6141787f, 0.3565912f);
                        boxColliders[1].offset = new Vector2(0.1289096f, -0.7024093f);
                        boxColliders[1].size = new Vector2(0.7193098f, 0.3670492f);
                        boxColliders[2].offset = new Vector2(-1.565375f, -0.04685879f);
                        boxColliders[2].size = new Vector2(0.3069048f, 1.172821f);
                        boxColliders[3].offset = new Vector2(-0.182754f, 0.05844641f);
                        boxColliders[3].size = new Vector2(0.2466841f, 1.228509f);
                        body.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(3.185663f, -0.9714276f),
                            new Vector2(3.757149f, -0.8567454f),
                            new Vector2(3.757144f, -0.3715542f),
                            new Vector2(3.527358f, -0.03142194f),
                            new Vector2(3.426147f, -0.1706514f),
                            new Vector2(1.911986f, -0.1707306f),
                            new Vector2(1.773367f, 0.1989212f),
                            new Vector2(1.554763f, 0.2378535f),
                            new Vector2(1.115627f, 0.6039464f),
                            new Vector2(0.6578842f, 0.8850195f),
                            new Vector2(0.09945774f, 0.9713602f),
                            new Vector2(-0.9570971f, 0.9719434f),
                            new Vector2(-1.611534f, 0.8831856f),
                            new Vector2(-1.868014f, 0.7379428f),
                            new Vector2(-2.297083f, 0.2813388f),
                            new Vector2(-2.57194f, -0.3414292f),
                            new Vector2(-3.729291f, -0.3409923f),
                            new Vector2(-3.871582f, -0.4034667f),
                            new Vector2(-3.872947f, -0.7684664f),
                            new Vector2(-3.78304f, -0.8540244f),
                            new Vector2(-2.871483f, -0.9714276f)
                        });
                        body.gameObject.GetComponent<PolygonCollider2D>().SetPath(1, new Vector2[]
                        {
                            new Vector2(-1.270739f, -0.6419963f),
                            new Vector2(-1.751979f, -0.03752166f),
                            new Vector2(-1.777454f, 0.2506431f),
                            new Vector2(-1.417542f, 0.8557708f),
                            new Vector2(0.4993168f, 0.8566883f),
                            new Vector2(1.529173f, 0.1971864f),
                            new Vector2(1.528283f, -0.8572918f),
                            new Vector2(-1.271488f, -0.8571992f)
                        });
                        body.GetChild(0).localPosition = new Vector3(0.2428579f, -0.0285669f);

                        WheelJoint2D[] wheels = body.gameObject.GetComponents<WheelJoint2D>();
                        wheels[0].anchor = new Vector2(2.498f, -0.842f);
                        wheels[0].connectedBody.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/PoliceSkin/Wheel.png");
                        wheels[1].anchor = new Vector2(-2.017f, -0.842f);
                        wheels[1].connectedBody.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/PoliceSkin/Wheel.png");

                        GameObject headlight = new GameObject("Headlight");
                        headlight.transform.parent = body;
                        headlight.transform.rotation = body.rotation;
                        headlight.transform.localPosition = new Vector3(3.428513f, -0.228559f, 0f);
                        headlight.transform.localScale = new Vector3(1f, 1f, 1f);
                        SpriteRenderer headlightRenderer = headlight.GetOrAddComponent<SpriteRenderer>();
                        headlightRenderer.sprite = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/Headlight.png");
                        headlightRenderer.sortingOrder = body.gameObject.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        headlight.AddComponent<Optout>();
                        ModAPI.CreateLight(headlight.transform, Color.white, 4f, 1.5f);
                        headlight.SetActive(false);

                        GameObject taillight = new GameObject("Taillight");
                        taillight.transform.parent = body;
                        taillight.transform.rotation = body.rotation;
                        taillight.transform.localPosition = new Vector3(-3.600053f, -0.0143395f, 0f);
                        taillight.transform.localScale = new Vector3(1f, 1f, 1f);
                        SpriteRenderer taillightRenderer = taillight.GetOrAddComponent<SpriteRenderer>();
                        taillightRenderer.sprite = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/Taillight.png");
                        taillightRenderer.sortingOrder = body.gameObject.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        taillight.AddComponent<Optout>();
                        ModAPI.CreateLight(taillight.transform, Color.red, 4f, 1.5f);
                        taillight.SetActive(false);

                        GameObject turnSignal = new GameObject("Turn Signal");
                        turnSignal.transform.parent = body;
                        turnSignal.transform.rotation = body.rotation;
                        turnSignal.transform.localPosition = new Vector3(3.357033f, -0.2286191f, 0f);
                        turnSignal.transform.localScale = new Vector3(1f, 1f, 1f);
                        SpriteRenderer turnSignalRenderer = turnSignal.GetOrAddComponent<SpriteRenderer>();
                        turnSignalRenderer.sprite = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/TurnSignal.png");
                        turnSignalRenderer.sortingOrder = body.gameObject.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        turnSignal.AddComponent<Optout>();
                        ModAPI.CreateLight(turnSignal.transform, new Color32(255, 146, 0, 255), 2f, 1f);
                        turnSignal.SetActive(false);

                        Transform bonnet = Instance.transform.GetChild(3);
                        bonnet.gameObject.GetComponent<HingeJoint2D>().anchor = new Vector2(-0.968627f, 0.1274662f);
                        bonnet.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.0295496f, 0.1156359f),
                            new Vector2(-0.9714286f, 0.1571429f),
                            new Vector2(-0.9714457f, 0.1009738f),
                            new Vector2(-0.2341142f, 0.06994343f),
                            new Vector2(0.566185f, -0.06477737f),
                            new Vector2(0.9147415f, -0.1564877f),
                            new Vector2(0.9722034f, -0.156457f),
                            new Vector2(0.9104564f, -0.07180859f)
                        });

                        Transform boot = Instance.transform.GetChild(4);
                        boot.gameObject.GetComponent<HingeJoint2D>().anchor = new Vector2(0.7391396f, 0.2849712f);
                        BoxCollider2D collider1 = boot.gameObject.GetComponent<BoxCollider2D>();
                        collider1.offset = new Vector3(-0.695933f, -0.1282277f);
                        collider1.size = new Vector3(0.09384847f, 0.08699512f);
                        boot.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.5408741f, 0.2304043f),
                            new Vector2(-0.6252663f, 0.1166591f),
                            new Vector2(-0.6855795f, -0.3142857f),
                            new Vector2(-0.6258167f, -0.3142857f),
                            new Vector2(-0.5501909f, 0.1585217f),
                            new Vector2(0.7394573f, 0.2598256f),
                            new Vector2(0.7428572f, 0.3142857f)
                        });

                        LightSprite reversingLamp = ModAPI.CreateLight(boot, Color.white, 1f, 1f);
                        reversingLamp.transform.localPosition = new Vector3(-0.6440883f, -0.03637658f);
                        reversingLamp.gameObject.SetActive(false);

                        Transform frontDoor = Instance.transform.GetChild(5);
                        frontDoor.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.1371212f, 0.8572855f),
                            new Vector2(-0.5434418f, 0.8856862f),
                            new Vector2(-0.9142857f, 0.8857143f),
                            new Vector2(-0.7665864f, -0.01718572f),
                            new Vector2(-0.7682474f, -0.8863561f),
                            new Vector2(0.9142857f, -0.8857143f),
                            new Vector2(0.9142857f, -0.002121955f),
                            new Vector2(0.7692806f, 0.2652609f)
                        });

                        Transform backDoor = Instance.transform.GetChild(6);
                        backDoor.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(0.7285714f, 0.8857143f),
                            new Vector2(-0.4270734f, 0.8857143f),
                            new Vector2(-0.8143019f, 0.2284377f),
                            new Vector2(-0.8143387f, -0.0568924f),
                            new Vector2(-0.4355482f, -0.3771335f),
                            new Vector2(-0.2788066f, -0.8857143f),
                            new Vector2(0.8142857f, -0.8857143f),
                            new Vector2(0.8142857f, 0.3714286f),
                            new Vector2(0.7857143f, 0.5714286f)
                        });

                        GameObject blinker = new GameObject("Blinker");
                        blinker.transform.parent = Instance.transform;
                        blinker.transform.rotation = body.transform.rotation;
                        blinker.transform.localScale = Vector3.one;
                        blinker.transform.localPosition = new Vector3(-0.333f, 1.05708f);
                        SpriteRenderer blinkerRenderer = blinker.AddComponent<SpriteRenderer>();
                        blinkerRenderer.sprite = ModAPI.LoadSprite("Textures/PoliceBlinker.png");
                        blinker.layer = 9;
                        blinker.AddComponent<BoxCollider2D>();
                        blinker.AddComponent<Rigidbody2D>().mass = 1.5f;
                        FixedJoint2D fixedJoint = blinker.AddComponent<FixedJoint2D>();
                        fixedJoint.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                        fixedJoint.breakForce = 5000f;
                        blinker.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Flammable metal");
                        DamagableMachineryBehaviour damagable = blinker.AddComponent<DamagableMachineryBehaviour>();
                        damagable.FirearmDamageMultiplier = 1f;
                        damagable.ExplosionDamageMultiplier = 100f;
                        damagable.Health = 50f;
                        damagable.BehavioursToToggle = new MonoBehaviour[0];
                        damagable.GameObjectsToToggle = new GameObject[0];
                        damagable.Waterproof = false;
                        blinker.AddComponent<JointSerialisationHelper>().Joint = fixedJoint;
                        JointBreakSoundBehaviour jointBreakSound = blinker.AddComponent<JointBreakSoundBehaviour>();
                        jointBreakSound.Clips = boot.GetComponent<JointBreakSoundBehaviour>().Clips;
                        jointBreakSound.AudioSource = blinker.GetComponent<AudioSource>();
                        jointBreakSound.Joints = new Joint2D[]
                        {
                            fixedJoint
                        };
                        jointBreakSound.OnBreak = new UnityEvent();
                        jointBreakSound.OnBreak.AddListener(() =>
                        {
                            jointBreakSound.Joints = new Joint2D[0];
                        });
                        AudioSource audio = blinker.AddComponent<AudioSource>();
                        audio.loop = true;
                        audio.clip = ModAPI.LoadSound("Sounds/PoliceBlinker.mp3");
                        audio.spatialBlend = 1f;
                        blinker.AddComponent<AudioSourceTimeScaleBehaviour>();
                        blinker.AddComponent<Optout>();

                        GameObject glow1 = new GameObject("Glow 1");
                        glow1.transform.parent = blinker.transform;
                        glow1.transform.rotation = blinker.transform.rotation;
                        glow1.transform.localScale = Vector3.one;
                        glow1.transform.localPosition = new Vector3(-0.25714f, 0.014288f);
                        SpriteRenderer glow1Renderer = glow1.AddComponent<SpriteRenderer>();
                        glow1Renderer.sprite = ModAPI.LoadSprite("Textures/PoliceBlinkerGlowMask.png");
                        glow1Renderer.sortingOrder = blinkerRenderer.sortingOrder + 1;
                        glow1Renderer.sortingLayerName = blinkerRenderer.sortingLayerName;
                        glow1Renderer.color = Color.blue;
                        glow1.AddComponent<Optout>();
                        ModAPI.CreateLight(glow1.transform, Color.blue, 15f, 3f);

                        GameObject glow2 = new GameObject("Glow 2");
                        glow2.transform.parent = blinker.transform;
                        glow2.transform.rotation = blinker.transform.rotation;
                        glow2.transform.localScale = new Vector3(-1f, 1f, 1f);
                        glow2.transform.localPosition = new Vector3(0.25714f, 0.014288f);
                        SpriteRenderer glow2Renderer = glow2.AddComponent<SpriteRenderer>();
                        glow2Renderer.sprite = ModAPI.LoadSprite("Textures/PoliceBlinkerGlowMask.png");
                        glow2Renderer.sortingOrder = blinkerRenderer.sortingOrder + 1;
                        glow2Renderer.sortingLayerName = blinkerRenderer.sortingLayerName;
                        glow2Renderer.color = Color.red;
                        glow2.AddComponent<Optout>();
                        ModAPI.CreateLight(glow2.transform, Color.red, 15f, 3f);

                        BlinkerBehaviour blinkerBehaviour = blinker.GetOrAddComponent<BlinkerBehaviour>();
                        blinkerBehaviour.Glow1 = glow1;
                        blinkerBehaviour.Glow2 = glow2;
                        blinkerBehaviour.Audio = audio;
                        blinkerBehaviour.Delay = 1f;

                        GameObject pushbar = new GameObject("Pushbar");
                        pushbar.transform.parent = Instance.transform;
                        pushbar.transform.rotation = body.rotation;
                        pushbar.transform.localScale = Vector3.one;
                        pushbar.transform.localPosition = new Vector3(3.928562f, -0.442858f);
                        pushbar.AddComponent<Optout>();
                        SpriteRenderer pushbarRenderer = pushbar.AddComponent<SpriteRenderer>();
                        pushbarRenderer.sprite = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/PoliceSkin/Pushbar.png");
                        pushbarRenderer.sortingLayerName = "Default";
                        pushbar.layer = 9;
                        pushbar.AddComponent<BoxCollider2D>();
                        pushbar.AddComponent<Rigidbody2D>().mass = 1.8f;
                        FixedJoint2D fixedJoint2 = pushbar.AddComponent<FixedJoint2D>();
                        fixedJoint2.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                        fixedJoint2.frequency = 8f;
                        fixedJoint2.dampingRatio = 1f;
                        fixedJoint2.breakForce = 9000f;
                        fixedJoint2.anchor = new Vector2(-0.09974623f, -0.2850485f);
                        pushbar.AddComponent<JointSerialisationHelper>().Joint = fixedJoint2;
                        JointBreakSoundBehaviour jointBreakSound2 = pushbar.AddComponent<JointBreakSoundBehaviour>();
                        jointBreakSound2.Clips = boot.GetComponent<JointBreakSoundBehaviour>().Clips;
                        jointBreakSound2.AudioSource = pushbar.GetComponent<AudioSource>();
                        jointBreakSound2.Joints = new Joint2D[]
                        {
                            fixedJoint2
                        };
                        jointBreakSound2.OnBreak = new UnityEvent();
                        jointBreakSound2.OnBreak.AddListener(() =>
                        {
                            jointBreakSound2.Joints = new Joint2D[0];
                        });
                        pushbar.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        pushbar.AddComponent<AudioSourceTimeScaleBehaviour>();
                        pushbar.AddComponent<Optout>();

                        RandomCarTextureBehaviour randomCarTextures = body.GetComponent<RandomCarTextureBehaviour>();
                        randomCarTextures.Textures = new RandomCarTextureBehaviour.CarSprites[]
                        {
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/PoliceSkin/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/PoliceSkin/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/PoliceSkin/Bonnet.png"),
                                Boot = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/PoliceSkin/Boot.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/PoliceSkin/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/PoliceSkin/BackDoor.png")
                            }
                        };

                        Sprite leftFrontDoor = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/PoliceSkin/FrontDoor2.png");
                        Sprite leftBackDoor = ModAPI.LoadSprite("Textures/Cars/Ford Crown Victoria/PoliceSkin/BackDoor2.png");
                        CarSerialisationHelper carSerialisationHelper = Instance.AddComponent<CarSerialisationHelper>();
                        carSerialisationHelper.AfterFirstSpawn = () =>
                        {
                            body.gameObject.GetComponent<CarBehaviour>().MotorSpeed = -4450f;

                            wheels[0].connectedBody.transform.localPosition = new Vector3(2.498f, -0.842f);
                            wheels[1].connectedBody.transform.localPosition = new Vector3(-2.017f, -0.842f);
                            bonnet.localPosition = new Vector3(2.557092f, 0.071427f);
                            boot.localPosition = new Vector3(-3.042912f, -0.028623f);
                            frontDoor.localPosition = new Vector3(0.642853f, -5.46e-05f);
                            backDoor.localPosition = new Vector3(-0.971439f, -3e-06f);
                            Instance.transform.GetChild(7).localPosition = new Vector3(2.522f, -0.333f);
                            Instance.transform.GetChild(8).localPosition = new Vector3(-2.082f, -0.435f);

                            Instance.AddComponent<ObjectSerialisationHelper>().Object = blinker;
                            Instance.AddComponent<ObjectSerialisationHelper>().Object = pushbar;
                        };
                        carSerialisationHelper.AfterSpawn = () =>
                        {
                            carSerialisationHelper.carOptics.Headlights = new GameObject[]
                            {
                                headlight,
                                taillight
                            };
                            carSerialisationHelper.carOptics.TurnSignals = new GameObject[]
                            {
                                turnSignal
                            };
                            carSerialisationHelper.carOptics.ReversingLamp = reversingLamp.gameObject;
                            carSerialisationHelper.carOptics.UpdateActivation();
                        };
                        carSerialisationHelper.Left = () =>
                        {
                            randomCarTextures.Textures[0].FrontDoor = leftFrontDoor;
                            randomCarTextures.Textures[0].BackDoor = leftBackDoor;
                            frontDoor.GetComponent<SpriteRenderer>().sprite = leftFrontDoor;
                            backDoor.GetComponent<SpriteRenderer>().sprite = leftBackDoor;
                        };

                        NoCollide noCollide = Instance.GetComponent<NoCollide>();
                        noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                        noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Car"),
                    NameOverride = "Mercedes-Benz G63 AMG" + tag,
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "The Mercedes-Benz G-Class, in American English sometimes called G-Wagon, is a four-wheel drive automobile manufactured by Magna Steyr (formerly Steyr-Daimler-Puch) in Austria and sold by Mercedes-Benz. Originally developed as a military off-roader, later more luxurious models were added to the line. In certain markets, it has been sold under the Puch name as Puch G.",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/Cars/Mercedes-Benz G63 AMG/Thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Transform body = Instance.transform.GetChild(0);
                        BoxCollider2D[] boxColliders = body.GetComponents<BoxCollider2D>();
                        boxColliders[0].offset = new Vector2(-1.3508f, -0.7637405f);
                        boxColliders[0].size = new Vector2(0.8158751f, 0.3957253f);
                        boxColliders[1].offset = new Vector2(-1.702761f, -0.04226589f);
                        boxColliders[1].size = new Vector2(0.3056898f, 1.208536f);
                        boxColliders[2].offset = new Vector2(0.06658506f, -0.7582121f);
                        boxColliders[2].size = new Vector2(0.6682787f, 0.4086018f);
                        boxColliders[3].offset = new Vector2(-0.2648792f, 0.01774502f);
                        boxColliders[3].size = new Vector2(0.2194366f, 1.275328f);
                        body.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(1.471359f, -1.14286f),
                            new Vector2(3.528589f, -1.057146f),
                            new Vector2(3.528571f, -0.6286302f),
                            new Vector2(3.471097f, -0.1143048f),
                            new Vector2(1.729225f, -0.2565899f),
                            new Vector2(0.8713696f, 1.057084f),
                            new Vector2(0.299943f, 1.142857f),
                            new Vector2(-3.100055f, 1.142857f),
                            new Vector2(-3.414341f, -5.662441e-05f),
                            new Vector2(-3.414341f, -1.057199f),
                            new Vector2(-1.300052f, -1.142859f)
                        });
                        body.GetComponent<PolygonCollider2D>().SetPath(1, new Vector2[]
                        {
                            new Vector2(-1.671483f, -0.3143423f),
                            new Vector2(-1.671484f, 0.9713657f),
                            new Vector2(0.785654f, 0.9713714f),
                            new Vector2(1.271368f, 0.2856579f),
                            new Vector2(1.271368f, -0.914341f),
                            new Vector2(-1.242911f, -0.9143411f)
                        });
                        body.GetChild(0).localPosition = new Vector3(0.0285701f, -0.0714306f);

                        LightSprite headlight = ModAPI.CreateLight(body, Color.white, 3.5f, 1.5f);
                        headlight.transform.localPosition = new Vector3(3.45f, -0.363f);
                        headlight.gameObject.SetActive(false);

                        GameObject taillight = new GameObject("Taillight");
                        taillight.transform.parent = body;
                        taillight.transform.rotation = body.rotation;
                        taillight.transform.localPosition = new Vector3(-3.471476f, -0.6143399f, 0f);
                        taillight.transform.localScale = new Vector3(1f, 1f, 1f);
                        SpriteRenderer taillightRenderer = taillight.GetOrAddComponent<SpriteRenderer>();
                        taillightRenderer.sprite = ModAPI.LoadSprite("Textures/Cars/Mercedes-Benz G63 AMG/Taillight.png");
                        taillightRenderer.sortingOrder = body.gameObject.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        taillight.AddComponent<Optout>();
                        ModAPI.CreateLight(taillight.transform, Color.red, 4f, 1.5f);
                        taillight.SetActive(false);

                        WheelJoint2D[] wheels = body.GetComponents<WheelJoint2D>();
                        wheels[0].anchor = new Vector2(-2.2f, -1.135f);
                        wheels[0].connectedBody.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Cars/Mercedes-Benz G63 AMG/Wheel.png");
                        wheels[0].connectedBody.GetComponent<CircleCollider2D>().radius = 0.6428571f;
                        wheels[1].anchor = new Vector2(2.455f, -1.135f);
                        wheels[1].connectedBody.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Cars/Mercedes-Benz G63 AMG/Wheel.png");
                        wheels[1].connectedBody.GetComponent<CircleCollider2D>().radius = 0.6428571f;

                        Transform bonnet = Instance.transform.GetChild(3);
                        bonnet.GetComponent<HingeJoint2D>().anchor = new Vector2(-0.955328f, 0.07318401f);
                        bonnet.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.9571429f, 0.1428571f),
                            new Vector2(-0.9571429f, 0.05708379f),
                            new Vector2(0.642805f, -0.1428571f),
                            new Vector2(0.9571429f, -0.1428571f),
                            new Vector2(0.8998538f, -0.02863818f)
                        });

                        Instance.transform.GetChild(4).gameObject.SetActive(false);

                        Transform frontDoor = Instance.transform.GetChild(5);
                        frontDoor.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.7714286f, 0.9714286f),
                            new Vector2(-0.7714286f, -0.9714286f),
                            new Vector2(0.7714286f, -0.9714286f),
                            new Vector2(0.771378f, 0.2570874f),
                            new Vector2(0.2570894f, 0.9713752f)
                        });

                        Transform backDoor = Instance.transform.GetChild(6);
                        backDoor.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.7f, 0.9714286f),
                            new Vector2(-0.7000543f, -0.3429041f),
                            new Vector2(-0.2420017f, -0.9714286f),
                            new Vector2(0.7f, -0.9714286f),
                            new Vector2(0.7f, 0.9714286f)
                        });

                        GameObject spareWheel = new GameObject("Spare Wheel");
                        spareWheel.transform.parent = Instance.transform;
                        spareWheel.transform.localEulerAngles = body.eulerAngles + new Vector3(0f, 0f, -5.2f);
                        spareWheel.transform.localScale = Vector3.one;
                        spareWheel.transform.localPosition = new Vector3(-3.496f, 0.103f);
                        spareWheel.AddComponent<SpriteRenderer>();
                        spareWheel.AddComponent<RandomCarTextureChildBehaviour>().Sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("Textures/Cars/Mercedes-Benz G63 AMG/BlackColor/SpareWheel.png"),
                            ModAPI.LoadSprite("Textures/Cars/Mercedes-Benz G63 AMG/BlueColor/SpareWheel.png"),
                            ModAPI.LoadSprite("Textures/Cars/Mercedes-Benz G63 AMG/GrayColor/SpareWheel.png"),
                            ModAPI.LoadSprite("Textures/Cars/Mercedes-Benz G63 AMG/GreenColor/SpareWheel.png"),
                            ModAPI.LoadSprite("Textures/Cars/Mercedes-Benz G63 AMG/RedColor/SpareWheel.png")
                        };
                        spareWheel.layer = 9;
                        spareWheel.AddComponent<BoxCollider2D>().size = new Vector3(0.2285299f, 1.114286f);
                        spareWheel.AddComponent<Rigidbody2D>().mass = 1f;
                        FixedJoint2D fixedJoint = spareWheel.AddComponent<FixedJoint2D>();
                        fixedJoint.connectedBody = body.GetComponent<Rigidbody2D>();
                        fixedJoint.frequency = 8f;
                        fixedJoint.dampingRatio = 1f;
                        fixedJoint.breakForce = 4000f;
                        fixedJoint.anchor = new Vector2(0.12f, 0f);
                        spareWheel.AddComponent<JointSerialisationHelper>().Joint = fixedJoint;
                        JointBreakSoundBehaviour jointBreakSound = spareWheel.AddComponent<JointBreakSoundBehaviour>();
                        jointBreakSound.Clips = bonnet.GetComponent<JointBreakSoundBehaviour>().Clips;
                        jointBreakSound.AudioSource = spareWheel.GetComponent<AudioSource>();
                        jointBreakSound.Joints = new Joint2D[]
                        {
                            fixedJoint
                        };
                        jointBreakSound.OnBreak = new UnityEvent();
                        jointBreakSound.OnBreak.AddListener(() =>
                        {
                            jointBreakSound.Joints = new Joint2D[0];
                        });
                        spareWheel.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        spareWheel.AddComponent<AudioSourceTimeScaleBehaviour>();
                        spareWheel.AddComponent<Optout>();

                        body.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[]
                        {
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Mercedes-Benz G63 AMG/BlackColor/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Mercedes-Benz G63 AMG/BlackColor/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Mercedes-Benz G63 AMG/BlackColor/Bonnet.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Mercedes-Benz G63 AMG/BlackColor/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/Mercedes-Benz G63 AMG/BlackColor/BackDoor.png")
                            },
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Mercedes-Benz G63 AMG/BlueColor/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Mercedes-Benz G63 AMG/BlueColor/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Mercedes-Benz G63 AMG/BlueColor/Bonnet.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Mercedes-Benz G63 AMG/BlueColor/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/Mercedes-Benz G63 AMG/BlueColor/BackDoor.png")
                            },
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Mercedes-Benz G63 AMG/GrayColor/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Mercedes-Benz G63 AMG/GrayColor/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Mercedes-Benz G63 AMG/GrayColor/Bonnet.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Mercedes-Benz G63 AMG/GrayColor/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/Mercedes-Benz G63 AMG/GrayColor/BackDoor.png")
                            },
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Mercedes-Benz G63 AMG/GreenColor/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Mercedes-Benz G63 AMG/GreenColor/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Mercedes-Benz G63 AMG/GreenColor/Bonnet.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Mercedes-Benz G63 AMG/GreenColor/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/Mercedes-Benz G63 AMG/GreenColor/BackDoor.png")
                            },
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Mercedes-Benz G63 AMG/RedColor/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Mercedes-Benz G63 AMG/RedColor/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Mercedes-Benz G63 AMG/RedColor/Bonnet.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Mercedes-Benz G63 AMG/RedColor/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/Mercedes-Benz G63 AMG/RedColor/BackDoor.png")
                            }
                        };

                        CarSerialisationHelper carSerialisationHelper = Instance.AddComponent<CarSerialisationHelper>();
                        carSerialisationHelper.AfterFirstSpawn = () =>
                        {
                            body.GetComponent<CarBehaviour>().MotorSpeed = -3850f;

                            wheels[0].connectedBody.transform.localPosition = new Vector3(-2.2f, -1.135f);
                            wheels[1].connectedBody.transform.localPosition = new Vector3(2.455f, -1.135f);
                            bonnet.localPosition = new Vector3(2.428571f, 0.0285748f);
                            frontDoor.localPosition = new Vector3(0.528566f, 0.028567f);
                            backDoor.localPosition = new Vector3(-1.000001f, 0.028567f);
                            Instance.transform.GetChild(7).localPosition = new Vector3(2.426f, -0.411f);
                            Instance.transform.GetChild(8).localPosition = new Vector3(-2.57f, -0.55f);

                            Instance.AddComponent<ObjectSerialisationHelper>().Object = spareWheel;
                        };
                        carSerialisationHelper.AfterSpawn = () =>
                        {
                            carSerialisationHelper.carOptics.Headlights = new GameObject[]
                            {
                                headlight.gameObject,
                                taillight
                            };
                        };

                        NoCollide noCollide = Instance.GetComponent<NoCollide>();
                        noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                        noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Car"),
                    NameOverride = "Lada 2107" + tag,
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "Soviet and Russian rear-wheel drive car of the II group of a small class with a sedan-type body, one of the latest models of the classic, produced by Volga Automobile Plant / AvtoVAZ OJSC from March 11, 1982 to April 17, 2012.",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/Cars/Lada 2107/Thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Transform body = Instance.transform.GetChild(0);
                        BoxCollider2D[] boxColliders = body.GetComponents<BoxCollider2D>();
                        boxColliders[0].offset = new Vector2(0.2189572f, -0.647047f);
                        boxColliders[0].size = new Vector2(0.724648f, 0.3879089f);
                        boxColliders[1].offset = new Vector2(-0.1184579f, 0.1199083f);
                        boxColliders[1].size = new Vector2(0.234082f, 1.24296f);
                        boxColliders[2].offset = new Vector2(-1.038829f, -0.6267681f);
                        boxColliders[2].size = new Vector2(0.8105371f, 0.4024429f);
                        boxColliders[3].offset = new Vector2(-1.433944f, 0.06821537f);
                        boxColliders[3].size = new Vector2(0.2856743f, 1.098406f);
                        body.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(3.314248f, -0.04296184f),
                            new Vector2(3.269659f, -0.04320218f),
                            new Vector2(3.167312f, -0.2113113f),
                            new Vector2(1.57134f, -0.09922314f),
                            new Vector2(1.571429f, 0.1289061f),
                            new Vector2(1.486577f, 0.128993f),
                            new Vector2(1.316337f, 0.4561877f),
                            new Vector2(0.9316525f, 0.9293668f),
                            new Vector2(-1.485412f, 0.9286764f),
                            new Vector2(-1.625621f, 0.7831802f),
                            new Vector2(-1.885948f, 0.1855679f),
                            new Vector2(-1.991941f, 0.1855736f),
                            new Vector2(-2.057207f, -0.2429123f),
                            new Vector2(-3.04708f, -0.2429485f),
                            new Vector2(-3.114352f, -0.01435471f),
                            new Vector2(-3.257148f, -0.01433372f),
                            new Vector2(-3.199382f, -0.4703431f),
                            new Vector2(-2.972294f, -0.8398728f),
                            new Vector2(-1.26619f, -0.9285724f),
                            new Vector2(2.989839f, -0.9289024f)
                        });
                        body.GetComponent<PolygonCollider2D>().SetPath(1, new Vector2[]
                        {
                            new Vector2(-0.9709282f, -0.8142473f),
                            new Vector2(-1.545203f, -0.1505785f),
                            new Vector2(-1.194507f, 0.8427334f),
                            new Vector2(0.8172312f, 0.8430069f),
                            new Vector2(1.192671f, 0.4672366f),
                            new Vector2(1.428947f, -0.07237557f),
                            new Vector2(1.428477f, -0.8142435f)
                        });
                        body.GetChild(0).localPosition = new Vector3(0.299995f, -0.0571414f);

                        LightSprite headlight = ModAPI.CreateLight(body, Color.white, 3.5f, 1.5f);
                        headlight.transform.localPosition = new Vector3(3.23f, -0.403f, 0f);
                        headlight.gameObject.SetActive(false);

                        GameObject taillight = new GameObject("Taillight");
                        taillight.transform.parent = body;
                        taillight.transform.rotation = body.rotation;
                        taillight.transform.localPosition = new Vector3(-3.285718f, -0.1142859f, 0f);
                        taillight.transform.localScale = new Vector3(1f, 1f, 1f);
                        SpriteRenderer taillightRenderer = taillight.GetOrAddComponent<SpriteRenderer>();
                        taillightRenderer.sprite = ModAPI.LoadSprite("Textures/Cars/Lada 2107/Taillight.png");
                        taillightRenderer.sortingOrder = body.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        taillight.AddComponent<Optout>();
                        ModAPI.CreateLight(taillight.transform, Color.red, 3.5f, 1.5f);
                        taillight.SetActive(false);

                        GameObject turnSignal1 = new GameObject("Turn Signal 1");
                        turnSignal1.transform.parent = body;
                        turnSignal1.transform.rotation = body.rotation;
                        turnSignal1.transform.localPosition = new Vector3(-3.271431f, -0.2714301f, 0f);
                        turnSignal1.transform.localScale = new Vector3(1f, 1f, 1f);
                        SpriteRenderer turnSignal1Renderer = turnSignal1.GetOrAddComponent<SpriteRenderer>();
                        turnSignal1Renderer.sprite = ModAPI.LoadSprite("Textures/Cars/Lada 2107/TurnSignal.png");
                        turnSignal1Renderer.sortingOrder = body.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        turnSignal1.AddComponent<Optout>();
                        ModAPI.CreateLight(turnSignal1.transform, new Color32(255, 146, 0, 255), 1f, 1f);
                        turnSignal1.SetActive(false);

                        GameObject turnSignal2 = new GameObject("Turn Signal 2");
                        turnSignal2.transform.parent = body;
                        turnSignal2.transform.rotation = body.rotation;
                        turnSignal2.transform.localPosition = new Vector3(3.01389f, -0.257206f, 0f);
                        turnSignal2.transform.localScale = new Vector3(1f, 1f, 1f);
                        SpriteRenderer turnSignal2Renderer = turnSignal2.GetOrAddComponent<SpriteRenderer>();
                        turnSignal2Renderer.sprite = ModAPI.LoadSprite("Textures/Cars/Lada 2104/TurnSignal2.png");
                        turnSignal2Renderer.sortingOrder = body.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        turnSignal2.AddComponent<Optout>();
                        ModAPI.CreateLight(turnSignal2.transform, new Color32(255, 146, 0, 255), 1f, 1f);
                        turnSignal2.SetActive(false);

                        WheelJoint2D[] wheels = body.GetComponents<WheelJoint2D>();
                        wheels[0].anchor = new Vector2(2.332422f, -0.9f);
                        wheels[0].connectedBody.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Cars/Lada 2104/Wheel.png");
                        wheels[0].connectedBody.GetComponent<CircleCollider2D>().radius = 0.4857143f;
                        wheels[1].anchor = new Vector2(-1.736741f, -0.9f);
                        wheels[1].connectedBody.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Cars/Lada 2104/Wheel.png");
                        wheels[1].connectedBody.GetComponent<CircleCollider2D>().radius = 0.4857143f;

                        Transform bonnet = Instance.transform.GetChild(3);
                        bonnet.GetComponent<HingeJoint2D>().anchor = new Vector2(-0.87f, 0.08f);
                        bonnet.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.8714285f, 0.1142857f),
                            new Vector2(-0.8721212f, 0.05846947f),
                            new Vector2(0.8714285f, -0.1142857f),
                            new Vector2(0.8703743f, -0.05867064f)
                        });

                        Transform boot = Instance.transform.GetChild(4);
                        boot.GetComponent<HingeJoint2D>().anchor = new Vector2(0.6239531f, 0.07419014f);
                        UnityEngine.Object.Destroy(boot.GetComponent<BoxCollider2D>());
                        boot.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.5134912f, 0.01392327f),
                            new Vector2(-0.6286232f, -0.1000541f),
                            new Vector2(-0.5714908f, -0.1000004f),
                            new Vector2(-0.5141863f, -0.05235253f),
                            new Vector2(0.6286077f, 0.04370341f),
                            new Vector2(0.6285715f, 0.1f)
                        });

                        Transform frontDoor = Instance.transform.GetChild(5);
                        frontDoor.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.8f, 0.8571429f),
                            new Vector2(-0.8f, -0.8571429f),
                            new Vector2(0.8f, -0.8571429f),
                            new Vector2(0.7972623f, -0.09603468f),
                            new Vector2(0.5215713f, 0.4979815f),
                            new Vector2(0.2152529f, 0.8591825f)
                        });

                        Transform backDoor = Instance.transform.GetChild(6);
                        backDoor.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.3259268f, 0.8428571f),
                            new Vector2(-0.5513432f, 0.5790653f),
                            new Vector2(-0.7285714f, 0.1564324f),
                            new Vector2(-0.7285714f, -0.1771082f),
                            new Vector2(-0.1275197f, -0.8428743f),
                            new Vector2(0.7285714f, -0.8428571f),
                            new Vector2(0.7285714f, 0.8428571f)
                        });

                        body.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[]
                        {
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Lada 2107/BlackColor/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Lada 2107/BlackColor/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Lada 2104/BlackColor/Bonnet.png"),
                                Boot = ModAPI.LoadSprite("Textures/Cars/Lada 2107/BlackColor/Boot.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Lada 2104/BlackColor/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/Lada 2107/BlackColor/BackDoor.png")
                            },
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Lada 2107/BlueColor/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Lada 2107/BlueColor/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Lada 2104/BlueColor/Bonnet.png"),
                                Boot = ModAPI.LoadSprite("Textures/Cars/Lada 2107/BlueColor/Boot.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Lada 2104/BlueColor/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/Lada 2107/BlueColor/BackDoor.png")
                            },
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Lada 2107/GrayColor/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Lada 2107/GrayColor/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Lada 2104/GrayColor/Bonnet.png"),
                                Boot = ModAPI.LoadSprite("Textures/Cars/Lada 2107/GrayColor/Boot.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Lada 2104/GrayColor/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/Lada 2107/GrayColor/BackDoor.png")
                            },
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Lada 2107/GreenColor/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Lada 2107/GreenColor/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Lada 2104/GreenColor/Bonnet.png"),
                                Boot = ModAPI.LoadSprite("Textures/Cars/Lada 2107/GreenColor/Boot.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Lada 2104/GreenColor/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/Lada 2107/GreenColor/BackDoor.png")
                            },
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Lada 2107/RedColor/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Lada 2107/RedColor/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Lada 2104/RedColor/Bonnet.png"),
                                Boot = ModAPI.LoadSprite("Textures/Cars/Lada 2107/RedColor/Boot.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Lada 2104/RedColor/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/Lada 2107/RedColor/BackDoor.png")
                            }
                        };

                        AudioClip failedEngineStartup = ModAPI.LoadSound("Sounds/FailedEngineStartup.mp3");
                        CarSerialisationHelper carSerialisationHelper = Instance.AddComponent<CarSerialisationHelper>();
                        carSerialisationHelper.AfterFirstSpawn = () =>
                        {
                            body.GetComponent<CarBehaviour>().MotorSpeed = -4250f;

                            wheels[0].connectedBody.transform.localPosition = new Vector3(2.332422f, -0.9f);
                            wheels[1].connectedBody.transform.localPosition = new Vector3(-1.736741f, -0.9f);
                            bonnet.localPosition = new Vector3(2.414229f, 0.015f);
                            boot.localPosition = new Vector3(-2.600003f, 0.085714f);
                            frontDoor.localPosition = new Vector3(0.657141f, 0.015f);
                            backDoor.localPosition = new Vector3(-0.87f, 0.027f);
                            Instance.transform.GetChild(7).localPosition = new Vector3(2.318f, -0.394f);
                            Instance.transform.GetChild(8).localPosition = new Vector3(-1.934f, -0.466f);
                        };
                        carSerialisationHelper.AfterSpawn = () =>
                        {
                            carSerialisationHelper.carOptics.FailedEngineStartup = true;
                            carSerialisationHelper.carOptics.Headlights = new GameObject[]
                            {
                                headlight.gameObject,
                                taillight
                            };
                            carSerialisationHelper.carOptics.TurnSignals = new GameObject[]
                            {
                                turnSignal1,
                                turnSignal2
                            };
                            carSerialisationHelper.carOptics.FailedEngineStartupSound = failedEngineStartup;
                            carSerialisationHelper.carOptics.UpdateActivation();
                        };

                        NoCollide noCollide = Instance.GetComponent<NoCollide>();
                        noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                        noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Car"),
                    NameOverride = "Lada 2107 Police" + tag,
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "Lada 2107 police edition",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/Cars/Lada 2107/Thumb2.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Transform body = Instance.transform.GetChild(0);
                        BoxCollider2D[] boxColliders = body.GetComponents<BoxCollider2D>();
                        boxColliders[0].offset = new Vector2(0.2189572f, -0.647047f);
                        boxColliders[0].size = new Vector2(0.724648f, 0.3879089f);
                        boxColliders[1].offset = new Vector2(-0.1184579f, 0.1199083f);
                        boxColliders[1].size = new Vector2(0.234082f, 1.24296f);
                        boxColliders[2].offset = new Vector2(-1.038829f, -0.6267681f);
                        boxColliders[2].size = new Vector2(0.8105371f, 0.4024429f);
                        boxColliders[3].offset = new Vector2(-1.433944f, 0.06821537f);
                        boxColliders[3].size = new Vector2(0.2856743f, 1.098406f);
                        body.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(3.314248f, -0.04296184f),
                            new Vector2(3.269659f, -0.04320218f),
                            new Vector2(3.167312f, -0.2113113f),
                            new Vector2(1.57134f, -0.09922314f),
                            new Vector2(1.571429f, 0.1289061f),
                            new Vector2(1.486577f, 0.128993f),
                            new Vector2(1.316337f, 0.4561877f),
                            new Vector2(0.9316525f, 0.9293668f),
                            new Vector2(-1.485412f, 0.9286764f),
                            new Vector2(-1.625621f, 0.7831802f),
                            new Vector2(-1.885948f, 0.1855679f),
                            new Vector2(-1.991941f, 0.1855736f),
                            new Vector2(-2.057207f, -0.2429123f),
                            new Vector2(-3.04708f, -0.2429485f),
                            new Vector2(-3.114352f, -0.01435471f),
                            new Vector2(-3.257148f, -0.01433372f),
                            new Vector2(-3.199382f, -0.4703431f),
                            new Vector2(-2.972294f, -0.8398728f),
                            new Vector2(-1.26619f, -0.9285724f),
                            new Vector2(2.989839f, -0.9289024f)
                        });
                        body.GetComponent<PolygonCollider2D>().SetPath(1, new Vector2[]
                        {
                            new Vector2(-0.9709282f, -0.8142473f),
                            new Vector2(-1.545203f, -0.1505785f),
                            new Vector2(-1.194507f, 0.8427334f),
                            new Vector2(0.8172312f, 0.8430069f),
                            new Vector2(1.192671f, 0.4672366f),
                            new Vector2(1.428947f, -0.07237557f),
                            new Vector2(1.428477f, -0.8142435f)
                        });
                        body.GetChild(0).localPosition = new Vector3(0.299995f, -0.0571414f);

                        LightSprite headlight = ModAPI.CreateLight(body, Color.white, 3.5f, 1.5f);
                        headlight.transform.localPosition = new Vector3(3.23f, -0.403f, 0f);
                        headlight.gameObject.SetActive(false);

                        GameObject taillight = new GameObject("Taillight");
                        taillight.transform.parent = body;
                        taillight.transform.rotation = body.rotation;
                        taillight.transform.localPosition = new Vector3(-3.285718f, -0.1142859f, 0f);
                        taillight.transform.localScale = new Vector3(1f, 1f, 1f);
                        SpriteRenderer taillightRenderer = taillight.GetOrAddComponent<SpriteRenderer>();
                        taillightRenderer.sprite = ModAPI.LoadSprite("Textures/Cars/Lada 2107/Taillight.png");
                        taillightRenderer.sortingOrder = body.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        taillight.AddComponent<Optout>();
                        ModAPI.CreateLight(taillight.transform, Color.red, 3.5f, 1.5f);
                        taillight.SetActive(false);

                        GameObject turnSignal1 = new GameObject("Turn Signal 1");
                        turnSignal1.transform.parent = body;
                        turnSignal1.transform.rotation = body.rotation;
                        turnSignal1.transform.localPosition = new Vector3(-3.271431f, -0.2714301f, 0f);
                        turnSignal1.transform.localScale = new Vector3(1f, 1f, 1f);
                        SpriteRenderer turnSignal1Renderer = turnSignal1.GetOrAddComponent<SpriteRenderer>();
                        turnSignal1Renderer.sprite = ModAPI.LoadSprite("Textures/Cars/Lada 2107/TurnSignal.png");
                        turnSignal1Renderer.sortingOrder = body.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        turnSignal1.AddComponent<Optout>();
                        ModAPI.CreateLight(turnSignal1.transform, new Color32(255, 146, 0, 255), 1f, 1f);
                        turnSignal1.SetActive(false);

                        GameObject turnSignal2 = new GameObject("Turn Signal 2");
                        turnSignal2.transform.parent = body;
                        turnSignal2.transform.rotation = body.rotation;
                        turnSignal2.transform.localPosition = new Vector3(3.01389f, -0.257206f, 0f);
                        turnSignal2.transform.localScale = new Vector3(1f, 1f, 1f);
                        SpriteRenderer turnSignal2Renderer = turnSignal2.GetOrAddComponent<SpriteRenderer>();
                        turnSignal2Renderer.sprite = ModAPI.LoadSprite("Textures/Cars/Lada 2104/TurnSignal2.png");
                        turnSignal2Renderer.sortingOrder = body.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        turnSignal2.AddComponent<Optout>();
                        ModAPI.CreateLight(turnSignal2.transform, new Color32(255, 146, 0, 255), 1f, 1f);
                        turnSignal2.SetActive(false);

                        WheelJoint2D[] wheels = body.GetComponents<WheelJoint2D>();
                        wheels[0].anchor = new Vector2(2.332422f, -0.9f);
                        wheels[0].connectedBody.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Cars/Lada 2104/Wheel.png");
                        wheels[0].connectedBody.GetComponent<CircleCollider2D>().radius = 0.4857143f;
                        wheels[1].anchor = new Vector2(-1.736741f, -0.9f);
                        wheels[1].connectedBody.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Cars/Lada 2104/Wheel.png");
                        wheels[1].connectedBody.GetComponent<CircleCollider2D>().radius = 0.4857143f;

                        Transform bonnet = Instance.transform.GetChild(3);
                        bonnet.GetComponent<HingeJoint2D>().anchor = new Vector2(-0.87f, 0.08f);
                        bonnet.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.8714285f, 0.1142857f),
                            new Vector2(-0.8721212f, 0.05846947f),
                            new Vector2(0.8714285f, -0.1142857f),
                            new Vector2(0.8703743f, -0.05867064f)
                        });

                        Transform boot = Instance.transform.GetChild(4);
                        boot.GetComponent<HingeJoint2D>().anchor = new Vector2(0.6239531f, 0.07419014f);
                        UnityEngine.Object.Destroy(boot.GetComponent<BoxCollider2D>());
                        boot.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.5134912f, 0.01392327f),
                            new Vector2(-0.6286232f, -0.1000541f),
                            new Vector2(-0.5714908f, -0.1000004f),
                            new Vector2(-0.5141863f, -0.05235253f),
                            new Vector2(0.6286077f, 0.04370341f),
                            new Vector2(0.6285715f, 0.1f)
                        });

                        Transform frontDoor = Instance.transform.GetChild(5);
                        frontDoor.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.8f, 0.8571429f),
                            new Vector2(-0.8f, -0.8571429f),
                            new Vector2(0.8f, -0.8571429f),
                            new Vector2(0.7972623f, -0.09603468f),
                            new Vector2(0.5215713f, 0.4979815f),
                            new Vector2(0.2152529f, 0.8591825f)
                        });

                        Transform backDoor = Instance.transform.GetChild(6);
                        backDoor.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.3259268f, 0.8428571f),
                            new Vector2(-0.5513432f, 0.5790653f),
                            new Vector2(-0.7285714f, 0.1564324f),
                            new Vector2(-0.7285714f, -0.1771082f),
                            new Vector2(-0.1275197f, -0.8428743f),
                            new Vector2(0.7285714f, -0.8428571f),
                            new Vector2(0.7285714f, 0.8428571f)
                        });

                        GameObject blinker = new GameObject("Blinker");
                        blinker.transform.parent = Instance.transform;
                        blinker.transform.rotation = body.transform.rotation;
                        blinker.transform.localScale = Vector3.one;
                        blinker.transform.localPosition = new Vector3(-0.225175f, 1.014291f);
                        SpriteRenderer blinkerRenderer = blinker.AddComponent<SpriteRenderer>();
                        blinkerRenderer.sprite = ModAPI.LoadSprite("Textures/PoliceBlinker.png");
                        blinker.layer = 9;
                        blinker.AddComponent<BoxCollider2D>();
                        blinker.AddComponent<Rigidbody2D>().mass = 1.5f;
                        FixedJoint2D fixedJoint = blinker.AddComponent<FixedJoint2D>();
                        fixedJoint.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                        fixedJoint.breakForce = 5000f;
                        blinker.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Flammable metal");
                        DamagableMachineryBehaviour damagable = blinker.AddComponent<DamagableMachineryBehaviour>();
                        damagable.FirearmDamageMultiplier = 1f;
                        damagable.ExplosionDamageMultiplier = 100f;
                        damagable.Health = 50f;
                        damagable.BehavioursToToggle = new MonoBehaviour[0];
                        damagable.GameObjectsToToggle = new GameObject[0];
                        damagable.Waterproof = false;
                        blinker.AddComponent<JointSerialisationHelper>().Joint = fixedJoint;
                        JointBreakSoundBehaviour jointBreakSound = blinker.AddComponent<JointBreakSoundBehaviour>();
                        jointBreakSound.Clips = boot.GetComponent<JointBreakSoundBehaviour>().Clips;
                        jointBreakSound.AudioSource = blinker.GetComponent<AudioSource>();
                        jointBreakSound.Joints = new Joint2D[]
                        {
                            fixedJoint
                        };
                        jointBreakSound.OnBreak = new UnityEvent();
                        jointBreakSound.OnBreak.AddListener(() =>
                        {
                            jointBreakSound.Joints = new Joint2D[0];
                        });
                        AudioSource audio = blinker.AddComponent<AudioSource>();
                        audio.loop = true;
                        audio.clip = ModAPI.LoadSound("Sounds/PoliceBlinker.mp3");
                        audio.spatialBlend = 1f;
                        blinker.AddComponent<AudioSourceTimeScaleBehaviour>();
                        blinker.AddComponent<Optout>();

                        GameObject glow1 = new GameObject("Glow 1");
                        glow1.transform.parent = blinker.transform;
                        glow1.transform.rotation = blinker.transform.rotation;
                        glow1.transform.localScale = Vector3.one;
                        glow1.transform.localPosition = new Vector3(-0.25714f, 0.014288f);
                        SpriteRenderer glow1Renderer = glow1.AddComponent<SpriteRenderer>();
                        glow1Renderer.sprite = ModAPI.LoadSprite("Textures/PoliceBlinkerGlowMask.png");
                        glow1Renderer.sortingOrder = blinkerRenderer.sortingOrder + 1;
                        glow1Renderer.sortingLayerName = blinkerRenderer.sortingLayerName;
                        glow1Renderer.color = Color.blue;
                        glow1.AddComponent<Optout>();
                        ModAPI.CreateLight(glow1.transform, Color.blue, 15f, 3f);

                        GameObject glow2 = new GameObject("Glow 2");
                        glow2.transform.parent = blinker.transform;
                        glow2.transform.rotation = blinker.transform.rotation;
                        glow2.transform.localScale = new Vector3(-1f, 1f, 1f);
                        glow2.transform.localPosition = new Vector3(0.25714f, 0.014288f);
                        SpriteRenderer glow2Renderer = glow2.AddComponent<SpriteRenderer>();
                        glow2Renderer.sprite = ModAPI.LoadSprite("Textures/PoliceBlinkerGlowMask.png");
                        glow2Renderer.sortingOrder = blinkerRenderer.sortingOrder + 1;
                        glow2Renderer.sortingLayerName = blinkerRenderer.sortingLayerName;
                        glow2Renderer.color = Color.red;
                        glow2.AddComponent<Optout>();
                        ModAPI.CreateLight(glow2.transform, Color.red, 15f, 3f);

                        BlinkerBehaviour blinkerBehaviour = blinker.GetOrAddComponent<BlinkerBehaviour>();
                        blinkerBehaviour.Glow1 = glow1;
                        blinkerBehaviour.Glow2 = glow2;
                        blinkerBehaviour.Audio = audio;
                        blinkerBehaviour.Delay = 1f;

                        body.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[]
                        {
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Lada 2107/PoliceSkin/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Lada 2107/PoliceSkin/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Lada 2107/PoliceSkin/Bonnet.png"),
                                Boot = ModAPI.LoadSprite("Textures/Cars/Lada 2107/PoliceSkin/Boot.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Lada 2107/PoliceSkin/FrontDoor.png"),
                                BackDoor = ModAPI.LoadSprite("Textures/Cars/Lada 2107/PoliceSkin/BackDoor.png")
                            }
                        };

                        AudioClip failedEngineStartup = ModAPI.LoadSound("Sounds/FailedEngineStartup.mp3");
                        Sprite leftFrontDoor = ModAPI.LoadSprite("Textures/Cars/Lada 2107/PoliceSkin/FrontDoor2.png");
                        CarSerialisationHelper carSerialisationHelper = Instance.AddComponent<CarSerialisationHelper>();
                        carSerialisationHelper.AfterFirstSpawn = () =>
                        {
                            body.GetComponent<CarBehaviour>().MotorSpeed = -4350f;

                            wheels[0].connectedBody.transform.localPosition = new Vector3(2.332422f, -0.9f);
                            wheels[1].connectedBody.transform.localPosition = new Vector3(-1.736741f, -0.9f);
                            bonnet.localPosition = new Vector3(2.414229f, 0.015f);
                            boot.localPosition = new Vector3(-2.600003f, 0.085714f);
                            frontDoor.localPosition = new Vector3(0.657141f, 0.015f);
                            backDoor.localPosition = new Vector3(-0.87f, 0.027f);
                            Instance.transform.GetChild(7).localPosition = new Vector3(2.318f, -0.394f);
                            Instance.transform.GetChild(8).localPosition = new Vector3(-1.934f, -0.466f);

                            Instance.AddComponent<ObjectSerialisationHelper>().Object = blinker;
                        };
                        carSerialisationHelper.AfterSpawn = () =>
                        {
                            carSerialisationHelper.carOptics.FailedEngineStartup = true;
                            carSerialisationHelper.carOptics.Headlights = new GameObject[]
                            {
                                headlight.gameObject,
                                taillight
                            };
                            carSerialisationHelper.carOptics.TurnSignals = new GameObject[]
                            {
                                turnSignal1,
                                turnSignal2
                            };
                            carSerialisationHelper.carOptics.FailedEngineStartupSound = failedEngineStartup;
                            carSerialisationHelper.carOptics.UpdateActivation();
                        };
                        carSerialisationHelper.Left = () =>
                        {
                            body.GetComponent<RandomCarTextureBehaviour>().Textures[0].FrontDoor = leftFrontDoor;
                            frontDoor.GetComponent<SpriteRenderer>().sprite = leftFrontDoor;
                        };

                        NoCollide noCollide = Instance.GetComponent<NoCollide>();
                        noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                        noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Car"),
                    NameOverride = "GAZ-2330" + tag,
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "Russian multi-purpose off-road vehicle, armored car, army off-road vehicle. Tiger and its modifications are produced at the Arzamas Machine-Building Plant with YaMZ-5347-10, Cummins B-205 engines.",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/Cars/GAZ-2330/Thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Transform body = Instance.transform.GetChild(0);
                        body.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                        body.GetComponent<SpriteRenderer>().sortingOrder = 4;
                        BoxCollider2D[] boxColliders = body.GetComponents<BoxCollider2D>();
                        boxColliders[0].offset = new Vector2(-2.429002f, 1.054443f);
                        boxColliders[0].size = new Vector2(2.313486f, 0.1766586f);
                        boxColliders[1].offset = new Vector2(0.3961835f, -0.7487698f);
                        boxColliders[1].size = new Vector2(0.6901622f, 0.3278313f);
                        boxColliders[2].offset = new Vector2(0.04453439f, -0.02321243f);
                        boxColliders[2].size = new Vector2(0.2347411f, 1.250999f);
                        boxColliders[3].offset = new Vector2(-1.776207f, 0.05924606f);
                        boxColliders[3].size = new Vector2(3.619015f, 1.994896f);
                        boxColliders[3].isTrigger = true;
                        body.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(3.414229f, 0.02851878f),
                            new Vector2(1.81423f, 0.02851421f),
                            new Vector2(1.442789f, 0.4285399f),
                            new Vector2(1.24279f, 0.9999363f),
                            new Vector2(0.1284853f, 1.14281f),
                            new Vector2(-0.2714825f, 1.142802f),
                            new Vector2(-0.2716913f, 0.9712524f),
                            new Vector2(0.1284853f, 0.9712524f),
                            new Vector2(1.157076f, 0.8571663f),
                            new Vector2(1.328516f, 0.371376f),
                            new Vector2(1.328513f, -0.8857727f),
                            new Vector2(-3.585688f, -0.8861803f),
                            new Vector2(-3.58571f, -0.9714838f),
                            new Vector2(-1.61434f, -1.2f),
                            new Vector2(1.557073f, -1.200004f),
                            new Vector2(3.271376f, -0.6571835f),
                            new Vector2(3.585713f, -0.657195f)
                        });
                        body.GetComponent<PolygonCollider2D>().pathCount = 1;
                        PhysicalProperties carProperties = UnityEngine.Object.Instantiate(body.GetComponent<PhysicalBehaviour>().Properties);
                        carProperties.BulletSpeedAbsorptionPower = 7f;
                        body.GetComponent<PhysicalBehaviour>().Properties = carProperties;
                        body.GetChild(0).localPosition = new Vector3(0.3428538f, -0.1285694f);

                        GameObject background2 = new GameObject("Background 2");
                        background2.transform.parent = body;
                        background2.transform.rotation = body.rotation;
                        background2.transform.localScale = Vector3.one;
                        background2.transform.localPosition = new Vector3(-2.557145f, -0.6571908f);
                        SpriteRenderer background2Renderer = background2.AddComponent<SpriteRenderer>();
                        background2Renderer.sprite = ModAPI.LoadSprite("Textures/Cars/GAZ-2330/Background2.png");
                        background2Renderer.sortingOrder = 2;
                        background2Renderer.sortingLayerName = "Foreground";
                        background2.AddComponent<Optout>();

                        WheelJoint2D[] wheels = body.GetComponents<WheelJoint2D>();
                        wheels[0].anchor = new Vector2(2.44f, -1.139f);
                        wheels[0].connectedBody.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Cars/GAZ-2330/Wheel.png");
                        wheels[1].connectedBody.GetComponent<SpriteRenderer>().sortingOrder = 3;
                        wheels[1].connectedBody.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                        wheels[0].connectedBody.GetComponent<CircleCollider2D>().radius = 0.7142857f;
                        wheels[1].anchor = new Vector2(-2.47f, -1.139f);
                        wheels[1].connectedBody.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Cars/GAZ-2330/Wheel.png");
                        wheels[1].connectedBody.GetComponent<CircleCollider2D>().radius = 0.7142857f;

                        Transform bonnet = Instance.transform.GetChild(3);
                        bonnet.GetComponent<FixedJoint2D>().breakForce = 1500f;
                        bonnet.GetComponent<HingeJoint2D>().anchor = new Vector2(-0.9156831f, 0.1013031f);
                        bonnet.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.7572119f, 0.2142819f),
                            new Vector2(-0.9571429f, 0.2142857f),
                            new Vector2(-0.9571875f, 0.09995553f),
                            new Vector2(-0.6429137f, -0.2142857f),
                            new Vector2(0.9571425f, -0.2142819f),
                            new Vector2(0.7855596f, -0.01442937f)
                        });

                        Instance.transform.GetChild(4).gameObject.SetActive(false);

                        Transform frontDoor = Instance.transform.GetChild(5);
                        frontDoor.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.6428571f, 0.9f),
                            new Vector2(-0.6428571f, -0.1855902f),
                            new Vector2(-0.1571174f, -0.8999637f),
                            new Vector2(0.6428571f, -0.9f),
                            new Vector2(0.6428571f, 0.3862686f),
                            new Vector2(0.4384478f, 0.9f)
                        });

                        Instance.transform.GetChild(6).gameObject.SetActive(false);

                        GameObject hatch = new GameObject("Hatch");
                        hatch.transform.parent = Instance.transform;
                        hatch.transform.rotation = body.transform.rotation;
                        hatch.transform.localScale = Vector3.one;
                        hatch.transform.localPosition = new Vector3(-0.7714317f, 1.185769f);
                        SpriteRenderer hatchRenderer = hatch.AddComponent<SpriteRenderer>();
                        hatchRenderer.sortingOrder = bonnet.GetComponent<SpriteRenderer>().sortingOrder;
                        hatchRenderer.sortingLayerName = bonnet.GetComponent<SpriteRenderer>().sortingLayerName;
                        hatch.AddComponent<RandomCarTextureChildBehaviour>().Sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("Textures/Cars/GAZ-2330/MilitarySkin/Hatch.png"),
                            ModAPI.LoadSprite("Textures/Cars/GAZ-2330/MilitaryBlackSkin/Hatch.png")
                        };
                        hatch.layer = 9;
                        BoxCollider2D boxCollider1 = hatch.AddComponent<BoxCollider2D>();
                        boxCollider1.offset = new Vector2(0f, -0.02860885f);
                        boxCollider1.size = new Vector2(1f, 0.08566461f);
                        BoxCollider2D boxCollider2 = hatch.AddComponent<BoxCollider2D>();
                        boxCollider2.offset = new Vector2(0f, 0.03170694f);
                        boxCollider2.size = new Vector2(0.1429618f, 0.07944325f);
                        hatch.AddComponent<Rigidbody2D>().mass = 0.35f;
                        FixedJoint2D fixedJoint1 = hatch.AddComponent<FixedJoint2D>();
                        fixedJoint1.connectedBody = body.GetComponent<Rigidbody2D>();
                        fixedJoint1.breakForce = 100f;
                        HingeJoint2D hingeJoint = hatch.AddComponent<HingeJoint2D>();
                        hingeJoint.connectedBody = body.GetComponent<Rigidbody2D>();
                        hingeJoint.anchor = new Vector2(-0.485643f, -0.05768967f);
                        hingeJoint.breakForce = 900f;
                        hingeJoint.breakTorque = 900f;
                        hingeJoint.limits = new JointAngleLimits2D
                        {
                            min = -95,
                            max = 0
                        };
                        hingeJoint.useLimits = true;
                        hatch.AddComponent<JointSerialisationHelper>().Joint = fixedJoint1;
                        hatch.AddComponent<JointSerialisationHelper>().Joint = hingeJoint;
                        JointBreakSoundBehaviour jointBreakSound1 = hatch.AddComponent<JointBreakSoundBehaviour>();
                        jointBreakSound1.Clips = bonnet.GetComponent<JointBreakSoundBehaviour>().Clips;
                        jointBreakSound1.AudioSource = hatch.GetComponent<AudioSource>();
                        jointBreakSound1.Joints = new Joint2D[]
                        {
                            hingeJoint
                        };
                        jointBreakSound1.OnBreak = new UnityEvent();
                        jointBreakSound1.OnBreak.AddListener(() =>
                        {
                            jointBreakSound1.Joints = new Joint2D[0];
                        });
                        PhysicalProperties properties = ModAPI.FindPhysicalProperties("Metal");
                        properties.BulletSpeedAbsorptionPower = 7f;
                        hatch.AddComponent<PhysicalBehaviour>().Properties = properties;
                        hatch.AddComponent<AudioSourceTimeScaleBehaviour>();
                        hatch.AddComponent<Optout>();

                        GameObject backDoor = new GameObject("Back Door");
                        backDoor.transform.parent = Instance.transform;
                        backDoor.transform.rotation = body.transform.rotation;
                        backDoor.transform.localScale = Vector3.one;
                        backDoor.transform.localPosition = new Vector3(-3.542808f, 0.05709f);
                        SpriteRenderer backDoorRenderer = backDoor.AddComponent<SpriteRenderer>();
                        backDoorRenderer.sprite = ModAPI.LoadSprite("Textures/Cars/GAZ-2330/MilitarySkin/BackDoorClosed.png");
                        backDoor.layer = 9;
                        BoxCollider2D boxCollider3 = backDoor.AddComponent<BoxCollider2D>();
                        boxCollider3.offset = new Vector2(0.02861438f, 0f);
                        boxCollider3.size = new Vector2(0.1430584f, 1.942857f);
                        backDoor.AddComponent<Rigidbody2D>().mass = 0.5f;
                        FixedJoint2D fixedJoint2 = backDoor.AddComponent<FixedJoint2D>();
                        fixedJoint2.connectedBody = body.GetComponent<Rigidbody2D>();
                        fixedJoint2.breakForce = 2500f;
                        backDoor.AddComponent<JointSerialisationHelper>().Joint = fixedJoint2;
                        JointBreakSoundBehaviour jointBreakSound2 = backDoor.AddComponent<JointBreakSoundBehaviour>();
                        jointBreakSound2.Clips = bonnet.GetComponent<JointBreakSoundBehaviour>().Clips;
                        jointBreakSound2.AudioSource = backDoor.GetComponent<AudioSource>();
                        jointBreakSound2.Joints = new Joint2D[]
                        {
                            fixedJoint2
                        };
                        jointBreakSound2.OnBreak = new UnityEvent();
                        jointBreakSound2.OnBreak.AddListener(() =>
                        {
                            jointBreakSound2.Joints = new Joint2D[0];
                        });
                        backDoor.AddComponent<PhysicalBehaviour>().Properties = properties;
                        backDoor.AddComponent<AudioSourceTimeScaleBehaviour>();
                        backDoor.AddComponent<Optout>();

                        GameObject spareWheel = new GameObject("Spare Wheel");
                        spareWheel.transform.parent = Instance.transform;
                        spareWheel.transform.rotation = body.transform.rotation;
                        spareWheel.transform.localScale = Vector3.one;
                        spareWheel.transform.localPosition = new Vector3(-3.846046f, -0.000108f);
                        SpriteRenderer spareWheelRenderer = spareWheel.AddComponent<SpriteRenderer>();
                        spareWheelRenderer.sprite = ModAPI.LoadSprite("Textures/Cars/GAZ-2330/SpareWheel.png");
                        spareWheelRenderer.sortingOrder += 1;
                        spareWheel.layer = 9;
                        spareWheel.AddComponent<BoxCollider2D>();
                        spareWheel.AddComponent<Rigidbody2D>().mass = 0.45f;
                        spareWheel.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Rubber");
                        spareWheel.AddComponent<AudioSourceTimeScaleBehaviour>();
                        spareWheel.AddComponent<Optout>();

                        FixedJoint2D fixedJoint3 = backDoor.AddComponent<FixedJoint2D>();
                        fixedJoint3.connectedBody = spareWheel.GetComponent<Rigidbody2D>();
                        fixedJoint3.breakForce = 900f;
                        backDoor.AddComponent<JointSerialisationHelper>().Joint = fixedJoint3;

                        BackDoorBehaviour backDoorBehaviour = backDoor.AddComponent<BackDoorBehaviour>();
                        backDoorBehaviour.SpareWheelJoint = fixedJoint3;
                        backDoorBehaviour.Textures = new BackDoorBehaviour.DoorSprites[]
                        {
                            new BackDoorBehaviour.DoorSprites
                            {
                                OpenSprite = ModAPI.LoadSprite("Textures/Cars/GAZ-2330/MilitarySkin/BackDoorOpen.png"),
                                OpenSpriteWithWheel = ModAPI.LoadSprite("Textures/Cars/GAZ-2330/MilitarySkin/BackDoorOpenWithWheel.png"),
                                ClosedSprite = ModAPI.LoadSprite("Textures/Cars/GAZ-2330/MilitarySkin/BackDoorClosed.png")
                            },
                            new BackDoorBehaviour.DoorSprites
                            {
                                OpenSprite = ModAPI.LoadSprite("Textures/Cars/GAZ-2330/MilitaryBlackSkin/BackDoorOpen.png"),
                                OpenSpriteWithWheel = ModAPI.LoadSprite("Textures/Cars/GAZ-2330/MilitaryBlackSkin/BackDoorOpenWithWheel.png"),
                                ClosedSprite = ModAPI.LoadSprite("Textures/Cars/GAZ-2330/MilitaryBlackSkin/BackDoorClosed.png")
                            }
                        };
                        backDoorBehaviour.OnClosed.AddListener(() =>
                        {
                            if (fixedJoint3)
                            {
                                foreach (Collider2D collider in Instance.GetComponentsInChildren<Collider2D>())
                                {
                                    Physics2D.IgnoreCollision(collider, spareWheel.GetComponent<BoxCollider2D>());
                                }
                                fixedJoint3.connectedBody = spareWheel.GetComponent<Rigidbody2D>();
                            }
                        });

                        body.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[]
                        {
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/GAZ-2330/MilitarySkin/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/GAZ-2330/Background1.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/GAZ-2330/MilitarySkin/Bonnet.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/GAZ-2330/MilitarySkin/Door.png")
                            },
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/GAZ-2330/MilitaryBlackSkin/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/GAZ-2330/Background1.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/GAZ-2330/MilitaryBlackSkin/Bonnet.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/GAZ-2330/MilitaryBlackSkin/Door.png")
                            }
                        };

                        NoCollideWithObjectsInTrigger noCollideWithObjectsInTrigger = body.gameObject.AddComponent<NoCollideWithObjectsInTrigger>();
                        noCollideWithObjectsInTrigger.Colliders = new Collider2D[]
                        {
                            wheels[1].connectedBody.GetComponent<CircleCollider2D>(),
                            Instance.transform.GetChild(8).GetComponent<BoxCollider2D>()
                        };
                        noCollideWithObjectsInTrigger.Trigger = boxColliders[3];

                        Instance.transform.GetChild(8).GetComponent<JointBreakSoundBehaviour>().OnBreak.AddListener(() =>
                        {
                            noCollideWithObjectsInTrigger.RemoveCollider(1);
                        });

                        CarSerialisationHelper carSerialisationHelper = Instance.AddComponent<CarSerialisationHelper>();
                        carSerialisationHelper.AfterFirstSpawn = () =>
                        {
                            body.GetComponent<CarBehaviour>().MotorSpeed = -3100f;

                            wheels[0].connectedBody.transform.localPosition = new Vector3(2.44f, -1.087f);
                            wheels[1].connectedBody.transform.localPosition = new Vector3(-2.47f, -1.087f);
                            bonnet.localPosition = new Vector3(2.45714f, 0.21428f);
                            frontDoor.localPosition = new Vector3(0.714281f, -0.0142933f);
                            Instance.transform.GetChild(8).localPosition = new Vector3(-2.829f, -0.69f);

                            Transform engine = Instance.transform.GetChild(7);
                            engine.localScale = new Vector3(1.1f, 1.1f);
                            engine.localPosition = new Vector3(2.437f, -0.203f);

                            Instance.AddComponent<ObjectSerialisationHelper>().Object = hatch;
                            Instance.AddComponent<ObjectSerialisationHelper>().Object = backDoor;
                            Instance.AddComponent<ObjectSerialisationHelper>().Object = spareWheel;
                        };

                        NoCollide noCollide = Instance.GetComponent<NoCollide>();
                        noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                        noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                    }
                }
            );
            ModAPI.Register(
                new Modification
                {
                    OriginalItem = ModAPI.FindSpawnable("Car"),
                    NameOverride = "Ford E-350 Ambulance" + tag,
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/Cars/Ford E-350/Thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Transform body = Instance.transform.GetChild(0);
                        BoxCollider2D[] boxColliders = body.GetComponents<BoxCollider2D>();
                        boxColliders[0].offset = new Vector2(1.977364f, -1.05674f);
                        boxColliders[0].size = new Vector2(0.7118301f, 0.4708023f);
                        boxColliders[1].offset = new Vector2(1.660072f, -0.2506199f);
                        boxColliders[1].size = new Vector2(0.2246094f, 1.269726f);
                        boxColliders[2].offset = new Vector2(0.11f, -1.03f);
                        boxColliders[2].size = new Vector2(0.7118301f, 0.4708023f);
                        boxColliders[3].offset = new Vector2(0.4195f, -0.21f);
                        boxColliders[3].size = new Vector2(0.2246094f, 1.269726f);
                        body.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-4.15699f, 1.271362f),
                            new Vector2(-4.042915f, 1.27137f),
                            new Vector2(-4.042915f, 1.620312f),
                            new Vector2(1.271351f, 1.620312f),
                            new Vector2(1.271351f, -1.214344f),
                            new Vector2(-4.185806f, -1.214344f),
                            new Vector2(-4.185757f, -1.528603f),
                            new Vector2(-4.614273f, -1.557201f),
                            new Vector2(-4.614296f, -1.699993f),
                            new Vector2(4.03906f, -1.697103f),
                            new Vector2(4.585949f, -1.556934f),
                            new Vector2(4.471359f, -1.014336f),
                            new Vector2(4.471424f, -0.5000725f),
                            new Vector2(4.442845f, -0.4429521f),
                            new Vector2(3.331085f, -0.4425125f),
                            new Vector2(3.330987f, -0.1287291f),
                            new Vector2(3.244163f, -0.1000191f),
                            new Vector2(2.329304f, 0.8423538f),
                            new Vector2(2.185619f, 0.8999481f),
                            new Vector2(1.357086f, 0.8999481f),
                            new Vector2(1.357095f, 1.699989f),
                            new Vector2(-4.157199f, 1.7f)
                        });
                        body.GetComponent<PolygonCollider2D>().SetPath(1, new Vector2[]
                        {
                            new Vector2(1.44279f, 0.7856209f),
                            new Vector2(2.242751f, 0.7857201f),
                            new Vector2(2.99045f, 0.07853732f),
                            new Vector2(3.012846f, 0.01302207f),
                            new Vector2(3.01373f, -0.4730177f),
                            new Vector2(2.932734f, -0.9890246f),
                            new Vector2(2.813897f, -1.242858f),
                            new Vector2(1.442806f, -1.242916f)
                        });
                        body.GetChild(0).localPosition = new Vector3(0.1285691f, -0.0571456f);
                        body.GetComponent<SpriteRenderer>().sortingOrder = 4;
                        body.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";

                        BoxCollider2D trigger = body.gameObject.AddComponent<BoxCollider2D>();
                        trigger.offset = new Vector2(-1.39292f, 0.1885738f);
                        trigger.size = new Vector2(5.408474f, 2.94289f);
                        trigger.isTrigger = true;

                        GameObject background2 = new GameObject("Background 2");
                        background2.transform.parent = body;
                        background2.transform.rotation = body.rotation;
                        background2.transform.localScale = Vector3.one;
                        background2.transform.localPosition = new Vector3(-0.642867f, -0.442908f);
                        SpriteRenderer background2Renderer = background2.AddComponent<SpriteRenderer>();
                        background2Renderer.sprite = ModAPI.LoadSprite("Textures/Cars/Ford E-350/Background2.png");
                        background2Renderer.sortingOrder = 2;
                        background2Renderer.sortingLayerName = "Foreground";
                        background2.AddComponent<Optout>();

                        GameObject background3 = new GameObject("Background 3");
                        background3.transform.parent = body;
                        background3.transform.rotation = body.rotation;
                        background3.transform.localScale = Vector3.one;
                        background3.transform.localPosition = new Vector3(-3.285767f, -1.142908f);
                        SpriteRenderer background3Renderer = background3.AddComponent<SpriteRenderer>();
                        background3Renderer.sprite = ModAPI.LoadSprite("Textures/Cars/Ford E-350/Background3.png");
                        background3Renderer.sortingOrder = 2;
                        background3Renderer.sortingLayerName = "Foreground";
                        background3.AddComponent<Optout>();

                        WheelJoint2D[] wheels = body.GetComponents<WheelJoint2D>();
                        wheels[0].anchor = new Vector2(3.58f, -1.635f);
                        wheels[0].connectedBody.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Cars/Ford E-350/Wheel.png");
                        wheels[0].connectedBody.GetComponent<CircleCollider2D>().radius = 0.6142857f;
                        wheels[1].anchor = new Vector2(-1.733f, -1.635f);
                        wheels[1].connectedBody.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Cars/Ford E-350/Wheel.png");
                        wheels[1].connectedBody.GetComponent<SpriteRenderer>().sortingOrder = 3;
                        wheels[1].connectedBody.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                        wheels[1].connectedBody.GetComponent<CircleCollider2D>().radius = 0.6142857f;

                        Transform bonnet = Instance.transform.GetChild(3);
                        bonnet.GetComponent<HingeJoint2D>().anchor = new Vector2(-0.544342f, 0.1267281f);
                        bonnet.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.4293824f, 0.1572153f),
                            new Vector2(-0.5428572f, 0.1571429f),
                            new Vector2(-0.5428457f, 0.1000585f),
                            new Vector2(0.3131017f, -0.09915575f),
                            new Vector2(0.4570781f, -0.1571429f),
                            new Vector2(0.5428572f, -0.1571429f),
                            new Vector2(0.5428534f, -0.1286338f),
                            new Vector2(0.4284404f, -0.04291502f)
                        });

                        Instance.transform.GetChild(4).gameObject.SetActive(false);

                        Transform frontDoor = Instance.transform.GetChild(5);
                        frontDoor.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.8142857f, 1.228571f),
                            new Vector2(-0.8142857f, -1.228571f),
                            new Vector2(0.4998886f, -1.228606f),
                            new Vector2(0.8142857f, -0.0571965f),
                            new Vector2(0.8142819f, 0.4285102f),
                            new Vector2(0.01434796f, 1.228571f)
                        });

                        GameObject backDoor = new GameObject("Back Door");
                        backDoor.transform.parent = Instance.transform;
                        backDoor.transform.rotation = Instance.transform.rotation;
                        backDoor.transform.localScale = Vector3.one;
                        backDoor.transform.localPosition = new Vector3(-4.100057f, 0.028516f);
                        backDoor.layer = 11;
                        backDoor.AddComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Cars/Ford E-350/AmbulanceSkin1/BackDoorClosed.png");
                        backDoor.AddComponent<BoxCollider2D>();
                        backDoor.AddComponent<Rigidbody2D>().mass = 0.5f;
                        FixedJoint2D backDoorFixedJoint = backDoor.AddComponent<FixedJoint2D>();
                        backDoorFixedJoint.connectedBody = body.GetComponent<Rigidbody2D>();
                        backDoorFixedJoint.breakForce = 2000f;
                        backDoorFixedJoint.breakTorque = 1500f;
                        AudioSource backDoorAudioSource = backDoor.AddComponent<AudioSource>();
                        backDoorAudioSource.spread = 0f;
                        backDoorAudioSource.volume = 1f;
                        backDoorAudioSource.minDistance = 1f;
                        backDoorAudioSource.spatialBlend = 1f;
                        backDoorAudioSource.dopplerLevel = 0f;
                        backDoor.AddComponent<JointSerialisationHelper>().Joint = backDoorFixedJoint;
                        BackDoorBehaviour backDoorBehaviour = backDoor.AddComponent<BackDoorBehaviour>();
                        backDoorBehaviour.HasSpareWheel = false;
                        backDoorBehaviour.Textures = new BackDoorBehaviour.DoorSprites[]
                        {
                            new BackDoorBehaviour.DoorSprites
                            {
                                ClosedSprite = ModAPI.LoadSprite("Textures/Cars/Ford E-350/AmbulanceSkin1/BackDoorClosed.png"),
                                OpenSprite = ModAPI.LoadSprite("Textures/Cars/Ford E-350/AmbulanceSkin1/BackDoorOpen.png")
                            },
                            new BackDoorBehaviour.DoorSprites
                            {
                                ClosedSprite = ModAPI.LoadSprite("Textures/Cars/Ford E-350/AmbulanceSkin2/BackDoorClosed.png"),
                                OpenSprite = ModAPI.LoadSprite("Textures/Cars/Ford E-350/AmbulanceSkin2/BackDoorOpen.png")
                            },
                            new BackDoorBehaviour.DoorSprites
                            {
                                ClosedSprite = ModAPI.LoadSprite("Textures/Cars/Ford E-350/AmbulanceSkin3/BackDoorClosed.png"),
                                OpenSprite = ModAPI.LoadSprite("Textures/Cars/Ford E-350/AmbulanceSkin3/BackDoorOpen.png")
                            }
                        };
                        JointBreakSoundBehaviour backDoorJointBreakSound = backDoor.AddComponent<JointBreakSoundBehaviour>();
                        backDoorJointBreakSound.Clips = frontDoor.GetComponent<JointBreakSoundBehaviour>().Clips;
                        backDoorJointBreakSound.AudioSource = backDoorAudioSource;
                        backDoorJointBreakSound.Joints = new Joint2D[]
                        {
                            backDoorFixedJoint
                        };
                        backDoorJointBreakSound.OnBreak = new UnityEvent();
                        backDoorJointBreakSound.OnBreak.AddListener(() =>
                        {
                            backDoorJointBreakSound.Joints = new Joint2D[0];
                        });
                        backDoor.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        backDoor.AddComponent<AudioSourceTimeScaleBehaviour>();
                        backDoor.AddComponent<Optout>();

                        GameObject sideDoor1 = new GameObject("SideDoor1");
                        sideDoor1.transform.parent = Instance.transform;
                        sideDoor1.transform.rotation = Instance.transform.rotation;
                        sideDoor1.transform.localScale = Vector3.one;
                        sideDoor1.transform.localPosition = new Vector3(-0.185771f, -0.085773f);
                        sideDoor1.layer = 10;
                        SpriteRenderer sideDoor1Renderer = sideDoor1.AddComponent<SpriteRenderer>();
                        sideDoor1Renderer.sortingOrder = 5;
                        sideDoor1Renderer.sortingLayerName = "Foreground";
                        sideDoor1.AddComponent<RandomCarTextureChildBehaviour>().Sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("Textures/Cars/Ford E-350/AmbulanceSkin1/SideDoor1.png"),
                            ModAPI.LoadSprite("Textures/Cars/Ford E-350/AmbulanceSkin2/SideDoor1.png"),
                            ModAPI.LoadSprite("Textures/Cars/Ford E-350/AmbulanceSkin3/SideDoor1.png")
                        };
                        sideDoor1.AddComponent<BoxCollider2D>().size = new Vector3(1.085714f, 3.057143f);
                        sideDoor1.AddComponent<Rigidbody2D>().mass = 0.5f;
                        FixedJoint2D sideDoor1FixedJoint = sideDoor1.AddComponent<FixedJoint2D>();
                        sideDoor1FixedJoint.connectedBody = body.GetComponent<Rigidbody2D>();
                        sideDoor1FixedJoint.breakForce = 500f;
                        sideDoor1FixedJoint.breakTorque = 500f;
                        HingeJoint2D sideDoor1HingeJoint = sideDoor1.AddComponent<HingeJoint2D>();
                        sideDoor1HingeJoint.connectedBody = body.GetComponent<Rigidbody2D>();
                        sideDoor1HingeJoint.anchor = new Vector2(0.5428543f, 0f);
                        sideDoor1HingeJoint.breakForce = 2000f;
                        sideDoor1HingeJoint.breakTorque = 1500f;
                        sideDoor1HingeJoint.limits = frontDoor.GetComponent<HingeJoint2D>().limits;
                        sideDoor1HingeJoint.useLimits = true;
                        sideDoor1HingeJoint.motor = frontDoor.GetComponent<HingeJoint2D>().motor;
                        sideDoor1HingeJoint.useMotor = true;
                        AudioSource audioSource = sideDoor1.AddComponent<AudioSource>();
                        audioSource.spread = 0f;
                        audioSource.volume = 1f;
                        audioSource.minDistance = 1f;
                        audioSource.spatialBlend = 1f;
                        audioSource.dopplerLevel = 0f;
                        JointSerialisationHelper sideDoor1HingeJointSerialisationHelper = sideDoor1.AddComponent<JointSerialisationHelper>();
                        sideDoor1HingeJointSerialisationHelper.Joint = sideDoor1FixedJoint;
                        sideDoor1.AddComponent<JointSerialisationHelper>().Joint = sideDoor1HingeJoint;
                        JointBreakSoundBehaviour sideDoor1JointBreakSound = sideDoor1.AddComponent<JointBreakSoundBehaviour>();
                        sideDoor1JointBreakSound.Clips = frontDoor.GetComponent<JointBreakSoundBehaviour>().Clips;
                        sideDoor1JointBreakSound.AudioSource = audioSource;
                        sideDoor1JointBreakSound.Joints = new Joint2D[]
                        {
                            sideDoor1HingeJoint
                        };
                        sideDoor1JointBreakSound.OnBreak = new UnityEvent();
                        sideDoor1.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        sideDoor1.AddComponent<AudioSourceTimeScaleBehaviour>();
                        sideDoor1.AddComponent<Optout>();

                        GameObject sideDoor2 = new GameObject("SideDoor2");
                        sideDoor2.transform.parent = Instance.transform;
                        sideDoor2.transform.rotation = Instance.transform.rotation;
                        sideDoor2.transform.localScale = Vector3.one;
                        sideDoor2.transform.localPosition = new Vector3(0.828508f, -0.400058f);
                        sideDoor2.layer = 10;
                        SpriteRenderer sideDoor2Renderer = sideDoor2.AddComponent<SpriteRenderer>();
                        sideDoor2Renderer.sortingOrder = 5;
                        sideDoor2Renderer.sortingLayerName = "Foreground";
                        sideDoor2.AddComponent<RandomCarTextureChildBehaviour>().Sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("Textures/Cars/Ford E-350/AmbulanceSkin1/SideDoor2.png"),
                            ModAPI.LoadSprite("Textures/Cars/Ford E-350/AmbulanceSkin2/SideDoor2.png"),
                            ModAPI.LoadSprite("Textures/Cars/Ford E-350/AmbulanceSkin3/SideDoor2.png")
                        };
                        sideDoor2.AddComponent<BoxCollider2D>().size = new Vector3(0.7142857f, 2.428571f);
                        sideDoor2.AddComponent<Rigidbody2D>().mass = 0.35f;
                        FixedJoint2D sideDoor2FixedJoint = sideDoor2.AddComponent<FixedJoint2D>();
                        sideDoor2FixedJoint.connectedBody = body.GetComponent<Rigidbody2D>();
                        sideDoor2FixedJoint.breakForce = 400f;
                        sideDoor2FixedJoint.breakTorque = 400f;
                        HingeJoint2D sideDoor2HingeJoint = sideDoor2.AddComponent<HingeJoint2D>();
                        sideDoor2HingeJoint.connectedBody = body.GetComponent<Rigidbody2D>();
                        sideDoor2HingeJoint.anchor = new Vector2(0.3453674f, 0f);
                        sideDoor2HingeJoint.breakForce = 1800f;
                        sideDoor2HingeJoint.breakTorque = 1300f;
                        sideDoor2HingeJoint.limits = frontDoor.GetComponent<HingeJoint2D>().limits;
                        sideDoor2HingeJoint.useLimits = true;
                        sideDoor2HingeJoint.motor = frontDoor.GetComponent<HingeJoint2D>().motor;
                        sideDoor2HingeJoint.useMotor = true;
                        AudioSource sideDoor2AudioSource = sideDoor2.AddComponent<AudioSource>();
                        sideDoor2AudioSource.spread = 0f;
                        sideDoor2AudioSource.volume = 1f;
                        sideDoor2AudioSource.minDistance = 1f;
                        sideDoor2AudioSource.spatialBlend = 1f;
                        sideDoor2AudioSource.dopplerLevel = 0f;
                        sideDoor2.AddComponent<JointSerialisationHelper>().Joint = sideDoor2FixedJoint;
                        sideDoor2.AddComponent<JointSerialisationHelper>().Joint = sideDoor2HingeJoint;
                        JointBreakSoundBehaviour sideDoor2JointBreakSound = sideDoor2.AddComponent<JointBreakSoundBehaviour>();
                        sideDoor2JointBreakSound.Clips = frontDoor.GetComponent<JointBreakSoundBehaviour>().Clips;
                        sideDoor2JointBreakSound.AudioSource = sideDoor2AudioSource;
                        sideDoor2JointBreakSound.Joints = new Joint2D[]
                        {
                            sideDoor2HingeJoint
                        };
                        sideDoor2JointBreakSound.OnBreak = new UnityEvent();
                        sideDoor2JointBreakSound.OnBreak.AddListener(() =>
                        {
                            sideDoor2JointBreakSound.Joints = new Joint2D[0];
                        });
                        sideDoor2.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        sideDoor2.AddComponent<AudioSourceTimeScaleBehaviour>();
                        sideDoor2.AddComponent<Optout>();

                        GameObject sideDoor3 = new GameObject("SideDoor3");
                        sideDoor3.transform.parent = Instance.transform;
                        sideDoor3.transform.rotation = Instance.transform.rotation;
                        sideDoor3.transform.localScale = Vector3.one;
                        sideDoor3.transform.localPosition = new Vector3(-3.285776f, -1.142917f);
                        sideDoor3.layer = 10;
                        SpriteRenderer sideDoor3Renderer = sideDoor3.AddComponent<SpriteRenderer>();
                        sideDoor3Renderer.sortingOrder = 5;
                        sideDoor3Renderer.sortingLayerName = "Foreground";
                        sideDoor3.AddComponent<RandomCarTextureChildBehaviour>().Sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("Textures/Cars/Ford E-350/AmbulanceSkin1/SideDoor3.png"),
                            ModAPI.LoadSprite("Textures/Cars/Ford E-350/AmbulanceSkin2/SideDoor3.png"),
                            ModAPI.LoadSprite("Textures/Cars/Ford E-350/AmbulanceSkin3/SideDoor3.png")
                        };
                        sideDoor3.AddComponent<BoxCollider2D>().size = new Vector3(1.4f, 0.8285714f);
                        sideDoor3.AddComponent<Rigidbody2D>().mass = 0.15f;
                        FixedJoint2D sideDoor3FixedJoint = sideDoor3.AddComponent<FixedJoint2D>();
                        sideDoor3FixedJoint.connectedBody = body.GetComponent<Rigidbody2D>();
                        sideDoor3FixedJoint.breakForce = 100f;
                        sideDoor3FixedJoint.breakTorque = 100f;
                        HingeJoint2D sideDoor3HingeJoint = sideDoor3.AddComponent<HingeJoint2D>();
                        sideDoor3HingeJoint.connectedBody = body.GetComponent<Rigidbody2D>();
                        sideDoor3HingeJoint.anchor = new Vector2(0.6864777f, 0f);
                        sideDoor3HingeJoint.breakForce = 1000f;
                        sideDoor3HingeJoint.breakTorque = 500f;
                        sideDoor3HingeJoint.limits = frontDoor.GetComponent<HingeJoint2D>().limits;
                        sideDoor3HingeJoint.useLimits = true;
                        sideDoor3HingeJoint.motor = frontDoor.GetComponent<HingeJoint2D>().motor;
                        sideDoor3HingeJoint.useMotor = true;
                        AudioSource sideDoor3AudioSource = sideDoor3.AddComponent<AudioSource>();
                        sideDoor3AudioSource.spread = 0f;
                        sideDoor3AudioSource.volume = 1f;
                        sideDoor3AudioSource.minDistance = 1f;
                        sideDoor3AudioSource.spatialBlend = 1f;
                        sideDoor3AudioSource.dopplerLevel = 0f;
                        sideDoor3.AddComponent<JointSerialisationHelper>().Joint = sideDoor3FixedJoint;
                        JointSerialisationHelper sideDoor3HingeJointSerialisationHelper = sideDoor3.AddComponent<JointSerialisationHelper>();
                        sideDoor3HingeJointSerialisationHelper.Joint = sideDoor3HingeJoint;
                        JointBreakSoundBehaviour sideDoor3JointBreakSound = sideDoor3.AddComponent<JointBreakSoundBehaviour>();
                        sideDoor3JointBreakSound.Clips = frontDoor.GetComponent<JointBreakSoundBehaviour>().Clips;
                        sideDoor3JointBreakSound.AudioSource = sideDoor3AudioSource;
                        sideDoor3JointBreakSound.Joints = new Joint2D[]
                        {
                            sideDoor3HingeJoint
                        };
                        sideDoor3JointBreakSound.OnBreak = new UnityEvent();
                        sideDoor3.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        sideDoor3.AddComponent<AudioSourceTimeScaleBehaviour>();
                        sideDoor3.AddComponent<Optout>();

                        GameObject blinker = new GameObject("Blinker");
                        blinker.transform.parent = Instance.transform;
                        blinker.transform.rotation = body.transform.rotation;
                        blinker.transform.localScale = Vector3.one;
                        blinker.transform.localPosition = new Vector3(1.798f, 0.986f);
                        SpriteRenderer blinkerRenderer = blinker.AddComponent<SpriteRenderer>();
                        blinkerRenderer.sprite = ModAPI.LoadSprite("Textures/AmbulanceBlinker.png");
                        blinker.layer = 9;
                        blinker.AddComponent<BoxCollider2D>();
                        blinker.AddComponent<Rigidbody2D>().mass = 1.5f;
                        FixedJoint2D fixedJoint = blinker.AddComponent<FixedJoint2D>();
                        fixedJoint.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                        fixedJoint.breakForce = 5000f;
                        blinker.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Flammable metal");
                        DamagableMachineryBehaviour damagable = blinker.AddComponent<DamagableMachineryBehaviour>();
                        damagable.FirearmDamageMultiplier = 1f;
                        damagable.ExplosionDamageMultiplier = 100f;
                        damagable.Health = 50f;
                        damagable.BehavioursToToggle = new MonoBehaviour[0];
                        damagable.GameObjectsToToggle = new GameObject[0];
                        damagable.Waterproof = false;
                        blinker.AddComponent<JointSerialisationHelper>().Joint = fixedJoint;
                        AudioSource audio = blinker.AddComponent<AudioSource>();
                        audio.loop = true;
                        audio.clip = ModAPI.LoadSound("Sounds/PoliceBlinker.mp3");
                        audio.spatialBlend = 1f;
                        blinker.AddComponent<AudioSourceTimeScaleBehaviour>();
                        blinker.AddComponent<Optout>();

                        GameObject glow1 = new GameObject("Glow 1");
                        glow1.transform.parent = blinker.transform;
                        glow1.transform.rotation = blinker.transform.rotation;
                        glow1.transform.localScale = Vector3.one;
                        glow1.transform.localPosition = new Vector3(-0.25714f, 0.014288f);
                        SpriteRenderer glow1Renderer = glow1.AddComponent<SpriteRenderer>();
                        glow1Renderer.sprite = ModAPI.LoadSprite("Textures/PoliceBlinkerGlowMask.png");
                        glow1Renderer.sortingOrder = blinkerRenderer.sortingOrder + 1;
                        glow1Renderer.sortingLayerName = blinkerRenderer.sortingLayerName;
                        glow1Renderer.color = Color.red;
                        glow1.AddComponent<Optout>();
                        ModAPI.CreateLight(glow1.transform, Color.red, 15f, 3f);

                        GameObject glow2 = new GameObject("Glow 2");
                        glow2.transform.parent = blinker.transform;
                        glow2.transform.rotation = blinker.transform.rotation;
                        glow2.transform.localScale = new Vector3(-1f, 1f, 1f);
                        glow2.transform.localPosition = new Vector3(0.25714f, 0.014288f);
                        SpriteRenderer glow2Renderer = glow2.AddComponent<SpriteRenderer>();
                        glow2Renderer.sprite = ModAPI.LoadSprite("Textures/PoliceBlinkerGlowMask.png");
                        glow2Renderer.sortingOrder = blinkerRenderer.sortingOrder + 1;
                        glow2Renderer.sortingLayerName = blinkerRenderer.sortingLayerName;
                        glow2Renderer.color = Color.red;
                        glow2.AddComponent<Optout>();
                        ModAPI.CreateLight(glow2.transform, Color.red, 15f, 3f);

                        GameObject glow3 = new GameObject("Glow 3");
                        glow3.transform.parent = body.transform;
                        glow3.transform.rotation = body.transform.rotation;
                        glow3.transform.localScale = Vector3.one;
                        glow3.transform.localPosition = new Vector3(0.799941f, 1.37137f);
                        SpriteRenderer glow3Renderer = glow3.AddComponent<SpriteRenderer>();
                        glow3Renderer.sprite = ModAPI.LoadSprite("Textures/Cars/Ford E-350/GlowMask.png");
                        glow3Renderer.sortingOrder = body.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        glow3Renderer.sortingLayerName = body.GetComponent<SpriteRenderer>().sortingLayerName;
                        glow3Renderer.color = Color.red;
                        glow3.AddComponent<Optout>();
                        ModAPI.CreateLight(glow3.transform, Color.red, 5f, 3f);

                        GameObject glow4 = new GameObject("Glow 4");
                        glow4.transform.parent = body.transform;
                        glow4.transform.rotation = body.transform.rotation;
                        glow4.transform.localScale = Vector3.one;
                        glow4.transform.localPosition = new Vector3(-3.200062f, 1.37137f);
                        SpriteRenderer glow4Renderer = glow4.AddComponent<SpriteRenderer>();
                        glow4Renderer.sprite = ModAPI.LoadSprite("Textures/Cars/Ford E-350/GlowMask.png");
                        glow4Renderer.sortingOrder = body.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        glow4Renderer.sortingLayerName = body.GetComponent<SpriteRenderer>().sortingLayerName;
                        glow4.AddComponent<Optout>();
                        ModAPI.CreateLight(glow4.transform, Color.white, 5f, 1f);

                        GameObject glow5 = new GameObject("Glow 5");
                        glow5.transform.parent = body.transform;
                        glow5.transform.rotation = body.transform.rotation;
                        glow5.transform.localScale = Vector3.one;
                        glow5.transform.localPosition = new Vector3(-3.714346f, 1.37137f);
                        SpriteRenderer glow5Renderer = glow5.AddComponent<SpriteRenderer>();
                        glow5Renderer.sprite = ModAPI.LoadSprite("Textures/Cars/Ford E-350/GlowMask.png");
                        glow5Renderer.sortingOrder = body.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        glow5Renderer.sortingLayerName = body.GetComponent<SpriteRenderer>().sortingLayerName;
                        glow5Renderer.color = Color.red;
                        glow5.AddComponent<Optout>();
                        ModAPI.CreateLight(glow5.transform, Color.red, 5f, 3f);

                        GameObject glow6 = new GameObject("Glow 6");
                        glow6.transform.parent = body.transform;
                        glow6.transform.rotation = body.transform.rotation;
                        glow6.transform.localScale = Vector3.one;
                        glow6.transform.localPosition = new Vector3(4.142795f, -0.657194f);
                        SpriteRenderer glow6Renderer = glow6.AddComponent<SpriteRenderer>();
                        glow6Renderer.sprite = ModAPI.LoadSprite("Textures/Cars/Ford E-350/GlowMask2.png");
                        glow6Renderer.sortingOrder = body.GetComponent<SpriteRenderer>().sortingOrder + 1;
                        glow6Renderer.sortingLayerName = body.GetComponent<SpriteRenderer>().sortingLayerName;
                        glow6Renderer.color = Color.red;
                        glow6.AddComponent<Optout>();
                        ModAPI.CreateLight(glow6.transform, Color.red, 3.5f, 3f);

                        AmbulanceBlinkerBehaviour blinkerBehaviour = blinker.GetOrAddComponent<AmbulanceBlinkerBehaviour>();
                        blinkerBehaviour.Glow1 = glow1;
                        blinkerBehaviour.Glow2 = glow2;
                        blinkerBehaviour.Glow3 = glow3;
                        blinkerBehaviour.Glow4 = glow4;
                        blinkerBehaviour.Glow5 = glow5;
                        blinkerBehaviour.Glow6 = glow6;
                        blinkerBehaviour.Audio = audio;
                        blinkerBehaviour.Delay = 1f;

                        Instance.transform.GetChild(6).gameObject.SetActive(false);

                        body.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[]
                        {
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Ford E-350/AmbulanceSkin1/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Ford E-350/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Ford E-350/AmbulanceSkin1/Bonnet.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Ford E-350/AmbulanceSkin1/FrontDoor.png")
                            },
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Ford E-350/AmbulanceSkin2/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Ford E-350/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Ford E-350/AmbulanceSkin2/Bonnet.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Ford E-350/AmbulanceSkin2/FrontDoor.png")
                            },
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Ford E-350/AmbulanceSkin3/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Ford E-350/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Ford E-350/AmbulanceSkin3/Bonnet.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Ford E-350/AmbulanceSkin3/FrontDoor.png")
                            }
                        };

                        Sprite leftBody1 = ModAPI.LoadSprite("Textures/Cars/Ford E-350/AmbulanceSkin1/Body2.png");
                        Sprite leftBody2 = ModAPI.LoadSprite("Textures/Cars/Ford E-350/AmbulanceSkin2/Body2.png");
                        Sprite leftBody3 = ModAPI.LoadSprite("Textures/Cars/Ford E-350/AmbulanceSkin3/Body2.png");
                        Sprite leftBackDoorOpen1 = ModAPI.LoadSprite("Textures/Cars/Ford E-350/AmbulanceSkin1/BackDoorOpen2.png");
                        Sprite leftBackDoorOpen3 = ModAPI.LoadSprite("Textures/Cars/Ford E-350/AmbulanceSkin3/BackDoorOpen2.png");
                        Sprite leftSideDoor21 = ModAPI.LoadSprite("Textures/Cars/Ford E-350/AmbulanceSkin1/SideDoor22.png");
                        Sprite leftSideDoor33 = ModAPI.LoadSprite("Textures/Cars/Ford E-350/AmbulanceSkin3/SideDoor32.png");

                        NoCollideWithObjectsInTrigger noCollideWithObjectsInTrigger = body.gameObject.AddComponent<NoCollideWithObjectsInTrigger>();
                        noCollideWithObjectsInTrigger.Colliders = new Collider2D[]
                        {
                            wheels[1].connectedBody.GetComponent<CircleCollider2D>(),
                            Instance.transform.GetChild(8).GetComponent<BoxCollider2D>()
                        };
                        noCollideWithObjectsInTrigger.Trigger = trigger;

                        Sprite[] spritesWhenShowInside = new Sprite[]
                        {
                            ModAPI.LoadSprite("Textures/Cars/Ford E-350/AmbulanceSkin1/BodyWhenShowInside.png"),
                            ModAPI.LoadSprite("Textures/Cars/Ford E-350/AmbulanceSkin2/BodyWhenShowInside.png"),
                            ModAPI.LoadSprite("Textures/Cars/Ford E-350/AmbulanceSkin3/BodyWhenShowInside.png")
                        };
                        CarSerialisationHelper carSerialisationHelper = Instance.AddComponent<CarSerialisationHelper>();
                        carSerialisationHelper.HasInside = true;
                        carSerialisationHelper.AfterFirstSpawn = () =>
                        {
                            body.GetComponent<CarBehaviour>().MotorSpeed = -3800f;

                            wheels[0].connectedBody.transform.localPosition = new Vector3(3.58f, -1.635f);
                            wheels[1].connectedBody.transform.localPosition = new Vector3(-1.733f, -1.635f);
                            bonnet.localPosition = new Vector3(3.871431f, -0.285715f);
                            frontDoor.localPosition = new Vector3(2.228507f, -0.4143363f);
                            Instance.transform.GetChild(7).localPosition = new Vector3(3.73f, -0.77f);
                            Instance.transform.GetChild(8).localPosition = new Vector3(-2.43f, -1.3f);

                            Instance.AddComponent<ObjectSerialisationHelper>().Object = sideDoor1;
                            Instance.AddComponent<ObjectSerialisationHelper>().Object = sideDoor2;
                            Instance.AddComponent<ObjectSerialisationHelper>().Object = sideDoor3;
                            Instance.AddComponent<ObjectSerialisationHelper>().Object = backDoor;
                            Instance.AddComponent<ObjectSerialisationHelper>().Object = blinker;
                        };
                        carSerialisationHelper.AfterSpawn = () =>
                        {
                            carSerialisationHelper.inside.ForegroundsRenderer = new SpriteRenderer[]
                            {
                                background3Renderer,
                                sideDoor1Renderer,
                                sideDoor3Renderer
                            };
                            carSerialisationHelper.inside.SpritesWhenShowInside = spritesWhenShowInside;
                            carSerialisationHelper.inside.OnToggleInside.AddListener(() =>
                            {
                                if (carSerialisationHelper.inside.ShowInside)
                                {
                                    glow4.SetActive(false);
                                    glow5.SetActive(false);
                                    blinkerBehaviour.Glow4 = null;
                                    blinkerBehaviour.Glow5 = null;
                                }
                                else
                                {
                                    blinkerBehaviour.Glow4 = glow4;
                                    blinkerBehaviour.Glow5 = glow5;
                                }
                            });

                            sideDoor3JointBreakSound.OnBreak.AddListener(() =>
                            {
                                sideDoor3JointBreakSound.Joints = new Joint2D[0];
                                if (carSerialisationHelper.inside.ShowInside)
                                {
                                    sideDoor3Renderer.color = Color.white;
                                }
                                List<SpriteRenderer> renderers = carSerialisationHelper.inside.ForegroundsRenderer.ToList();
                                renderers.Remove(sideDoor3Renderer);
                                carSerialisationHelper.inside.ForegroundsRenderer = renderers.ToArray();
                            });

                            sideDoor1JointBreakSound.OnBreak.AddListener(() =>
                            {
                                sideDoor1JointBreakSound.Joints = new Joint2D[0];
                                if (carSerialisationHelper.inside.ShowInside)
                                {
                                    sideDoor1Renderer.color = Color.white;
                                }
                                List<SpriteRenderer> renderers = carSerialisationHelper.inside.ForegroundsRenderer.ToList();
                                renderers.Remove(sideDoor1Renderer);
                                carSerialisationHelper.inside.ForegroundsRenderer = renderers.ToArray();
                            });

                            if (sideDoor1HingeJointSerialisationHelper.Broken)
                            {
                                sideDoor1JointBreakSound.OnBreak.Invoke();
                            }
                            if (sideDoor3HingeJointSerialisationHelper.Broken)
                            {
                                sideDoor3JointBreakSound.OnBreak.Invoke();
                            }
                        };
                        carSerialisationHelper.Left = () =>
                        {
                            if (body.GetComponent<RandomCarTextureBehaviour>().chosenIndex == 0)
                            {
                                sideDoor2Renderer.sprite = leftSideDoor21;
                                body.GetComponent<SpriteRenderer>().sprite = leftBody1;
                                if (backDoorBehaviour.Activated)
                                {
                                    backDoor.GetComponent<SpriteRenderer>().sprite = leftBackDoorOpen1;
                                }
                            }
                            else if (body.GetComponent<RandomCarTextureBehaviour>().chosenIndex == 1)
                            {
                                body.GetComponent<SpriteRenderer>().sprite = leftBody2;
                            }
                            else if (body.GetComponent<RandomCarTextureBehaviour>().chosenIndex == 2)
                            {
                                sideDoor3Renderer.sprite = leftSideDoor33;
                                body.GetComponent<SpriteRenderer>().sprite = leftBody3;
                                if (backDoorBehaviour.Activated)
                                {
                                    backDoor.GetComponent<SpriteRenderer>().sprite = leftBackDoorOpen3;
                                }
                            }
                            sideDoor2.GetComponent<RandomCarTextureChildBehaviour>().Sprites[0] = leftSideDoor21;
                            sideDoor3.GetComponent<RandomCarTextureChildBehaviour>().Sprites[2] = leftSideDoor33;
                            backDoorBehaviour.Textures[0].OpenSprite = leftBackDoorOpen1;
                            backDoorBehaviour.Textures[2].OpenSprite = leftBackDoorOpen3;
                            body.GetComponent<RandomCarTextureBehaviour>().Textures[0].Body = leftBody1;
                            body.GetComponent<RandomCarTextureBehaviour>().Textures[1].Body = leftBody2;
                            body.GetComponent<RandomCarTextureBehaviour>().Textures[2].Body = leftBody3;
                        };

                        NoCollide noCollide = Instance.GetComponent<NoCollide>();
                        noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                        noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Car"),
                    NameOverride = "Lenco BearCat G3" + tag,
                    DescriptionOverride = "The Lenco BearCat is a wheeled SWAT vehicle designed for military and law enforcement use. It is in use by several military forces and law enforcement agencies around the world.",
                    NameToOrderByOverride = "!",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/Cars/Lenco BearCat G3/Thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Transform body = Instance.transform.GetChild(0);
                        body.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                        body.GetComponent<SpriteRenderer>().sortingOrder = 4;
                        BoxCollider2D[] boxColliders = body.GetComponents<BoxCollider2D>();
                        boxColliders[0].offset = new Vector2(-2.394135f, 1.111959f);
                        boxColliders[0].size = new Vector2(2.668991f, 0.1181691f);
                        boxColliders[1].offset = new Vector2(-1.08649f, 1.212258f);
                        boxColliders[1].size = new Vector2(0.08427429f, 0.3187666f);
                        boxColliders[2].offset = new Vector2(0.8621271f, -0.8355286f);
                        boxColliders[2].size = new Vector2(0.7376524f, 0.3849792f);
                        boxColliders[3].offset = new Vector2(0.5497106f, -0.09211683f);
                        boxColliders[3].size = new Vector2(0.2151401f, 1.320908f);
                        BoxCollider2D boxCollider1 = body.gameObject.AddComponent<BoxCollider2D>();
                        boxCollider1.offset = new Vector2(-2.394135f, 1.111959f);
                        boxCollider1.size = new Vector2(2.668991f, 0.1181691f);
                        body.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(3.900675f, -0.2068939f),
                            new Vector2(2.357086f, -0.2068939f),
                            new Vector2(2.357086f, 0.1999435f),
                            new Vector2(1.385658f, 1.171371f),
                            new Vector2(-0.07148743f, 1.171371f),
                            new Vector2(-0.07148743f, 1.371429f),
                            new Vector2(-0.1553116f, 1.371429f),
                            new Vector2(-0.1553116f, 1.052872f),
                            new Vector2(1.274643f, 1.052872f),
                            new Vector2(1.814222f, 0.5142242f),
                            new Vector2(1.814235f, -0.9714822f),
                            new Vector2(-3.728691f, -0.9713173f),
                            new Vector2(-3.585777f, -1.257198f),
                            new Vector2(-3.957146f, -1.257198f),
                            new Vector2(-3.957143f, -1.371429f),
                            new Vector2(2.157086f, -1.371429f),
                            new Vector2(3.899947f, -0.857195f),
                            new Vector2(3.957143f, -0.77148f),
                            new Vector2(3.957146f, -0.0286293f),
                            new Vector2(3.900675f, -0.02862996f)
                        });
                        body.GetComponent<PolygonCollider2D>().pathCount = 1;
                        PhysicalProperties carProperties = UnityEngine.Object.Instantiate(body.GetComponent<PhysicalBehaviour>().Properties);
                        carProperties.BulletSpeedAbsorptionPower = 5f;
                        body.GetComponent<PhysicalBehaviour>().Properties = carProperties;
                        body.GetChild(0).localPosition = new Vector3(0.271436f, -0.271427f);

                        BoxCollider2D trigger = body.gameObject.AddComponent<BoxCollider2D>();
                        trigger.offset = new Vector2(-2.113163f, -0.3968334f);
                        trigger.size = new Vector2(2.851387f, 1.45583f);
                        trigger.isTrigger = true;

                        GameObject background2 = new GameObject("Background 2");
                        background2.transform.parent = body;
                        background2.transform.rotation = body.rotation;
                        background2.transform.localScale = Vector3.one;
                        background2.transform.localPosition = new Vector3(-1.800001f, -1.028564f);
                        SpriteRenderer background2Renderer = background2.AddComponent<SpriteRenderer>();
                        background2Renderer.sprite = ModAPI.LoadSprite("Textures/Cars/Lenco BearCat G3/Background2.png");
                        background2Renderer.sortingOrder = 2;
                        background2Renderer.sortingLayerName = "Foreground";
                        background2.AddComponent<Optout>();

                        WheelJoint2D[] wheels = body.GetComponents<WheelJoint2D>();
                        wheels[0].anchor = new Vector2(3.032f, -1.42f);
                        wheels[0].connectedBody.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Cars/Lenco BearCat G3/Wheel.png");
                        wheels[0].connectedBody.GetComponent<CircleCollider2D>().radius = 0.7142857f;
                        wheels[1].anchor = new Vector2(-1.815f, -1.42f);
                        wheels[1].connectedBody.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Cars/Lenco BearCat G3/Wheel.png");
                        wheels[1].connectedBody.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                        wheels[1].connectedBody.GetComponent<SpriteRenderer>().sortingOrder = 3;
                        wheels[1].connectedBody.GetComponent<CircleCollider2D>().radius = 0.7142857f;

                        Transform bonnet = Instance.transform.GetChild(3);
                        bonnet.GetComponent<HingeJoint2D>().anchor = new Vector2(-0.7951355f, 0.1030006f);
                        bonnet.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.8f, 0.1285714f),
                            new Vector2(-0.8f, 0.07206312f),
                            new Vector2(0.8f, -0.1285714f),
                            new Vector2(0.8f, -0.07145277f)
                        });

                        Instance.transform.GetChild(4).gameObject.SetActive(false);

                        Transform frontDoor = Instance.transform.GetChild(5);
                        frontDoor.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                        {
                            new Vector2(-0.6571429f, 0.9714286f),
                            new Vector2(-0.6571429f, -0.9714286f),
                            new Vector2(0.6571429f, -0.9714286f),
                            new Vector2(0.6571429f, 0.5427643f),
                            new Vector2(0.2284786f, 0.9714362f)
                        });

                        Instance.transform.GetChild(6).gameObject.SetActive(false);

                        GameObject hatch = new GameObject("Hatch");
                        hatch.transform.parent = Instance.transform;
                        hatch.transform.rotation = body.transform.rotation;
                        hatch.transform.localScale = Vector3.one;
                        hatch.transform.localPosition = new Vector3(-0.6000028f, 1.41428f);
                        SpriteRenderer hatchRenderer = hatch.AddComponent<SpriteRenderer>();
                        hatchRenderer.sprite = ModAPI.LoadSprite("Textures/Cars/Lenco BearCat G3/Hatch.png");
                        hatchRenderer.sortingOrder = bonnet.GetComponent<SpriteRenderer>().sortingOrder;
                        hatchRenderer.sortingLayerName = bonnet.GetComponent<SpriteRenderer>().sortingLayerName;
                        hatch.layer = 9;
                        BoxCollider2D boxCollider2 = hatch.AddComponent<BoxCollider2D>();
                        boxCollider2.offset = new Vector2(0f, -0.028810875f);
                        boxCollider2.size = new Vector2(1.114286f, 0.08523539f);
                        hatch.AddComponent<Rigidbody2D>().mass = 0.35f;
                        FixedJoint2D fixedJoint1 = hatch.AddComponent<FixedJoint2D>();
                        fixedJoint1.connectedBody = body.GetComponent<Rigidbody2D>();
                        fixedJoint1.breakForce = 100f;
                        HingeJoint2D hingeJoint = hatch.AddComponent<HingeJoint2D>();
                        hingeJoint.connectedBody = body.GetComponent<Rigidbody2D>();
                        hingeJoint.anchor = new Vector2(-0.5144129f, -0.06474733f);
                        hingeJoint.breakForce = 900f;
                        hingeJoint.breakTorque = 900f;
                        hingeJoint.limits = new JointAngleLimits2D
                        {
                            min = -95,
                            max = 0
                        };
                        hingeJoint.useLimits = true;
                        hatch.AddComponent<JointSerialisationHelper>().Joint = fixedJoint1;
                        hatch.AddComponent<JointSerialisationHelper>().Joint = hingeJoint;
                        JointBreakSoundBehaviour jointBreakSound1 = hatch.AddComponent<JointBreakSoundBehaviour>();
                        jointBreakSound1.Clips = bonnet.GetComponent<JointBreakSoundBehaviour>().Clips;
                        jointBreakSound1.AudioSource = hatch.GetComponent<AudioSource>();
                        jointBreakSound1.Joints = new Joint2D[]
                        {
                            hingeJoint
                        };
                        jointBreakSound1.OnBreak = new UnityEvent();
                        jointBreakSound1.OnBreak.AddListener(() =>
                        {
                            jointBreakSound1.Joints = new Joint2D[0];
                        });
                        PhysicalProperties properties = ModAPI.FindPhysicalProperties("Metal");
                        properties.BulletSpeedAbsorptionPower = 5f;
                        hatch.AddComponent<PhysicalBehaviour>().Properties = properties;
                        hatch.AddComponent<AudioSourceTimeScaleBehaviour>();
                        hatch.AddComponent<Optout>();

                        GameObject backDoor = new GameObject("Back Door");
                        backDoor.transform.parent = Instance.transform;
                        backDoor.transform.rotation = body.transform.rotation;
                        backDoor.transform.localScale = Vector3.one;
                        backDoor.transform.localPosition = new Vector3(-3.700003f, 0.0285765f);
                        SpriteRenderer backDoorRenderer = backDoor.AddComponent<SpriteRenderer>();
                        backDoorRenderer.sprite = ModAPI.LoadSprite("Textures/Cars/Lenco BearCat G3/BackDoorClosed.png");
                        backDoor.layer = 9;
                        BoxCollider2D boxCollider3 = backDoor.AddComponent<BoxCollider2D>();
                        boxCollider3.offset = new Vector2(0.0426966f, 0f);
                        boxCollider3.size = new Vector2(0.1429554f, 2.057143f);
                        BoxCollider2D boxCollider4 = backDoor.AddComponent<BoxCollider2D>();
                        boxCollider4.offset = new Vector2(-0.05048621f, -0.4286131f);
                        boxCollider4.size = new Vector2(0.127599f, 0.057182193f);
                        backDoor.AddComponent<Rigidbody2D>().mass = 0.5f;
                        FixedJoint2D fixedJoint2 = backDoor.AddComponent<FixedJoint2D>();
                        fixedJoint2.connectedBody = body.GetComponent<Rigidbody2D>();
                        fixedJoint2.breakForce = 2500f;
                        backDoor.AddComponent<JointSerialisationHelper>().Joint = fixedJoint2;
                        JointBreakSoundBehaviour jointBreakSound2 = backDoor.AddComponent<JointBreakSoundBehaviour>();
                        jointBreakSound2.Clips = bonnet.GetComponent<JointBreakSoundBehaviour>().Clips;
                        jointBreakSound2.AudioSource = backDoor.GetComponent<AudioSource>();
                        jointBreakSound2.Joints = new Joint2D[]
                        {
                            fixedJoint2
                        };
                        jointBreakSound2.OnBreak = new UnityEvent();
                        jointBreakSound2.OnBreak.AddListener(() =>
                        {
                            jointBreakSound2.Joints = new Joint2D[0];
                        });
                        backDoor.AddComponent<PhysicalBehaviour>().Properties = properties;
                        BackDoorBehaviour backDoorBehaviour = backDoor.AddComponent<BackDoorBehaviour>();
                        backDoorBehaviour.HasSpareWheel = false;
                        backDoorBehaviour.Textures = new BackDoorBehaviour.DoorSprites[]
                        {
                            new BackDoorBehaviour.DoorSprites
                            {
                                OpenSprite = ModAPI.LoadSprite("Textures/Cars/Lenco BearCat G3/BackDoorOpen.png"),
                                ClosedSprite = ModAPI.LoadSprite("Textures/Cars/Lenco BearCat G3/BackDoorClosed.png")
                            }
                        };
                        backDoor.AddComponent<AudioSourceTimeScaleBehaviour>();
                        backDoor.AddComponent<Optout>();

                        GameObject blinker = new GameObject("Blinker");
                        blinker.transform.parent = Instance.transform;
                        blinker.transform.rotation = body.transform.rotation;
                        blinker.transform.localScale = Vector3.one;
                        blinker.transform.localPosition = new Vector3(0.9142826f, 1.385713f);
                        SpriteRenderer blinkerRenderer = blinker.AddComponent<SpriteRenderer>();
                        blinkerRenderer.sprite = ModAPI.LoadSprite("Textures/PoliceBlinker2.png");
                        blinker.layer = 9;
                        blinker.AddComponent<BoxCollider2D>();
                        blinker.AddComponent<Rigidbody2D>().mass = 1.2f;
                        FixedJoint2D fixedJoint = blinker.AddComponent<FixedJoint2D>();
                        fixedJoint.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                        fixedJoint.breakForce = 5000f;
                        blinker.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Glass");
                        DamagableMachineryBehaviour damagable = blinker.AddComponent<DamagableMachineryBehaviour>();
                        damagable.FirearmDamageMultiplier = 1f;
                        damagable.ExplosionDamageMultiplier = 100f;
                        damagable.Health = 50f;
                        damagable.BehavioursToToggle = new MonoBehaviour[0];
                        damagable.GameObjectsToToggle = new GameObject[0];
                        damagable.Waterproof = false;
                        blinker.AddComponent<JointSerialisationHelper>().Joint = fixedJoint;
                        JointBreakSoundBehaviour jointBreakSound = blinker.AddComponent<JointBreakSoundBehaviour>();
                        jointBreakSound.Clips = bonnet.GetComponent<JointBreakSoundBehaviour>().Clips;
                        jointBreakSound.AudioSource = blinker.GetComponent<AudioSource>();
                        jointBreakSound.Joints = new Joint2D[]
                        {
                            fixedJoint
                        };
                        jointBreakSound.OnBreak = new UnityEvent();
                        jointBreakSound.OnBreak.AddListener(() =>
                        {
                            jointBreakSound.Joints = new Joint2D[0];
                        });
                        AudioSource audio = blinker.AddComponent<AudioSource>();
                        audio.loop = true;
                        audio.clip = ModAPI.LoadSound("Sounds/PoliceBlinker.mp3");
                        audio.spatialBlend = 1f;
                        blinker.AddComponent<AudioSourceTimeScaleBehaviour>();
                        blinker.AddComponent<Optout>();

                        GameObject glow1 = new GameObject("Glow 1");
                        glow1.transform.parent = blinker.transform;
                        glow1.transform.rotation = blinker.transform.rotation;
                        glow1.transform.localScale = Vector3.one;
                        glow1.transform.localPosition = new Vector3(0f, 0f);
                        SpriteRenderer glow1Renderer = glow1.AddComponent<SpriteRenderer>();
                        glow1Renderer.sprite = ModAPI.LoadSprite("Textures/PoliceBlinker2GlowMask.png");
                        glow1Renderer.sortingOrder = blinkerRenderer.sortingOrder + 1;
                        glow1Renderer.sortingLayerName = blinkerRenderer.sortingLayerName;
                        glow1Renderer.color = new Color32(54, 124, 255, 255);
                        glow1.AddComponent<Optout>();
                        LightSprite glow1Light = ModAPI.CreateLight(glow1.transform, new Color32(54, 124, 255, 255), 13f, 3f);

                        LightSprite glow2 = ModAPI.CreateLight(blinker.transform, Color.red, 13f, 3f);

                        BlinkerBehaviour blinkerBehaviour = blinker.GetOrAddComponent<BlinkerBehaviour>();
                        blinkerBehaviour.Glow1 = glow1;
                        blinkerBehaviour.Glow2 = glow2.gameObject;
                        blinkerBehaviour.Audio = audio;
                        blinkerBehaviour.Delay = 1f;

                        Transform gastank = Instance.transform.GetChild(8);

                        body.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[]
                        {
                            new RandomCarTextureBehaviour.CarSprites
                            {
                                Body = ModAPI.LoadSprite("Textures/Cars/Lenco BearCat G3/Body.png"),
                                Background = ModAPI.LoadSprite("Textures/Cars/Lenco BearCat G3/Background.png"),
                                Bonnet = ModAPI.LoadSprite("Textures/Cars/Lenco BearCat G3/Bonnet.png"),
                                FrontDoor = ModAPI.LoadSprite("Textures/Cars/Lenco BearCat G3/Door.png")
                            }
                        };

                        Sprite bodyLeft = ModAPI.LoadSprite("Textures/Cars/Lenco BearCat G3/Body2.png");
                        Sprite redBlinker = ModAPI.LoadSprite("Textures/PoliceBlinker22.png");
                        CarSerialisationHelper carSerialisationHelper = Instance.AddComponent<CarSerialisationHelper>();
                        carSerialisationHelper.AfterFirstSpawn = () =>
                        {
                            body.GetComponent<CarBehaviour>().MotorSpeed = -3200f;

                            wheels[0].connectedBody.transform.localPosition = new Vector3(3.032f, -1.42f);
                            wheels[1].connectedBody.transform.localPosition = new Vector3(-1.815f, -1.42f);
                            bonnet.localPosition = new Vector3(3.157087f, 0.042804f);
                            frontDoor.localPosition = new Vector3(1.185721f, -0.028572f);
                            gastank.localPosition = new Vector3(-2.8f, -0.86f);

                            Transform engine = Instance.transform.GetChild(7);
                            engine.localPosition = new Vector3(2.978f, -0.441f);
                            engine.localScale = new Vector3(1.1f, 1.1f);

                            Instance.AddComponent<ObjectSerialisationHelper>().Object = hatch;
                            Instance.AddComponent<ObjectSerialisationHelper>().Object = backDoor;
                            Instance.AddComponent<ObjectSerialisationHelper>().Object = blinker;
                        };
                        carSerialisationHelper.Left = () =>
                        {
                            body.GetComponent<SpriteRenderer>().sprite = bodyLeft;
                            body.GetComponent<RandomCarTextureBehaviour>().Textures[0].Body = bodyLeft;
                            blinkerRenderer.sprite = redBlinker;
                            glow1Renderer.color = Color.red;
                            glow1Light.Color = Color.red;
                            glow2.Color = new Color32(54, 124, 255, 255);
                        };

                        NoCollideWithObjectsInTrigger noCollideWithObjectsInTrigger = body.gameObject.AddComponent<NoCollideWithObjectsInTrigger>();
                        noCollideWithObjectsInTrigger.Trigger = trigger;
                        noCollideWithObjectsInTrigger.Colliders = new Collider2D[]
                        {
                            wheels[1].connectedBody.GetComponent<CircleCollider2D>(),
                            gastank.GetComponent<BoxCollider2D>()
                        };

                        NoCollide noCollide = Instance.GetComponent<NoCollide>();
                        noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                        noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
                    }
                }
            );
        }
    }
    [SkipSerialisation]
    public class CarSerialisationHelper : MonoBehaviour
    {
        private void Start()
        {
            bool firstSpawn = !GetComponent<FirstSpawn>();
            RandomCarTextureBehaviour randomCarTextures = GetComponentInChildren<RandomCarTextureBehaviour>();
            if (randomCarTextures && randomCarTextures.Textures.Length <= 1)
            {
                PhysicalBehaviour phys = randomCarTextures.GetComponent<PhysicalBehaviour>();
                ContextMenuButton nextTexture = phys.ContextMenuOptions.Buttons.Find((button) => button.Identity == "nextSkin");
                ContextMenuButton previousTexture = phys.ContextMenuOptions.Buttons.Find((button) => button.Identity == "previousSkin");
                phys.ContextMenuOptions.Buttons.Remove(nextTexture);
                phys.ContextMenuOptions.Buttons.Remove(previousTexture);
            }
            if (firstSpawn)
            {
                gameObject.AddComponent<FirstSpawn>();
                if (randomCarTextures)
                {
                    randomCarTextures.chosenIndex = UnityEngine.Random.Range(0, randomCarTextures.Textures.Length);
                    randomCarTextures.SendMessage("SetSpritesToIndex", SendMessageOptions.DontRequireReceiver);
                    carOptics = randomCarTextures.gameObject.AddComponent<CarOpticsBehaviour>();
                    if (HasInside)
                    {
                        inside = randomCarTextures.gameObject.AddComponent<InsideBehaviour>();
                    }
                }
                AfterFirstSpawn?.Invoke();
            }
            else
            {
                if (randomCarTextures)
                {
                    carOptics = randomCarTextures.GetComponent<CarOpticsBehaviour>();
                    if (HasInside)
                    {
                        InsideBehaviour oldInside = randomCarTextures.GetComponent<InsideBehaviour>();
                        inside = randomCarTextures.gameObject.AddComponent<InsideBehaviour>();
                        inside.ShowInside = oldInside.ShowInside;
                        Destroy(oldInside);
                    }
                }
            }
            AfterSpawn?.Invoke();
            if (transform.localScale.x > 0)
            {
                Right?.Invoke();
            }
            else
            {
                Left?.Invoke();
            }
        }

        public bool HasInside;
        public Action AfterFirstSpawn;
        public Action AfterSpawn;
        public Action Right;
        public Action Left;
        public CarOpticsBehaviour carOptics;
        public InsideBehaviour inside;
    }
    public class FirstSpawn : MonoBehaviour
    {
    }
    [SkipSerialisation]
    public class NoCollideWithObjectsInTrigger : MonoBehaviour
    {
        private void Start()
        {
            collidersWithoutTrigger = GetComponents<Collider2D>().ToList();
            collidersWithoutTrigger.Remove(Trigger);
        }
        private void OnTriggerEnter2D(Collider2D collider)
        {
            if (collider.isTrigger || noCollides.ContainsKey(collider))
            {
                return;
            }
            NoCollide noCollide = gameObject.AddComponent<NoCollide>();
            noCollide.NoCollideSetA = Colliders;
            noCollide.NoCollideSetB = new Collider2D[]
            { 
                collider 
            };
            noCollides.Add(collider, noCollide);
        }
        private void OnTriggerExit2D(Collider2D collider)
        {
            if (!noCollides.ContainsKey(collider))
            {
                return;
            }
            Destroy(noCollides[collider]);
            noCollides.Remove(collider);
        }
        public void RemoveCollider(int index)
        {
            List<Collider2D> colliders = Colliders.ToList();
            colliders.RemoveAt(index);
            Colliders = colliders.ToArray();
            Dictionary<Collider2D, NoCollide>.KeyCollection otherColliders = noCollides.Keys;
            foreach (Collider2D collider in otherColliders.ToList())
            {
                OnTriggerExit2D(collider);
                OnTriggerEnter2D(collider);
            }
        }
        private void OnCableConnect(WireBehaviour wire)
        {
            if (wire.untypedJoint.enableCollision)
            {
                return;
            }
            wire.untypedJoint.enableCollision = true;
            if (wire.untypedJoint.connectedBody == GetComponent<Rigidbody2D>())
            {
                colliders.Add(wire, wire.GetComponents<Collider2D>());
            }
            else
            {
                colliders.Add(wire, wire.untypedJoint.connectedBody.GetComponents<Collider2D>());
            }
            foreach (Collider2D collider in collidersWithoutTrigger)
            {
                foreach (Collider2D otherCollider in colliders[wire])
                {
                    IgnoreCollisionStackController.IgnoreCollisionSubstituteMethod(collider, otherCollider);
                }
            }
            connectedWires.Add(wire);
        }
        private void OnCableDisconnect(WireBehaviour wire)
        {
            if (!connectedWires.Contains(wire))
            {
                return;
            }
            foreach (Collider2D collider in collidersWithoutTrigger)
            {
                foreach (Collider2D otherCollider in colliders[wire])
                {
                    IgnoreCollisionStackController.IgnoreCollisionSubstituteMethod(collider, otherCollider, false);
                }
            }
            connectedWires.Remove(wire);
            colliders.Remove(wire);
        }

        public Collider2D[] Colliders;
        public Collider2D Trigger;
        private List<Collider2D> collidersWithoutTrigger;
        private List<WireBehaviour> connectedWires = new List<WireBehaviour>();
        private Dictionary<WireBehaviour, Collider2D[]> colliders = new Dictionary<WireBehaviour, Collider2D[]>();
        private Dictionary<Collider2D, NoCollide> noCollides = new Dictionary<Collider2D, NoCollide>();
    }
    public class CarWheelsBehaviour : MonoBehaviour
    {
        private void OnJointBreak2D(Joint2D joint)
        {
            if (Wheels.Contains(joint))
            {
                joint.connectedBody.transform.parent = transform.parent;
            }
        }

        [SkipSerialisation]
        public WheelJoint2D[] Wheels = new WheelJoint2D[0];
    }
    public class ObjectSerialisationHelper : MonoBehaviour
    {
        private void OnBeforeSerialise()
        {
            disabledCollision = Object.layer == 10;
            isWeightless = Object.GetComponent<PhysicalBehaviour>().IsWeightless;
            frezee = Object.GetComponent<FreezeBehaviour>();
            temperature = Object.GetComponent<PhysicalBehaviour>().Temperature;

            List<bool> jointBrokenList = new List<bool>();
            JointSerialisationHelper[] jointHelpers = Object.GetComponents<JointSerialisationHelper>();
            for (int i = 0; i < jointHelpers.Length; i++)
            {
                jointBrokenList.Add(jointHelpers[i].Broken);
            }
            jointBroken = jointBrokenList.ToArray();

            CarOpticsBehaviour carOptics = Object.GetComponent<CarOpticsBehaviour>();
            if (carOptics)
            {
                headlightsActivated = carOptics.HeadlightsActivated;
                turnSignalsActivated = carOptics.TurnSignalsActivated;
                startMotorSpeed = carOptics.startMotorSpeed;
            }

            BackDoorBehaviour backDoorBehaviour = Object.GetComponent<BackDoorBehaviour>();
            if (backDoorBehaviour)
            {
                backDoorActivated = backDoorBehaviour.Activated;
                spareWheelJointBroken = backDoorBehaviour.spareWheelJointBroken;
            }

            BlinkerBehaviour blinker = Object.GetComponent<BlinkerBehaviour>();
            if (blinker)
            {
                blinkerActivated = blinker.Activated;
                blinkerGlow1Active = blinker.glow1Active;
                blinkerIndex = blinker.index;
            }

            AmbulanceBlinkerBehaviour ambulanceBlinker = Object.GetComponent<AmbulanceBlinkerBehaviour>();
            if (ambulanceBlinker)
            {
                blinkerActivated = ambulanceBlinker.Activated;
                blinkerGlowActives = ambulanceBlinker.glowActives;
                blinkerIndexes = ambulanceBlinker.indexes;
            }

            if (Object.GetComponent<DamagableMachineryBehaviour>())
            {
                destroyed = Object.GetComponent<DamagableMachineryBehaviour>().Destroyed;
            }

            transformData = new TransformPrototype(Object.transform.localPosition, Object.transform.eulerAngles.z, Object.transform.localScale);
            originalScale = transform.localScale;
            objectName = Utils.GetHierachyPath(Object.transform);

            if (Object.GetComponent<CarBehaviour>())
            {
                carSpeed = Object.GetComponent<CarBehaviour>().MotorSpeed;
            }

            if (Object.GetComponent<RandomCarTextureBehaviour>())
            {
                carTextureIndex = Object.GetComponent<RandomCarTextureBehaviour>().chosenIndex;
            }
        }
        private void OnAfterDeserialise()
        {
            GameObject gameObject = transform.Find(objectName).gameObject;
            gameObject.transform.position = gameObject.transform.parent.TransformPoint(transformData.RelativePosition);
            gameObject.transform.eulerAngles = new Vector3(0f, 0f, (transform.localScale == originalScale) ? transformData.RelativeRotation + this.gameObject.transform.eulerAngles.z : -transformData.RelativeRotation - this.gameObject.transform.eulerAngles.z);
            gameObject.transform.localScale = transformData.LocalScale;

            gameObject.layer = disabledCollision ? 10 : 9;
            gameObject.GetComponent<PhysicalBehaviour>().IsWeightless = isWeightless;
            gameObject.GetComponent<PhysicalBehaviour>().Temperature = temperature;

            if (frezee)
            {
                gameObject.AddComponent<FreezeBehaviour>();
            }

            JointSerialisationHelper[] jointHelpers = gameObject.GetComponents<JointSerialisationHelper>();
            for (int i = 0; i < jointHelpers.Length; i++)
            {
                if (jointBroken[i])
                {
                    jointHelpers[i].Broken = true;
                    Destroy(jointHelpers[i].Joint);
                }
            }

            CarOpticsBehaviour carOptics = gameObject.GetComponent<CarOpticsBehaviour>();
            if (carOptics)
            {
                carOptics.firstSpawn = false;
                carOptics.HeadlightsActivated = headlightsActivated;
                carOptics.TurnSignalsActivated = turnSignalsActivated;
                carOptics.startMotorSpeed = startMotorSpeed;
            }

            BackDoorBehaviour backDoorBehaviour = gameObject.GetComponent<BackDoorBehaviour>();
            if (backDoorBehaviour)
            {
                backDoorBehaviour.Activated = backDoorActivated;
                backDoorBehaviour.spareWheelJointBroken = spareWheelJointBroken;
            }

            BlinkerBehaviour blinker = gameObject.GetComponent<BlinkerBehaviour>();
            if (blinker)
            {
                blinker.Activated = blinkerActivated;
                blinker.glow1Active = blinkerGlow1Active;
                blinker.index = blinkerIndex;
            }

            AmbulanceBlinkerBehaviour ambulanceBlinker = gameObject.GetComponent<AmbulanceBlinkerBehaviour>();
            if (ambulanceBlinker)
            {
                ambulanceBlinker.Activated = blinkerActivated;
                ambulanceBlinker.glowActives = blinkerGlowActives;
                ambulanceBlinker.indexes = blinkerIndexes;
            }

            if (gameObject.GetComponent<DamagableMachineryBehaviour>())
            {
                gameObject.GetComponent<DamagableMachineryBehaviour>().Destroyed = destroyed;
            }

            if (gameObject.GetComponent<CarBehaviour>())
            {
                gameObject.GetComponent<CarBehaviour>().MotorSpeed = carSpeed;
            }

            if (gameObject.GetComponent<RandomCarTextureBehaviour>())
            {
                gameObject.GetComponent<RandomCarTextureBehaviour>().chosenIndex = carTextureIndex;
            }

            Object = gameObject;
        }

        public bool disabledCollision;
        public bool isWeightless;
        public bool frezee;
        public bool[] jointBroken;
        public bool headlightsActivated;
        public bool turnSignalsActivated;
        public bool backDoorActivated;
        public bool spareWheelJointBroken;
        public bool blinkerActivated;
        public bool blinkerGlow1Active;
        public bool[] blinkerGlowActives;
        public bool destroyed;
        [SkipSerialisation]
        public GameObject Object;
        public TransformPrototype transformData;
        public Vector3 originalScale;
        public string objectName;
        public float temperature;
        public float startMotorSpeed;
        public float carSpeed;
        public float blinkerIndex;
        public float[] blinkerIndexes;
        public int carTextureIndex;
    }
    public class CarOpticsBehaviour : MonoBehaviour
    {
        private void Start()
        {
            phys = gameObject.GetComponent<PhysicalBehaviour>();
            Car = gameObject.GetComponent<CarBehaviour>();
            for (int i = 0; i < Headlights.Length; i++)
            {
                Headlights[i].SetActive(false);
            }
            if (ReversingLamp != null)
            {
                ReversingLamp.SetActive(false);
            }
            if (firstSpawn)
            {
                startMotorSpeed = Car.MotorSpeed;
            }
            phys.ContextMenuOptions.Buttons.Add(new ContextMenuButton("cruiseControl", "Set speed limit", "Sets speed limit", new UnityAction[1]
            {
                () =>
                {
                    DialogBox dialog = null;
                    dialog = DialogBoxManager.TextEntry("Set the speed limit\n<color=green><size=26>Currently: " + Mathf.Abs(Car.MotorSpeed).ToString() + "</size></color>", "Speed limit", new DialogButton[]
                    {
                        new DialogButton("Apply", true, new UnityAction[1]
                        {
                            () =>
                            {
                                float speedLimit;
                                if(float.TryParse(dialog.EnteredText, out speedLimit))
                                {
                                    if(speedLimit > 0f)
                                    {
                                        if(speedLimit >= Mathf.Abs(startMotorSpeed))
                                        {
                                            Car.MotorSpeed = (Car.MotorSpeed > 0f) ? Mathf.Abs(startMotorSpeed) : startMotorSpeed;
                                            return;
                                        }
                                        if(Car.MotorSpeed > 0f)
                                        {
                                            Car.MotorSpeed = speedLimit;
                                        }
                                        else
                                        {
                                            Car.MotorSpeed = -speedLimit;
                                        }
                                    }
                                    else
                                    {
                                        if(speedLimit <= startMotorSpeed)
                                        {
                                            Car.MotorSpeed = (Car.MotorSpeed > 0f) ? Mathf.Abs(startMotorSpeed) : startMotorSpeed;
                                            return;
                                        }
                                        if(Car.MotorSpeed > 0f)
                                        {
                                            Car.MotorSpeed = Mathf.Abs(speedLimit);
                                        }
                                        else
                                        {
                                            Car.MotorSpeed = speedLimit;
                                        }
                                    }
                                }
                            }
                        }),
                        new DialogButton("Off", true, new UnityAction[1]
                        {
                            () =>
                            {
                                Car.MotorSpeed = startMotorSpeed;
                            }
                        }),
                        new DialogButton("Cancel", true, () => dialog.Close())
                    });
                }
            }));
            phys.ContextMenuOptions.Buttons.Add(new ContextMenuButton("toggleHeadlights", () =>
            {
                if (!HeadlightsActivated)
                {
                    return "Enable headlights";
                }
                return "Disable headlights";
            }, "Toggles headlights", new UnityAction[1]
            {
                () =>
                {
                    HeadlightsActivated = !HeadlightsActivated;
                }
            })
            {
                Condition = () => Headlights.Length != 0 && Headlights != null
            });
            phys.ContextMenuOptions.Buttons.Add(new ContextMenuButton("toggleTurnSignals", () =>
            {
                if (!TurnSignalsActivated)
                {
                    return "Enable turn signals";
                }
                return "Disable turn signals";
            }, "Toggles turn signals", new UnityAction[1]
            {
                () =>
                {
                    TurnSignalsActivated = !TurnSignalsActivated;
                    UpdateActivation();
                }
            })
            {
                Condition = () => TurnSignals.Length != 0 && TurnSignals != null
            });
            if (FailedEngineStartup)
            {
                carAudioSources = Car.audioSourcePosition.GetComponents<AudioSource>();
                failedEngineStartupSource = Car.audioSourcePosition.gameObject.AddComponent<AudioSource>();
                failedEngineStartupSource.spread = 0f;
                failedEngineStartupSource.volume = 1f;
                failedEngineStartupSource.minDistance = 10f;
                failedEngineStartupSource.spatialBlend = 1f;
                failedEngineStartupSource.dopplerLevel = 1f;
                gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
            }
            UpdateActivation();
            firstSpawn = false;
        }
        private void Use()
        {
            if(FailedEngineStartup)
            {
                if(Car.Activated)
                {
                    if((double)UnityEngine.Random.value > FailedEngineStartupChance)
                    {
                        carAudioSources[0].Stop();
                        carAudioSources[1].Stop();
                        Car.Activated = false;
                        failedEngineStartupSource.PlayOneShot(FailedEngineStartupSound, 1f);
                    }
                }
            }
        }
        private void Update()
        {
            for(int i = 0; i < Headlights.Length; i++)
            {
                if(HeadlightsActivated)
                {
                    Headlights[i].SetActive(true);
                }
                if(!HeadlightsActivated)
                {
                    Headlights[i].SetActive(false);
                }
            }
            if(ReversingLamp != null)
            {
                if(Car.MotorSpeed > 0 && Car.Activated && !ReversingLampActivated)
                {
                    ReversingLampActivated = true;
                    ReversingLamp.SetActive(true);
                }
                if(Car.MotorSpeed < 0 && ReversingLampActivated || !Car.Activated)
                {
                    ReversingLampActivated = false;
                    ReversingLamp.SetActive(false);
                }
            }
        }
        public void UpdateActivation()
        {
            if(TurnSignals.Length != 0)
            {
                if(TurnSignalsActivated)
                {
                    StopAllCoroutines();
                    StartCoroutine(Blink());
                }
                else
                {
                    for(int i = 0; i < TurnSignals.Length; i++)
                    {
                        TurnSignals[i].SetActive(false);
                    }
                    StopAllCoroutines();
                }
            }
        }
        private void OnCollisionEnter2D(Collision2D collision)
        {
            if(ActivateTurnSignalsOnCollision && TurnSignals.Length != 0)
            {
                if(collision.GetContact(0).normalImpulse > BreakingThreshold)
                {
                    TurnSignalsActivated = true;
                    UpdateActivation();
                }
            }
        }
        private IEnumerator Blink()
        {
            while(TurnSignalsActivated)
            {
                yield return new WaitForSeconds(0.3f);
                for(int i = 0; i < TurnSignals.Length; i++)
                {
                    TurnSignals[i].SetActive(true);
                }
                yield return new WaitForSeconds(0.3f);
                for(int i = 0; i < TurnSignals.Length; i++)
                {
                    TurnSignals[i].SetActive(false);
                }
            }
        }

        public bool firstSpawn = true;
        public bool HeadlightsActivated;
        public bool TurnSignalsActivated;
        public bool ReversingLampActivated;
        public bool ActivateTurnSignalsOnCollision;
        public bool FailedEngineStartup;
        [SkipSerialisation]
        public GameObject[] Headlights = new GameObject[0];
        [SkipSerialisation]
        public GameObject[] TurnSignals = new GameObject[0];
        [SkipSerialisation]
        public GameObject ReversingLamp;
        private PhysicalBehaviour phys;
        private AudioSource[] carAudioSources;
        private AudioSource failedEngineStartupSource;
        [SkipSerialisation]
        public CarBehaviour Car;
        [SkipSerialisation]
        public AudioClip FailedEngineStartupSound;
        public float BreakingThreshold = 20f;
        public float startMotorSpeed;
        public double FailedEngineStartupChance = 0.8d;
    }
    public class RandomCarTextureChildBehaviour : MonoBehaviour
    {
        private void Start()
        {
            phys = gameObject.GetComponent<PhysicalBehaviour>();
            renderer = gameObject.GetComponent<SpriteRenderer>();
            randomCarTextures = transform.root.gameObject.GetComponentInChildren<RandomCarTextureBehaviour>();
            if(randomCarTextures)
            {
                randomCarTextures.OnAfterChange.AddListener(new UnityAction(SyncSprite));
                randomCarTextures.OnAfterChange.Invoke();
            }
        }
        private void SyncSprite()
        {
            renderer.sprite = Sprites[randomCarTextures.chosenIndex];
            if(phys)
            {
                phys.RefreshOutline();
            }
        }

        private PhysicalBehaviour phys;
        private SpriteRenderer renderer;
        private RandomCarTextureBehaviour randomCarTextures;
        public Sprite[] Sprites = new Sprite[0];
    }
    public class TowbarBehaviour : MonoBehaviour
    {
        private void Start()
        {
            gameObject.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("disconnect", "Disconnect", "Disconnect", new UnityAction[]
            {
                delegate()
                {
                    if(fixedJoint)
                    {
                        Disconnect();
                    }
                    else
                    {
                        connectedTowbar.Disconnect();
                    }
                }
            })
            {
                Condition = (() => connectedTowbar)
            });
        }
        private void OnCollisionEnter2D(Collision2D collision)
        {
            if(collision.gameObject.GetComponent<TowbarBehaviour>() && !connectedTowbar && !collision.gameObject.GetComponent<TowbarBehaviour>().connectedTowbar && collision.gameObject.GetComponent<TowbarBehaviour>().IsTrailerTowbar != IsTrailerTowbar)
            {
                connectedTowbar = collision.gameObject.GetComponent<TowbarBehaviour>();
                collision.gameObject.GetComponent<TowbarBehaviour>().connectedTowbar = gameObject.GetComponent<TowbarBehaviour>();
                fixedJoint = gameObject.AddComponent<FixedJoint2D>();
                fixedJoint.breakForce = 40000f;
                fixedJoint.connectedBody = collision.gameObject.GetComponent<Rigidbody2D>();
                fixedJoint.anchor = Anchor;
                fixedJoint.frequency = 10f;
                fixedJoint.dampingRatio = 1f;
                noCollide = gameObject.AddComponent<NoCollide>();
                noCollide.NoCollideSetA = GetComponents<Collider2D>();
                noCollide.NoCollideSetB = collision.gameObject.GetComponents<Collider2D>();
                transform.root.gameObject.BroadcastMessage("OnConnected", connectedTowbar, SendMessageOptions.DontRequireReceiver);
                collision.transform.root.gameObject.BroadcastMessage("OnConnected", this, SendMessageOptions.DontRequireReceiver);
            }
        }
        private void OnJointBreak2D(Joint2D joint)
        {
            if (noCollide)
            {
                Disconnect();
            }
            else
            {
                connectedTowbar.Disconnect();
            }
        }
        public void Disconnect()
        {
            transform.root.gameObject.BroadcastMessage("OnDisconnected", connectedTowbar, SendMessageOptions.DontRequireReceiver);
            connectedTowbar.transform.root.gameObject.BroadcastMessage("OnDisconnected", this, SendMessageOptions.DontRequireReceiver);
            Destroy(fixedJoint);
            Destroy(noCollide, 2.5f);
            connectedTowbar.connectedTowbar = null;
            connectedTowbar = null;
        }

        public bool IsTrailerTowbar = false;
        [SkipSerialisation]
        public TowbarBehaviour connectedTowbar;
        [SkipSerialisation]
        public FixedJoint2D fixedJoint;
        [SkipSerialisation]
        public NoCollide noCollide;
        [SkipSerialisation]
        public Vector2 Anchor = Vector2.zero;
    }
    public class TrailerBehaviour : MonoBehaviour
    {
        private void Start()
        {
            phys = gameObject.GetComponent<PhysicalBehaviour>();
            phys.ContextMenuOptions.Buttons.Add(new ContextMenuButton("disconnect", "Disconnect", "Disconnect", new UnityAction[1]
            {
                () =>
                {
                    if (TowbarBehaviour.fixedJoint)
                    {
                        TowbarBehaviour.Disconnect();
                    }
                    else
                    {
                        TowbarBehaviour.connectedTowbar.Disconnect();
                    }
                }
            }));
            StartCoroutine(SupportFoot.Move(1f));
        }
        private void OnConnected(TowbarBehaviour towbarBehaviour)
        {
            carBehaviour = towbarBehaviour.transform.root.GetComponentInChildren<CarBehaviour>();
            List<WheelJoint2D> wheelList = carBehaviour.WheelJoints.ToList();
            wheelList.AddRange(Wheels);
            carBehaviour.WheelJoints = wheelList.ToArray();
            StartCoroutine(SupportFoot.Move(-1f));
        }
        private void OnDisconnected()
        {
            List<WheelJoint2D> wheelList = carBehaviour.WheelJoints.ToList();
            foreach (WheelJoint2D wheel in Wheels)
            {
                float maxMotorTorque = wheel.motor.maxMotorTorque;
                wheel.motor = new JointMotor2D
                {
                    motorSpeed = 0f,
                    maxMotorTorque = maxMotorTorque
                };
                wheelList.Remove(wheel);
            }
            carBehaviour.WheelJoints = wheelList.ToArray();
            carBehaviour = null;
            StartCoroutine(SupportFoot.Move(1f));
        }
        private void OnJointBreak2D(Joint2D joint)
        {
            if (!Wheels.Contains(joint))
            {
                return;
            }
            List<WheelJoint2D> wheels = Wheels.ToList();
            wheels.Remove(joint as WheelJoint2D);
            Wheels = wheels.ToArray();
            if(carBehaviour != null)
            {
                List<WheelJoint2D> wheelList = carBehaviour.WheelJoints.ToList();
                wheelList.Remove(joint as WheelJoint2D);
                carBehaviour.WheelJoints = wheelList.ToArray();
            }
        }

        private PhysicalBehaviour phys;
        private CarBehaviour carBehaviour;
        [SkipSerialisation]
        public TowbarBehaviour TowbarBehaviour;
        [SkipSerialisation]
        public WheelJoint2D[] Wheels;
        [SkipSerialisation]
        public SupportFootBehaviour SupportFoot;
    }
    public class SupportFootBehaviour : MonoBehaviour
    {
        private void Start()
        {
            originalLimits = SliderJoint.limits;
            UpdateLimits();
        }
        public IEnumerator Move(float direction)
        {
            JointLimitState2D limitToWaitFor = (direction > 0f) ? JointLimitState2D.UpperLimit : JointLimitState2D.LowerLimit;
            SetMotorSpeed(direction * Mathf.Abs(transform.localScale.x));
            yield return new WaitUntil(() => SliderJoint.limitState == limitToWaitFor);
            SetMotorSpeed(0f);
            yield break;
        }
        private void Update()
        {
            UpdateLimits();
        }
        private void UpdateLimits()
        {
            JointTranslationLimits2D limits = default;
            float num = Mathf.Abs(transform.localScale.x);
            limits.max = originalLimits.max * num;
            limits.min = originalLimits.min * num;
            SliderJoint.limits = limits;
        }
        private void SetMotorSpeed(float speed)
        {
            JointMotor2D motor = SliderJoint.motor;
            motor.motorSpeed = speed * 0.5f;
            SliderJoint.motor = motor;
        }

        [SkipSerialisation]
        public SliderJoint2D SliderJoint;
        private JointTranslationLimits2D originalLimits;
    }
    public class BlinkerBehaviour : MonoBehaviour
    {
        private void Start()
        {
            Glow1.SetActive(false);
            Glow2.SetActive(false);
            damagableMachinery = GetComponent<DamagableMachineryBehaviour>();
        }
        private void Use()
        {
            Activated = !Activated;
        }
        private void FixedUpdate()
        {
            if (Activated && !damagableMachinery.Destroyed)
            {
                if (!Audio.isPlaying)
                {
                    Audio.Play();
                }
                if (index >= Delay)
                {
                    glow1Active = !glow1Active;
                    index = 0f;
                }
                Glow1.SetActive(glow1Active);
                Glow2.SetActive(!glow1Active);
                index += 0.1f;
            }
            else
            {
                if (Audio.isPlaying)
                {
                    Audio.Stop();
                }
                Glow1.SetActive(false);
                Glow2.SetActive(false);
            }
            if (damagableMachinery.Destroyed)
            {
                Activated = false;
            }
        }

        public bool Activated;
        public bool glow1Active = true;
        [SkipSerialisation]
        public GameObject Glow1;
        [SkipSerialisation]
        public GameObject Glow2;
        [SkipSerialisation]
        public AudioSource Audio;
        private DamagableMachineryBehaviour damagableMachinery;
        [SkipSerialisation]
        public float Delay;
        public float index;
    }
    public class AmbulanceBlinkerBehaviour : MonoBehaviour
    {
        private void Start()
        {
            damagableMachinery = GetComponent<DamagableMachineryBehaviour>();
            damagableMachinery.OnRepaired = new UnityEvent();
            damagableMachinery.OnRepaired.AddListener(() =>
            {
                Activated = false;
            });
            Glow1.SetActive(false);
            Glow2.SetActive(false);
            Glow3.SetActive(false);
            Glow4.SetActive(false);
            Glow5.SetActive(false);
            Glow6.SetActive(false);
        }
        private void Use()
        {
            if (damagableMachinery.Destroyed)
            {
                return;
            }
            Activated = !Activated;
        }
        private void FixedUpdate()
        {
            if (Activated)
            {
                if (!Audio.isPlaying && !damagableMachinery.Destroyed)
                {
                    Audio.Play();
                }
                if (indexes[0] >= Delay && !damagableMachinery.Destroyed)
                {
                    glowActives[0] = !glowActives[0];
                    indexes[0] = 0f;
                }
                if (indexes[1] >= 0.6f)
                {
                    glowActives[1] = !glowActives[1];
                    indexes[1] = 0f;
                }
                if (indexes[2] >= 1.1f)
                {
                    glowActives[2] = !glowActives[2];
                    indexes[2] = 0f;
                }
                if (indexes[3] >= 1.6f)
                {
                    glowActives[3] = !glowActives[3];
                    indexes[3] = 0f;
                }
                if (indexes[4] >= 0.9f)
                {
                    glowActives[4] = !glowActives[4];
                    indexes[4] = 0f;
                }
                Glow1.SetActive(glowActives[0]);
                Glow2.SetActive(!glowActives[0]);
                Glow3.SetActive(glowActives[1]);
                if (Glow4 != null)
                {
                    Glow4.SetActive(glowActives[2]);
                }
                if (Glow5 != null)
                {
                    Glow5.SetActive(glowActives[3]);
                }
                Glow6.SetActive(glowActives[4]);
                for (int i = 0; i < 5; i++)
                {
                    indexes[i] += 0.1f;
                }
            }
            else
            {
                if (Audio.isPlaying)
                {
                    Audio.Stop();
                }
                Glow1.SetActive(false);
                Glow2.SetActive(false);
                Glow3.SetActive(false);
                if (Glow4 != null)
                {
                    Glow4.SetActive(false);
                }
                if (Glow5 != null)
                {
                    Glow5.SetActive(false);
                }
                Glow6.SetActive(false);
            }
            if (damagableMachinery.Destroyed && Activated)
            {
                if (Audio.isPlaying)
                {
                    Audio.Stop();
                }
                Glow1.SetActive(false);
                Glow2.SetActive(false);
            }
        }

        public bool Activated;
        public bool[] glowActives = new bool[5];
        [SkipSerialisation]
        public GameObject Glow1;
        [SkipSerialisation]
        public GameObject Glow2;
        [SkipSerialisation]
        public GameObject Glow3;
        [SkipSerialisation]
        public GameObject Glow4;
        [SkipSerialisation]
        public GameObject Glow5;
        [SkipSerialisation]
        public GameObject Glow6;
        [SkipSerialisation]
        public AudioSource Audio;
        private DamagableMachineryBehaviour damagableMachinery;
        [SkipSerialisation]
        public float Delay;
        public float[] indexes = new float[5];
    }
    public class BackDoorBehaviour : MonoBehaviour
    {
        private void Start()
        {
            renderer = GetComponent<SpriteRenderer>();
            randomCarTextures = transform.root.GetComponentInChildren<RandomCarTextureBehaviour>();
            randomCarTextures.OnAfterChange.AddListener(new UnityAction(UpdateActivation));
            randomCarTextures.OnAfterChange.Invoke();
            startLayerName = renderer.sortingLayerName;
            UpdateActivation();
        }
        private void Use()
        {
            Activated = !Activated;
            UpdateActivation();
        }
        private void Update()
        {
            if (HasSpareWheel && !SpareWheelJoint && !spareWheelJointBroken)
            {
                spareWheelJointBroken = true;
            }
        }
        private void UpdateActivation()
        {
            if (Activated)
            {
                renderer.sprite = Textures[randomCarTextures.chosenIndex].OpenSprite;
                if (HasSpareWheel && !spareWheelJointBroken)
                {
                    SpareWheelJoint.connectedBody.transform.parent = transform;
                    SpareWheelJoint.connectedBody.gameObject.SetActive(false);
                    renderer.sprite = Textures[randomCarTextures.chosenIndex].OpenSpriteWithWheel;
                }
                renderer.sortingLayerName = "Bottom";
                gameObject.layer = 10;
            }
            else
            {
                if (HasSpareWheel && !spareWheelJointBroken)
                {
                    SpareWheelJoint.connectedBody.transform.parent = transform.parent;
                    SpareWheelJoint.connectedBody.gameObject.SetActive(true);
                }
                renderer.sprite = Textures[randomCarTextures.chosenIndex].ClosedSprite;
                renderer.sortingLayerName = startLayerName;
                gameObject.layer = 9;
                OnClosed?.Invoke();
            }
            GetComponent<PhysicalBehaviour>().RefreshOutline();
        }
        private void OnBeforeSerialise()
        {
            if (HasSpareWheel && !spareWheelJointBroken && Activated)
            {
                SpareWheelJoint.connectedBody.transform.parent = transform.parent;
                foreach (ObjectSerialisationHelper objectSerialisationHelper in transform.parent.GetComponents<ObjectSerialisationHelper>())
                {
                    if (objectSerialisationHelper.Object == SpareWheelJoint.connectedBody.gameObject)
                    {
                        objectSerialisationHelper.transformData = new TransformPrototype(SpareWheelJoint.connectedBody.transform.localPosition, SpareWheelJoint.connectedBody.transform.eulerAngles.z, SpareWheelJoint.connectedBody.transform.localScale);
                        objectSerialisationHelper.objectName = Utils.GetHierachyPath(SpareWheelJoint.connectedBody.transform);
                    }
                }
                SpareWheelJoint.connectedBody.transform.parent = transform;
            }
        }

        public bool Activated;
        public bool HasSpareWheel = true;
        public bool spareWheelJointBroken;
        [SkipSerialisation]
        public FixedJoint2D SpareWheelJoint;
        private SpriteRenderer renderer;
        private RandomCarTextureBehaviour randomCarTextures;
        [SkipSerialisation]
        public DoorSprites[] Textures = new DoorSprites[0];
        public UnityEvent OnClosed = new UnityEvent();
        private string startLayerName;
        public struct DoorSprites
        {
            public Sprite OpenSprite;
            public Sprite OpenSpriteWithWheel;
            public Sprite ClosedSprite;
        }
    }
    public class InsideBehaviour : MonoBehaviour
    {
        private void Start()
        {
            renderer = GetComponent<SpriteRenderer>();
            randomCarTextures = GetComponent<RandomCarTextureBehaviour>();
            randomCarTextures.OnAfterChange.AddListener(new UnityAction(UpdateInside));
            GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("toggleInside", () =>
            {
                if (!ShowInside)
                {
                    return "Show inside";
                }
                return "Hide inside";
            }, "Toggles inside", new UnityAction[1]
            {
                () =>
                {
                    ShowInside = !ShowInside;
                    UpdateInside();
                }
            }));
            UpdateInside();
        }
        public void UpdateInside()
        {
            if (SpritesWhenShowInside.Length == randomCarTextures.Textures.Length)
            {
                if (ShowInside)
                {
                    renderer.sprite = SpritesWhenShowInside[randomCarTextures.chosenIndex];
                    foreach (SpriteRenderer foregroundRenderer in ForegroundsRenderer)
                    {
                        foregroundRenderer.color = Color.clear;
                    }
                }
                else
                {
                    renderer.sprite = randomCarTextures.Textures[randomCarTextures.chosenIndex].Body;
                    foreach (SpriteRenderer foregroundRenderer in ForegroundsRenderer)
                    {
                        foregroundRenderer.color = Color.white;
                    }
                }
                OnToggleInside?.Invoke();
            }
        }

        public bool ShowInside;
        [SkipSerialisation]
        public SpriteRenderer[] ForegroundsRenderer = new SpriteRenderer[0];
        private SpriteRenderer renderer;
        private RandomCarTextureBehaviour randomCarTextures;
        [SkipSerialisation]
        public Sprite[] SpritesWhenShowInside = new Sprite[0];
        [SkipSerialisation]
        public UnityEvent OnToggleInside = new UnityEvent();
    }
}